#  Licensed Materials - Property of IBM
#  5724-M24
#  Copyright IBM Corporation 2009. All Rights Reserved.
#  US Government Users Restricted Rights - Use, duplication or disclosure
#  restricted by GSA ADP Schedule Contract with IBM Corp.
#

import os
import sys
import java
from java.io import ByteArrayOutputStream 

print "Staring installAndConfigurePortalIwidgetBusinessSpace"

serverName    = sys.argv[0]
nodeName      = sys.argv[1]
adminUsername = sys.argv[2]
adminPassword = sys.argv[3]
portalRoot	  = sys.argv[4]
singleServer  = sys.argv[5]
skipEndpoint  = sys.argv[6]
productKey    =	sys.argv[7]
restPrefix    = sys.argv[8]
appServerRoot = sys.argv[9]
widgetDir	  = sys.argv[10]
portalUsername = sys.argv[11]
portalPassword = sys.argv[12]
logsLocation   = sys.argv[13]

def checkReturnCode(statusCode, function):
	if(statusCode == "false"):
		failureMessage = "ERROR: " + function + " exited unsuccessfully with return value " + statusCode
		print failureMessage
		raise RuntimeError(failureMessage)
	else:
		print "SUCCESS: " + function, "exited successfully with return value", statusCode
		return

def updateRestPrefix(skipEndpoint, productKey, restPrefix):
	if skipEndpoint == "false":
		# WPS consists of WPS and WESB
		if productKey == "WPS":
			productsArray=["WPS", "WESB"]
		# WDPE consists of WPS, WBM, and WBSF
		elif productKey == "WDPE":
			productsArray=["WPS", "WESB","WBSF", "WBM"]
		# All other products just use the productKey
		else:
			productsArray=[productKey]
			
		for x in productsArray:
			#	updateRestPrefixInWidgetZip {-productKey WBM -restPrefix http://myHost:port}
			updateRestPrefixParams=["-productKey",x,"-restPrefix",restPrefix]
			print "\nRunning updateRestPrefixInWidgetZip with the following arguments"
			print updateRestPrefixParams
			checkReturnCode(AdminTask.updateRestPrefixInWidgetZip(updateRestPrefixParams), "updateRestPrefixInWidgetZip")
			AdminConfig.save()
	return

def installWidgetsOnPortal(serverName, nodeName, widgetDir, productKey, portalUsername, portalPassword):
	# installBusinessSpaceWidgetsOnPortal  {-serverName <WebSphere_Portal> -nodeName  <your_node> -widgets <widgets_dir>}
	if productKey == "WPS":
		widgetDirectories=[widgetDir.replace(productKey, "WPS"), widgetDir.replace(productKey, "WESB")]
	# WDPE consists of WPS, WBM, and WBSF
	elif productKey == "WDPE":
		widgetDirectories=[widgetDir.replace(productKey, "WPS"), widgetDir.replace(productKey, "WESB"), widgetDir.replace(productKey, "WBSF"), widgetDir.replace(productKey, "WBM")]
	# All other products used widgetdir as is
	else:
		widgetDirectories=[widgetDir]
	for y in widgetDirectories:
		print "\nRunning installBusinessSpaceWidgetsOnPortal with the following arguments"
		widgetInstallArgs=["-serverName",serverName,"-nodeName",nodeName,"-widgets",y, "-portalusername", portalUsername, "-portalpassword",portalPassword]
		widgetInstallArgsNoPwd=["-serverName",serverName,"-nodeName",nodeName,"-widgets",y, "-portalusername", portalUsername, "-portalpassword","******"]
		print widgetInstallArgsNoPwd
		checkReturnCode(AdminTask.installBusinessSpaceWidgetsOnPortal(widgetInstallArgs), "installBusinessSpaceWidgetsOnPortal")
		AdminConfig.save()
	return
try:
	if singleServer == "true":
		print "\nSingle server install option selected"
		
		#	getBusinessSpaceDeployStatusOnPortal {-serverName <WebSphere_Portal> -nodeName <your_node>}
		print "\nRunning getBusinessSpaceDeployStatusOnPortal with the following arguments"
		deployArgs=["-serverName",serverName,"-nodeName",nodeName]
		print deployArgs
		bspaceDeployStatus = AdminTask.getBusinessSpaceDeployStatusOnPortal(deployArgs)
		print "bspaceDeployStatus = ", bspaceDeployStatus
		
		if bspaceDeployStatus == "false":
			#	installBusinessSpaceOnPortal {-serverName <WebSphere_Portal> -nodeName <your_node> -user <wasadmin> -password <wasadmin> -portalRoot <path_to_PortalServer> }      
			installOptList=["-serverName",serverName,"-nodeName",nodeName,"-user",adminUsername,"-password",adminPassword, "-portalRoot",portalRoot]
			installOptListNoPwd=["-serverName",serverName,"-nodeName",nodeName,"-user",adminUsername,"-password","******", "-portalRoot",portalRoot]
			print "\nRunning installBusinessSpaceOnPortal with the following arguments"
			print installOptListNoPwd
			checkReturnCode(AdminTask.installBusinessSpaceOnPortal(installOptList), "installBusinessSpaceOnPortal")
			AdminConfig.save()
			
			updateRestPrefix(skipEndpoint, productKey, restPrefix)
				
			#	configureBusinessSpaceOnPortal {-serverName WebSphere_Portal  -nodeName CONFI}
			installOptList3=["-serverName",serverName,"-nodeName",nodeName, "-portalusername", portalUsername, "-portalpassword",portalPassword]
			installOptList3nopw=["-serverName",serverName,"-nodeName",nodeName, "-portalusername", portalUsername, "-portalpassword","******"]
			print "\nRunning configureBusinessSpaceOnPortal with the following arguments"
			print installOptList3nopw
			checkReturnCode(AdminTask.configureBusinessSpaceOnPortal (installOptList3), "configureBusinessSpaceOnPortal")
			AdminConfig.save()
		else:
			print "Business space is already installed"
			updateRestPrefix(skipEndpoint, productKey, restPrefix)
			installWidgetsOnPortal(serverName, nodeName, widgetDir, productKey, portalUsername, portalPassword)
	else:
		print "Skipping Business Space install and configure tasks due to cluster selection"
	print "Done deploying bspace iWidgets for portal "
except:    
	print "\nInstall and configure Failed"
	print "Error Type: ", sys.exc_info()[0]
	print "Error Message: ", sys.exc_info()[1]
	print "For more information see logs in :", logsLocation
	sys.exit(1)

	
