if(!dojo._hasResource["com.ibm.mm.builder.dialog.ACLReassignDialog"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dialog.ACLReassignDialog"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dialog.ACLReassignDialog");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");
/**
 * this class will create the access control reassign dialog
 */
dojo.declare("com.ibm.mm.builder.dialog.ACLReassignDialog", null, {

	aclReassignDialog:null,
	
	aclReassignRootDiv:null,
	
	constructor: function(){
		this.init();
	},
	
	init:function(){
		this.initACLReassignContent();
		var acrId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID() + "_accessControlReassign";
			
		var dialogWidth = (dojo.isIE)?"370px":"350px";
			
		this.aclReassignDialog = new com.ibm.mm.builder.widget.CustomDialog(
			{
				id: acrId,
				title: com.ibm.mm.builder.coreWidgetsStrings.I_ACL_CONFLICT_TITLE,
				nodeWidth: dialogWidth,
				containerBackgroundColor: "white",
				hasRightBottomResizer: false
			},
			this.aclReassignRootDiv
		);
	},
	
	initACLReassignContent:function(){
		
		this.maxLen = dojo.isIE ? 50 : 95;
		if (ibmConfig.fontSizeEnlarged && dojo.isSafari) {
			this.maxLen = dojo.isSafari < 4 ? 65 : 60;		
		}
		this.aclReassignRootDiv = document.createElement("div");
		
		var aclReassignContentDiv  = document.createElement("div");
		dojo.addClass(aclReassignContentDiv,"accessControlReassignDiv");
		
		var aclReassignTitleSpan = document.createElement("span");
		dojo.addClass(aclReassignTitleSpan,"accessControlReassignTitle");
		aclReassignTitleSpan.innerHTML= com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INFORMATION_1 + "<br/><br/>";
		aclReassignContentDiv.appendChild(aclReassignTitleSpan);
		
		
		var aclReassignConfirmSpan = document.createElement("span");
		dojo.addClass(aclReassignConfirmSpan,"accessControlReassignConfirm");
		aclReassignConfirmSpan.innerHTML="<br/>" + com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INFORMATION_2 + "<br/><br/>";
		aclReassignContentDiv.appendChild(aclReassignConfirmSpan);
		
		var aclReassignButtonDiv = document.createElement("div");
		dojo.addClass(aclReassignButtonDiv,"accessControlReassignBottomDiv");
		
		var htmlUtil = com.ibm.mm.builder.utils.htmlUtil;
		var aclReassignResignBtn = document.createElement("input");
		aclReassignResignBtn.setAttribute("type","button");
		aclReassignResignBtn.setAttribute("value",htmlUtil.getStrWithLimit(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_BTN,aclReassignResignBtn,this.maxLen));
		aclReassignResignBtn.setAttribute("title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_BTN);

		/* begin a11y fixes for truncated value */
		dojo.attr(aclReassignResignBtn,'role','button');
		dojo.attr(aclReassignResignBtn,'wai-role','button');
		dojo.attr(aclReassignResignBtn,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_BTN);	
		/* end a11y fixes for truncated value */
						
		dojo.addClass(aclReassignResignBtn,"lotusFormButton");
		dojo.addClass(aclReassignResignBtn,"lotusFormButtonReassign");
		
		//for a11y
		this._defaultFocus = aclReassignResignBtn;
		
		var aclReassignNoChangeBtn = document.createElement("input");
		aclReassignNoChangeBtn.setAttribute("type","button");
		aclReassignNoChangeBtn.setAttribute("value",htmlUtil.getStrWithLimit(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_NOT_CHANGE,aclReassignNoChangeBtn,this.maxLen));
		aclReassignNoChangeBtn.setAttribute("title",com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_NOT_CHANGE);
		
		/* some a11y fixes */
		dojo.attr(aclReassignNoChangeBtn,'role','button');
		dojo.attr(aclReassignNoChangeBtn,'wai-role','button');
		dojo.attr(aclReassignNoChangeBtn,'aria-label',com.ibm.mm.builder.coreWidgetsStrings.I_ACL_REASSIGN_NOT_CHANGE);	
				
		dojo.addClass(aclReassignNoChangeBtn,"lotusFormButton");
		dojo.addClass(aclReassignNoChangeBtn,"lotusFormButtonReassignNoChange");
		
		aclReassignButtonDiv.appendChild(aclReassignResignBtn);
		aclReassignButtonDiv.appendChild(aclReassignNoChangeBtn);
		aclReassignContentDiv.appendChild(aclReassignButtonDiv);
		
		this.aclReassignRootDiv.appendChild(aclReassignContentDiv);
		
		dojo.connect(aclReassignResignBtn, "onclick", this, "reassign");
		dojo.connect(aclReassignNoChangeBtn, "onclick", this, "noChange");
		
	},
	
	_getSource:function(perm){
		switch(perm){
			case "aclView":
				this.viewIsSource = true;
				return com.ibm.mm.builder.dnd.viewSource ;
			case "aclPersonal":
				this.personalizeIsSource = true;
				return com.ibm.mm.builder.dnd.personalizeSource;
			case "aclEdit":
				this.editIsSource = true;
				return com.ibm.mm.builder.dnd.editSource;
		}
	},
	reassign:function(){
		for(var i=0;i<this.aclReassignList.length;i++){
			var source = this._getSource(this.aclReassignList[i].perm);
			this.layout.transferNode(source,this.target,this.aclReassignList[i].id,null,false);
		}
		if(this.viewIsSource){
			dojo.publish("aclView");
			this.viewIsSource = false;
		}
		if(this.personalizeIsSource){
			dojo.publish("aclPersonalize");
			this.personalizeIsSource = false;
		}
		if(this.editIsSource){
			dojo.publish("aclEdit");
			this.editIsSource = false;
		}
		dojo.publish(com.ibm.mm.builder.eventTopics.UpdateAllPageControl);
		this.hide();
	},
	noChange:function(){
		this.hide();
	},
	/**
	 * show the access control reassign dialog
	 */
	show: function(layout,target,list){
		this.layout = layout;
		this.viewIsSource = false;
		//this.personalizeIsSource = false;
		this.editIsSource = false;
		this.target = target;	
		this.aclReassignList = list;
		
		var aclReassignListSpan = document.createElement("span");
		dojo.addClass(aclReassignListSpan,"accessControlReassignList");
		aclReassignListSpan.innerHTML=this._listToHtml(this.aclReassignList);
		
		
	
		var existingList = dojo.query(".accessControlReassignList",this.aclReassignDialog.domNode);
		if(!!existingList &existingList.length>0){
			dojo.destroy(existingList[0]);
		}

		var confirmButton = dojo.query(".accessControlReassignConfirm",this.aclReassignDialog.domNode)[0];
		confirmButton.parentNode.insertBefore(aclReassignListSpan,confirmButton);
		
		this.aclReassignDialog.show();
		
		//for a11y
		this._defaultFocus.focus();
	},

	/**
	 * hide the access control reassign dialog
	 */		
	hide: function(){		
		this.aclReassignDialog.hide();
	},
	_listToHtml:function(list){
		var content ="";
		for(var i=0;i<list.length;i++){
			var perm;
			switch(list[i].perm){
				case "aclView":
					perm=com.ibm.mm.builder.coreWidgetsStrings.I_ACL_PERMISSION_VIEW;
					break;
				case "aclPersonalize":
					perm="Personalize";//personalization is not supported in v1
					break;
				case "aclEdit":
					perm=com.ibm.mm.builder.coreWidgetsStrings.I_ACL_PERMISSION_EDIT;
					break;
				default:
					perm="";
			}
			
			var newItem = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_INFORMATION_HAS,[list[i].name,"<span class='accessControlReassignLevel'>" + perm + "</span>"," <span class='accessControlReassignHas' > "," </span>"]);
			content = content+ "<span>"+ newItem + "</span><br/>";
		}
		return content;
	}	
});

}
