if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SmallWidgetContextMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SmallWidgetContextMenu"] = true;
/**
 * @author Allen Liang(llcsdl@cn.ibm.com)
 */

dojo.provide("com.ibm.mm.builder.iwidget.SmallWidgetContextMenu");
dojo.require("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");
dojo.require("com.ibm.mm.catalog.hubUtil");
dojo.declare("com.ibm.mm.builder.iwidget.SmallWidgetContextMenu", com.ibm.mm.builder.widget.ShadowMenu, {

    offset_y: 3,
    category: null,
    leftClickToOpen: true,
    entryModel: null,
    entryId: "",
	myparent: null,
	widget: null,
	LOGGER: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.SmallWidgetContextMenu"),
    cwm: com.ibm.mm.builder.coreWidgetsMessages,
	
    postCreate: function(){
        this.inherited(arguments);
        //get entryModel 
		if (!this._isFromHub()) {
			var utils = com.ibm.mm.builder.utils;
			var toolboxUtil = utils.toolboxUtil;
			var _catModel = toolboxUtil.getCatalogModel();
			var cs = toolboxUtil.getCategories();
			var find = false;
			
			for (var i = 0; i < cs.length && i < 5 && !find; i++) {
				_categoryModel = _catModel.getCatalogEntryModel(cs[i]);
				var elemIterator = _categoryModel.iterator();
				elemIterator.setCursorPosition(0);
				while (elemIterator.hasNext()) {
					var entry = elemIterator.next();
					if (!entry) continue;
					if (entry.getID() == this.entryId) {
						find = true; // find the entryModel 
						this.entryModel = entry;
						break;
					}
				}
			}
		}
		if (null == this.entryModel) {
			return;
		}

		this.utils = com.ibm.mm.builder.utils;
        this.iwidgetUtil = this.utils.iwidgetUtil;
		
		if (!this._isFromHub()) {
			this.isTrusted = this.iwidgetUtil.isWidgetTrusted(this.entryModel.getID());
		} else {
			this.isTrusted = this.widget.map.sandbox_user == "true" ? false : true;
		};
		
        this.enablerUtil = this.utils.enablerUtil;
        this.htmlUtil = this.utils.htmlUtil;
        this.toolboxUtil = this.utils.toolboxUtil;
        this.eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    },
    canShowSandboxSeparator: function(){
		return this._isSandBoxEnabled()
    },
	
	_isFromHub : function() {
		return dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"])== "hub";	
	},
	
	_isSandBoxEnabled : function() {
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var sandboxEnabled = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.SANDBOXENABLED);
        return sandboxEnabled;	
	},
    
    canToggleSandbox: function(){	
		if (this._isOpenSocial()) return false;
			
		if (!this._isSandBoxEnabled()) return false;
		
		if (this._isFeed()) return false;
	
		
		if (this._isFromHub()) {				
			return this.widget.map.permission == "edit";	
		} else {
			var tu = com.ibm.mm.builder.utils.toolboxUtil;
			var wd = tu.getWidgetDefinition(this.entryId);	
	        return !this.iwidgetUtil.isDisabledSandboxWidget(this.entryId) && !this.iwidgetUtil.isSandboxWidget(this.entryId) && wd.confirmSetMetaData('sandbox_user', true);
		}		
    },
    
    canShowMarkAsTrustedSandBoxMenuItem: function(){
		
		if (this._isOpenSocial()) return false;
		
		if (!this._isSandBoxEnabled()) return false;
		
		if (this._isFeed()) return false; 
		
		if (this._isFromHub()){
			if (this.widget.map.sandbox_definition == "true") 
				return false;	
		} else {
			if (com.ibm.mm.builder.utils.iwidgetUtil.isSandboxWidget(this.entryId)) 
				return false;
		};
		
		if (this._isWidgetInSandboxDisableGroup(this.widget.map.definitionURL))
			return false;	
		
		if (this._isFromHub()) {
			var trusted = this.widget.map.sandbox_user == "true" ? false : true; 
			return !trusted;			
		} else {
			return !this.iwidgetUtil.isWidgetTrusted(this.entryModel.getID());	
		}
		
    },
    
    canShowMarkAsUntrustedSandBoxMenuItem: function(){	
		if (this._isOpenSocial()) return false;
			
		if (!this._isSandBoxEnabled()) return false;
		
		if (this._isFeed()) return false; 
		
		if (this._isFromHub()){
			if (this.widget.map.sandbox_definition == "true") 
				return false;	
		} else {
			if (com.ibm.mm.builder.utils.iwidgetUtil.isSandboxWidget(this.entryId)) 
				return false;
		};
		
		if (this._isWidgetInSandboxDisableGroup(this.widget.map.definitionURL))
			return false;		
		
		if (this._isFromHub()) {
			var trusted = this.widget.map.sandbox_user == "true" ? false : true; 
			return trusted;					
		} else {
			return this.iwidgetUtil.isWidgetTrusted(this.entryModel.getID());	
		}		
    },
	
	_isWidgetInSandboxDisableGroup: function(thisWidgetUrl) {
		var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		var disableWidgets= cs.getValue("com.ibm.mashups.sandbox.force.disable");	
		if (dojo.isArray(disableWidgets)) {
			for (var x in disableWidgets) {
				var widgetUrl = dojo.trim(disableWidgets[x]);
				if (thisWidgetUrl == widgetUrl) 
					return true;
			}	
		} else {
			return (thisWidgetUrl == disableWidgets);
		}
		return false;
	},
	
	_isFeed : function () {
		return this.widget.isFeed;
	},
	
	_isOpenSocial : function () {
		return this.widget.isOpenSocial;
	},
	
	canShowEmbedWidget: function() {
		return !this._isFeed(); 
		//return !(this._isFeed() || this._isOpenSocial());	
	},
	
	canEnableEmbedWidget: function() {
		return !(this._isFeed() || this._isOpenSocial());	
	},
    
    canRemove: function(){
		if (this._isFromHub()) {
			return this.widget.map.permission == "edit";
		} else {
			return this.toolboxUtil.getCatalogModel().confirmRemove(this.entryModel);
		}
    },
    
    needRemove: function(){
		if (this._isFromHub()) {
			return false;
		} else {
			return true;
		}
    },
    
    addWidget: function(){
		//this.eventService.broadcastEvent("com.ibm.mashups.builder.addWidget", this.entryId);
    },
	
	updateWidgetItemUI: function () {		
	},
    
    embedWidget: function(){

		
		if (this._isFromHub()) {
			com.ibm.mm.builder.utils.embedUtil.displayEmbedDialogForHubWidget(this.widget.map);
		} else  {
			var widgetType = this.enablerUtil.getNodeTitle(this.entryModel);
        	com.ibm.mm.builder.utils.embedUtil.displayEmbedDialog(this.entryId, "widget", widgetType);	
		}
		
    },
	
	_getCategories: function(){
			if (this.catalogEntries) { return this.catalogEntries; }
			this.catalogEntries = [];
			var cm = com.ibm.mashups.enabler.model.Factory.getCatalogCategoryModel(),
				rootNode = cm.getRoot().start(),
				iter = cm.getChildren(rootNode);
			while (iter.hasNext()) {
				this.catalogEntries.push(iter.next());
			}
			return this.catalogEntries;
	},
    
    removeWidgetDefinition: function(){
		if (this._isFromHub()) {

			var hubURL = this._getHubURL();
			dojo.xhrDelete({	         
	            url: hubURL,
				error: dojo.hitch(this, function(error, ioArgs){
		                console.log(error);
		        })          
	        });
			this.widget.destroyRecursive();
		
		} else {
			var _catModel = this.toolboxUtil.getCatalogModel();
			
			var myElement = null;
			var cwm = com.ibm.mm.builder.coreWidgetsMessages;
			var categories = this._getCategories();
			for (var i = 0; i < categories.length; i++) {
				var category = categories[i];
				var _entryModel = _catModel.getCatalogEntryModel(category);
				var myElement = _entryModel.find(this.entryId).start();
				if (myElement) {
					
					var menuTitle = this.enablerUtil.getNodeTitle(myElement)
					var warnInfo = this.htmlUtil.getSubstitute(cwm.I_TOOLBOX_DELETE_WARN_1, [menuTitle]);
					if (confirm(warnInfo)) {
						_entryModel.remove(this.entryId);
						_catModel.commit().start();
						this.toolboxUtil.getCatalogModel(true);
						this.widget.destroyRecursive();
					};
					break;
				}		
			}

		}
		
    },
    
    toggleMark: function(){
		
		if (this._isFromHub()) {
			var needMarkSandbox = this.widget.map.sandbox_user == "true" ? false : true; 
			this._changeWidgetTrustSetting(needMarkSandbox);
		}else{
			var needMarkSandbox = this.iwidgetUtil.toggleMarkedSandboxWidget(this.entryId);	
			this.widget.map.isTrusted = !needMarkSandbox;
			this.updateWidgetItemUI();
		}		
		
		this.destroyDescendants();
		this.opened = false;        
    },
	
	
	_getHubWidgetID: function () {
		var hubURL = this.widget.item.store.url;
 		var id = this.widget.map.id;
    	id = id.replace("urn:id:", "");	
		return id;			
	},
	
	_getHubURL: function () {
		var id = this._getHubWidgetID();
		var hubURL = this.widget.item.store.url;
		hubURL += "&id=" + id;
		return hubURL;
	},
	
//	_getHubPutURLForFeed: function () {
//		var id = this._getHubWidgetID();
//		var hubURL = this.widget.item.store.url;
//		hubURL = com.ibm.mm.catalog.hubUtil.getDefaultHubUrl() + hubURL.replace("/mashuphub","") + ".feed&id=" + id;
//		//hubURL = com.ibm.mm.catalog.hubUtil.getDefaultHubUrl() + "/atom?collection=widgets.iWidgetURL&id=" + id;
//		
//		return hubURL;
//	},
	
	_generateAtom: function (feed, needMarkSandbox) {		
		
		//change user permission to public.
		feed = feed.replace("<catalog:permission>edit</catalog:permission>", "<catalog:permission>public</catalog:permission>")
        
		if (!needMarkSandbox) {
			feed = feed.replace("<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"true\"></catalog:metadata>", 
				"<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"false\"></catalog:metadata>");
			return feed;
		}
		
		var sandbox_markup 
			= "  <catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"true\"></catalog:metadata>";
			  
		var meta_sandbox_markup 
			= "<catalog:objectmeta>\n" +
			   sandbox_markup + "\n" +
 			  "</catalog:objectmeta>";	
		
		//check if the feed passed is for feed or widget	  
		//isFeed = feed.indexOf("<catalog:feed") >= 0;
		isFeed = this._isFeed();
			 
		//add sandbox mark	  
		feed = feed.replace("<catalog:objectmeta/>", "");
		feed = feed.replace("<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"true\"></catalog:metadata>", "");
		feed = feed.replace("<catalog:metadata name=\"sandbox_user\" label=\"sandbox_user\" value=\"false\"></catalog:metadata>", "");

		var s1 = "";
		var inx = feed.indexOf("</catalog:objectmeta>");

		if (inx >= 0) {			
			s1 = feed.substring(0, inx);
			s1 += sandbox_markup;		
			s1 += feed.substring(inx)		
		} else {
			if (isFeed) {
				inx = feed.indexOf("</catalog:feed>");
			} else {
				inx = feed.indexOf("</catalog:widget>");
			}
			s1 = feed.substring(0, inx);
			s1 += meta_sandbox_markup;
			s1 += feed.substring(inx);				
		}
		
		return s1;
	},
	
	
	_changeWidgetTrustSetting: function (needMarkSandbox) {
		var hubURL = this._getHubURL();
		
		dojo.xhrGet({
			url: hubURL,
			load: dojo.hitch(this, function (feed, ioArgs) {
				dojo.xhrPut({
		            headers: { "Content-Type": "application/xml" },
		            url: hubURL,
		            load: dojo.hitch(this, function(data, ioArgs){
						if (needMarkSandbox) {
							this.widget.map.sandbox_user = "true";
							this.widget.map.isTrusted = false;
						}
						else {
							this.widget.map.sandbox_user = "false";
							this.widget.map.isTrusted = true;
						}
						this.updateWidgetItemUI();
						// The trust setting that you just marked applies to all subsequent users of this widget
						this.LOGGER.info("_changeWidgetTrustSetting",this.cwm.I_CONTENTSHELF_WIDGET_SANDBOX_0);
		            }),
		            error: dojo.hitch(this, function(error, ioArgs){
		                console.log(error);
		            }),
		            postData: this._generateAtom(feed, needMarkSandbox),
		            handleAs: "text"
		        });  
						
			}),
			error: dojo.hitch(this, function(error, ioArgs){
                console.log(error);
            })
		});		
		
	},
	
	
    prepareData: function(){        
	    try {
			
			var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
			var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.toolboxAction", this.entryId, null, {
	            context: this
	        });
	
	        for (var i = 0; i < widgetMenus.length; ++i) {
	            if (widgetMenus[i].isSeparator) {
	                this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator())
	                continue;
	            }
	            
				
				
	            this.addChild(new dijit.MenuItem({
	                label: widgetMenus[i].title,
	                iconClass: widgetMenus[i].iconClass,
	                disabled: !widgetMenus[i].enabled,
	                onClick: widgetMenus[i].actionCallBackFunction
	            }));
	        }
		} catch (e) {
			console.log(e)
		}
    },
	
	_clearMenu: function() {
		
		dojo.forEach(this.containerNode.childNodes,function(item){
			dojo.removeClass(item,"dijitMenuItemHover");
			dojo.removeClass(item,"dijitMenuItemSelected");
		});
		
		dojo.forEach(this.getChildren(), function(item){	
			this.removeChild(item);
			dijit.byId(item.id).destroy();
			item.destroyRecursive();		
			delete item;			
		},this);
		
		this._isMenuCreated = false;			
	},
	
	onClose: function () {

		this.inherited(arguments);		
		this._clearMenu();
	
		
		
	}
    
});

}
