if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SpaceSelector2"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SpaceSelector2"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.SpaceSelector2");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.mm.builder.Model");

dojo.require("com.ibm.mm.builder.utils.htmlUtil");
dojo.require("com.ibm.mm.builder.utils.layoutUtil");
dojo.require("com.ibm.mm.builder.utils.pageUtil");
dojo.require("com.ibm.mm.builder.utils.enablerUtil");
dojo.require("com.ibm.mm.builder.utils.spaceUtil");

dojo.require("com.ibm.mm.builder.widget.ShadowMenu");

(function(){
var maxLen = 190;
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var spaceUtil = utils.spaceUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cws = com.ibm.mm.builder.coreWidgetsStrings;

dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelector2",
	[dijit._Widget, dijit._Templated],{
	
	templateString: 
		'<ul class="lotusInlinelist lotusLinks">'+
			'<li dojoAttachPoint="containerNode1"><a dojoAttachPoint="containerNode" tabindex=0 dojoAttachEvent="onkeypress:_onSelectorKeyPress"></a></li>'+
		'</ul>',
	
	refresh: function(spaceId){
		this.uninitialize();
		var limitedTitle = htmlUtil.getStrWithLimit(spaceUtil.getSpaceTitle(spaceId), this.containerNode, maxLen);
		this.containerNode.innerHTML = limitedTitle;
		if (builderConfig.isBidi && (dojo.isIE === 6 || dojo.isIE === 8)) {
			var w = htmlUtil.getStrWidth(limitedTitle, this.containerNode);
			this.containerNode.style.width = w + "px";
		}
		this._createSpaceSelectorMenu();
	},
	
	_createSpaceSelectorMenu: function(){
		this.spaceSelectorMenu = new com.ibm.mm.builder.iwidget.SpaceSelectorMenu2({ 
			targetNodeIds: [this.containerNode1],
			disable_shadow: true 
		});
	},
	
	_onSelectorKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
				this.spaceSelectorMenu._openMyself(evt);
			break;
		}
	},
	
	uninitialize: function(){
		if (this.spaceSelectorMenu) {
			if(this.spaceSelectorMenu.isShowingNow){ dijit.popup.close(this.spaceSelectorMenu); }
			this.spaceSelectorMenu.destroyRecursive();
			this.spaceSelectorMenu = null;
		}
	}
});


dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelectorMenu2", com.ibm.mm.builder.widget.ShadowMenu, {
	
	leftClickToOpen: true,
	
	postCreate: function(){
		dojo.addClass(this.domNode, "lotusCommonActionMenu spaceSelectorMenu");
		this.inherited(arguments);
	},
	
	prepareData: function(){
		if (!userUtil.isLockedDownAnonymousMode()) {
			this.addChild(new com.ibm.mm.builder.iwidget.SpaceSelectorMenuItem2({
				label: cws.I_SPACE_MANAGE_SPACES,
				onClick: function(){
					var payload = {
						widgetTypeId: "spaceManager",
						eventName: "com.ibm.mashups.builder.showSpaceManager",
						eventPayload: "",
						dialogParam: {
							title: cws.I_SPACE_MANAGE_SPACES,
							nodeWidth: "910px",
							nodeHeight: "750px",
							containerBackgroundColor: "white",
							hasRightBottomResizer: false
						}
					};
					eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
				}
			}));
		}
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.spaceSelector", null, null, {
			context: this
		});
		for (var i = 0; i < widgetMenus.length; ++i) {
			var mitem = new com.ibm.mm.builder.iwidget.SpaceSelectorMenuItem2({
				label: spaceUtil.getPersonalSpaceTitle(),
				onClick: widgetMenus[i].actionCallBackFunction
			});
			this.addChild(mitem);
		}
		
		var spaceModel = spaceUtil.getSpaceModel();
		var spaceNodes = spaceModel;
		if (!userUtil.isLockedDownAnonymousMode()) {
			spaceNodes = spaceModel.findFavorites();
		}
		if(spaceNodes.hasNext()){
			this.addChild(new dijit.MenuSeparator());
		}
		var self = this;
		while (spaceNodes.hasNext()) {
			(function(){
				var node = spaceNodes.next();
				if (spaceUtil.isVisiable(node)) {
					var nodeId = node.getID();
					var rootNodeId = spaceModel.find(nodeId).start().getRootNavigation().getID();
					
					var label = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(node);
					var iconClass = "";
					if(nodeId === spaceUtil.getHomeSpaceId()){
						label = "<span class='access'>Home Space</span>" + label;
						iconClass = "homeSpaceMenuItemIcon";
					}
					var c = new com.ibm.mm.builder.iwidget.SpaceSelectorMenuItem2({
						label: label,
						iconClass: iconClass,
						onClick: function(){
							com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(function(){
								eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace", nodeId);
							});
						}
					});
					dojo.attr(c.domNode, "space_id", nodeId);
					self.addChild(c);
				}
			})();
		}
		
		if (!userUtil.isLockedDownAnonymousMode() && spaceUtil.getSpaceModel().confirmCreate()) {
			this.addChild(new dijit.MenuSeparator());
			this.addChild(new com.ibm.mm.builder.iwidget.SpaceSelectorMenuItem2({
				label: cws.I_SPACE_CREATE_NEW_SPACE,
				onClick: function(){
					var callbackFun = dojo.hitch(this,function(){
						var payload = {
							widgetTypeId: "createSpace",
							eventName: "com.ibm.mashups.builder.createSpace",
							eventPayload: {createSpaceFromSpaceManager:false},	
							dialogParam: {
								nodeWidth: "675px",
								title: cws.CREATE_SPACE_CAPTION,
								containerBackgroundColor: "white",
								hasRightBottomResizer: false
							}
						};
						eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
					});
					com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(callbackFun);
				}
			}));
		}
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
	},
	
	_onKeyPress: function(evt){
		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.keyCode){
			case dojo.keys.RIGHT_ARROW:
				this.onItemHover(this.focusedChild);
				break;
			case dojo.keys.LEFT_ARROW:
				if(this.parentMenu){
					this.onCancel(false);
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},
	
	switchToPersonalSpace: function(){
		eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace");
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelectorMenuItem2",dijit.MenuItem,{
	
	postCreate: function(){
        this.inherited(arguments);
        htmlUtil.markTruncation(this.containerNode, maxLen);
	}
});
})();

}
