if(!dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.columnUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.columnUtil"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");

dojo.require("dojo.number");
dojo.require("dojo.string");
dojo.require("dijit.form.Slider");
dojo.require("com.ibm.mm.builder.widget.CustomDialog");
dojo.require("com.ibm.mm.builder.dnd.ColumnSource");

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX = 0;
com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY = dojo.isIE < 8 ? -4 : 20;

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.getColNumberFromLayoutData = function(layoutdata) {
	var colPos = layoutdata.indexOf("column:");
	var valueStr = layoutdata.substr(colPos+7,layoutdata.length);
	var colValue = valueStr.substr(0,valueStr.indexOf(";"));
	return colValue;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.moveWidget = function(widgetId,targetColumn,targetRow,columnWidgetId){
    // widget span should have the attribute layoutdata, sample value: "layout:columnlayout;column:2;row:2;"
	var widgetSpan = dojo.byId(widgetId);
	var curWidgetLayoutData = widgetSpan.getAttribute("layoutdata");
	if (!curWidgetLayoutData) {
		return;
	}
	var targetCol = dojo.byId("_" + columnWidgetId + "_Column"+targetColumn);
	var targetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,targetCol);
	var len = targetColWidgets.length;
	var i=0;
	var layoutAttr,beforeNode;
	var movingNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetId);
	if (curWidgetLayoutData.indexOf("column:"+targetColumn)== -1){// target column is a different column
	
		//update the previous column widget layout data	
		var oldColumn = curWidgetLayoutData.substr(curWidgetLayoutData.indexOf("column:") + 7, 1);
		var oldRow = curWidgetLayoutData.substr(curWidgetLayoutData.indexOf("row:") + 4, 1);
		var oldTargetCol = dojo.byId("_" + columnWidgetId + "_Column"+oldColumn);
		var oldTargetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,oldTargetCol);
		var oldLen = oldTargetColWidgets.length;
		if(oldLen == 1 || oldRow == oldLen){
		   
		}else{
			for (i=oldRow;i<oldLen;i++){
				layoutAttr = oldTargetColWidgets[i].getAttribute("layoutdata");
				if (layoutAttr){
					var rowNum = layoutAttr.substr(layoutAttr.indexOf("row:") + 4,1);
					oldTargetColWidgets[i].setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(layoutAttr,rowNum - 1));					
				}
			}
		}
		
		// insert the iwidget instance
		if((len === 0) || (len +1 == targetRow)){
			targetCol.appendChild(movingNode);
		}else{
			beforeNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + targetColWidgets[targetRow - 1].id);
			targetCol.insertBefore(movingNode,beforeNode);
		}
		// update the previous widget layout data
		for (i=targetRow;i<=len;i++){
			layoutAttr = targetColWidgets[i-1].getAttribute("layoutdata");
			if (layoutAttr) {
				targetColWidgets[i-1].setAttribute("layoutdata", com.ibm.mm.builder.iwidget.columnlayout.columnUtil._increaseRow(layoutAttr));
			}
		}

		widgetSpan.setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getLayoutData(targetColumn,targetRow));
	}else{// target column is the same column
		// if the row is the same, do nothing
		if (curWidgetLayoutData.indexOf("row:"+targetRow) == -1){
			// update the upper widgets row number
			var count = 1;
			for (i=0;i<len;i++){
				if (targetColWidgets[i].id != widgetId) {
					layoutAttr = targetColWidgets[i].getAttribute("layoutdata");
					if (layoutAttr) {
						targetColWidgets[i].setAttribute("layoutdata", com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(layoutAttr, count));
						count = count + 1;
					}
				}
			}
			if((len === 0) || (len == targetRow)){
				targetCol.appendChild(movingNode);
			}else{
				beforeNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + targetColWidgets[targetRow - 1].id);
				targetCol.insertBefore(movingNode,beforeNode);
				// update the below widgets row number
				for (i=targetRow;i<=len-1;i++){
					layoutAttr = targetColWidgets[i-1].getAttribute("layoutdata");
					if (layoutAttr) {
						targetColWidgets[i - 1].setAttribute("layoutdata", com.ibm.mm.builder.iwidget.columnlayout.columnUtil._increaseRow(layoutAttr));
					}
				}				
			}
			widgetSpan.setAttribute("layoutdata",com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(curWidgetLayoutData,targetRow));
		}
	} 
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._increaseRow = function(layoutdata){
	var rowPos = layoutdata.indexOf("row:");
	var prefix = layoutdata.substr(0,rowPos);
	var suffix = layoutdata.substr(rowPos+4,layoutdata.length);
	var oldRowValue = parseInt(suffix,10);
	var newRow = oldRowValue + 1;
	return prefix + "row:" + newRow + ";";
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._decreaseRow = function(layoutdata){
	var rowPos = layoutdata.indexOf("row:");
	var prefix = layoutdata.substr(0,rowPos);
	var suffix = layoutdata.substr(rowPos+4,layoutdata.length);
	var oldRowValue = parseInt(suffix,10);
	var newRow = oldRowValue - 1;
	return prefix + "row:" + newRow + ";";
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow = function(layoutdata,row){
	var rowPos = layoutdata.indexOf("row:");
	var prefix;
	if(rowPos != -1){
	    prefix = layoutdata.substr(0,rowPos);
	}else{
		prefix = layoutdata + ";";
	}
	return prefix + "row:" + row + ";";
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getRow = function(layoutdata){
	var rowPos = layoutdata.indexOf("row:");
	if (rowPos != -1) {
		return parseInt(layoutdata.substr(rowPos + 4,layoutdata.length),10);
	}
	return -1;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getLayoutData = function(targetColumn,targetRow){
	return "layout:columnlayout;column:"+targetColumn+";row:"+targetRow+";";
};

// to refresh other widget layout data since current widget is to be removed, specifically for column layout
com.ibm.mm.builder.iwidget.columnlayout.columnUtil.refreshLayoutData = function(widgetId){
	var widgetSpan = dojo.byId(widgetId);
	var curWidgetLayoutData = widgetSpan.getAttribute("layoutdata");
	if (!curWidgetLayoutData) {
		return;
	}
	var col = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.getColNumberFromLayoutData(curWidgetLayoutData);
	var layoutId = null;
	var i=0;
	var layouts = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme().getLayouts();
	for(i = 0; i < layouts.length; i++) {
		if (com.ibm.mm.builder.utils.layoutUtil.widgetInLayout(widgetId,layouts[i])){
			layoutId =  layouts[i];
		}
    }
	if (layoutId){
		var colDiv = dojo.byId("_"+ layoutId + "_Column" + col);
		if (colDiv){
			var existingWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,colDiv);
			var row = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getRow(curWidgetLayoutData);
			if (row > 0){
				for (i=0;i<existingWidgets.length;i++){
					if (existingWidgets[i].id != widgetId){
						var existingWidgetLayoutdata = dojo.byId(existingWidgets[i].id).getAttribute("layoutdata");
						if (existingWidgetLayoutdata){
							if (com.ibm.mm.builder.iwidget.columnlayout.columnUtil._getRow(existingWidgetLayoutdata) > row){
								var newLayoutData = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._decreaseRow(existingWidgetLayoutdata);
								dojo.byId(existingWidgets[i].id).setAttribute("layoutdata",newLayoutData);
							}
						}

					}
				}
			}
		}
	}
};

/**
 * this method is called to change the view or edit mode of column width resizer
 * @param {String} mode "view" or "edit"
 */
com.ibm.mm.builder.iwidget.columnlayout.columnUtil._changeColumnResizerStatus = function(mode){
    var resizers = dijit.registry.byClass(com.ibm.mm.builder.widget.ColumnWidthResizer);
    var resizer_len = resizers.length;
    for (var x = 0; x < resizer_len; x++) {
        var oneResizer = resizers[x];
        if (mode == "view") {
            oneResizer.toViewMode();
        }
        else {
            oneResizer.toEditMode();
        }
    }
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createSkinConfigUI = function(skinDivId, wid){
    var skinConfig = dojo.byId(skinDivId);
    com.ibm.mm.builder.utils.layoutUtil.removeAllChildren(skinConfig);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
    if (skins.length > 0) {
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.skinObjects = [];
		dojo.forEach(skins, function(skin){
            var skinTitle = skin.getTitle(dojo.locale);
            if (ibmConfig["default.locale"] != dojo.locale && (null === skinTitle || "" == skinTitle)) {
                skinTitle = skin.getTitle(ibmConfig["default.locale"]);
            }
            if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
                com.ibm.mm.builder.iwidget.columnlayout.columnUtil.skinObjects.push(skin);
                var fathDiv = document.createElement("div");
                skinConfig.appendChild(fathDiv);
                dojo.addClass(fathDiv, "skinPreviewDiv");
                var funcName = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin(\"" + skin.getID() + "\",\"" + wid + "\")";
                var funcNameWithKey = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkinWithKey(event,\"" + skin.getID() + "\",\"" + wid + "\")";
                var inner = "<DIV align='center' id='" + wid + "_" + skin.getID();
                inner = inner + "' style='margin-top:4px;' onclick='";
                inner = inner + "eval(" + funcName + ");' onkeypress='";
                inner = inner + "eval(" + funcNameWithKey + ");'>";
                inner = inner + "<IMG tabindex='0' src='" + skin.getPreviewUrl() + "' title='" + skinTitle + "' alt='" + skinTitle + "' /></DIV>";
                fathDiv.innerHTML = inner;
            }
	    });
    } else {
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER.severe("createSkinConfigUI",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CHOOSE_SKIN_0);
    }
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkinWithKey = function(event, skinvalue, wid){
    var keyCode = event.keyCode;
    if (keyCode != dojo.keys.ENTER) {
		return true;
	}
    com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin(skinvalue, wid);
};

/**
 * chooseSkin is called when click the different skin type in configuration pane
 * @param {Object} skinvalue
 */
com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin = function(skinvalue, wid){
    com.ibm.mm.builder.columnLayoutBean.setSelectedSkin(skinvalue);
	var skins = com.ibm.mm.builder.utils.skinUtil.getAllSkins();
    if (skins.length > 0) {
		dojo.forEach(skins, function(skin){
	        if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
	            var skinUIDiv = dojo.byId(wid + "_" + skin.getID());
	            if (skinvalue == skin.getID()) {
	                skinUIDiv.parentNode.style.border = "1px solid";
	                skinUIDiv.parentNode.style.borderColor = "#739DD7";
	                skinUIDiv.parentNode.style.backgroundColor = "#BED2EE";
	            } else {
	                skinUIDiv.parentNode.style.border = "1px dotted";
	                skinUIDiv.parentNode.style.borderColor = "#F3F3F3";
	                skinUIDiv.parentNode.style.backgroundColor = "";
	            }
	        }
	    });
    } else {
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.LOGGER.severe("chooseSkin",com.ibm.mm.builder.coreWidgetsMessages.E_LAYOUT_UTIL_CHOOSE_SKIN_0);
    }
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._toShowColorPicker = function(iwid, wid, adjustX, adjustY, indicatorId, colorDivId){
    var indicatorX = dojo._abs(dojo.byId(iwid + indicatorId)).x;
    var indicatorY = dojo._abs(dojo.byId(iwid + indicatorId)).y;
    var relativeX = indicatorX - dojo._abs(dojo.byId(wid + "_edit")).x + parseInt(adjustX,10);
    var relativeY = indicatorY - dojo._abs(dojo.byId(wid + "_edit")).y + parseInt(adjustY,10);
    com.ibm.mm.builder.iwidget.columnlayout.columnUtil._showColorPalette(iwid, iwid + indicatorId, iwid + colorDivId, relativeX, relativeY);
};

/**
 * this method will show the color palette, by default the palete is "7x10"
 * @param {string} indicatorId: indicatorId is the indicator dom node id, which will display the user selected color
 * @param {string} inputId: inputId is the input dom id, which will hold the color value and save it back to server
 */
com.ibm.mm.builder.iwidget.columnlayout.columnUtil._showColorPalette = function(wid, indicatorId, inputId, posX, posY){
    var father = dojo.byId(wid + "ColorPaletteContainer");
    var indicator = dojo.byId(indicatorId);
    var colorPaletteX = posX;
    var colorPaletteY = posY;
    if (this.colorPicker !== null) {
        this.colorPicker.destroy();
        var colorPalette = document.createElement("div");
        colorPalette.id = wid + "ColorPalette";
        father.appendChild(colorPalette);
    }
    var palette = "8x16";
	if (dojo.version.major == 1 && dojo.version.minor == 4){
			// dojo 1.4
	    this.colorPicker = new com.ibm.mm.builder.widget.MumColorPalette14({
	        palette: palette,
	        indicator: indicatorId,
	        inputId: inputId
	    }, dojo.byId(wid + "ColorPalette"));		
	}else{
	    this.colorPicker = new com.ibm.mm.builder.widget.MumColorPalette({
	        palette: palette,
	        indicator: indicatorId,
	        inputId: inputId
	    }, dojo.byId(wid + "ColorPalette"));		
	}	

    var rtlColorPaletteAdjust = 0;
	if(builderConfig.isBidi){
	    var str = this.colorPicker._paletteDims[palette].width;
	    str=str.replace(/px/,"");
		//18 is size of preview color div box width + a pixel more for looks
	    rtlColorPaletteAdjust = new Number(str)-19;//JSLINT-IGNORE: deprecated code for mashups 3.0
	    //prevent dialog container from adding vertical scrollbar
	    var dialog = father.parentNode;
	    dialog = dialog.parentNode;
	    dialog.style.overflow="visible";	    
	}   
	father.style.left = colorPaletteX-rtlColorPaletteAdjust + "px";
    father.style.top = colorPaletteY + "px";
    father.style.zIndex = 888;
    father.style.display = "";
    this.colorPicker.focus();
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnSetting = function(icontext, columnNum, columnAttrJSONObj){
    var wid = "_" + icontext.widgetId + "_";
    dojo.byId(wid + "eachColCheckBox").innerHTML = "";
    dojo.byId(wid + "eachColumnBgColor").innerHTML = "";
    dojo.byId(wid + "eachColumnBgColorIndicator").innerHTML = "";
    dojo.byId(wid + "eachColumnBorderStyle").innerHTML = "";
    dojo.byId(wid + "eachColumnBorderColor").innerHTML = "";
    dojo.byId(wid + "eachColumnBorderColorIndicator").innerHTML = "";
    
    var eachCheckBoxStr = "";
    var eachColumnBgColorStr = "";
    var eachColumnBorderStyleStr = "";
    var checked, colorValue, bgcolor, borderColor, border;
    var indicatorDiv;
    for (var i = 1; i <= columnNum; i++) {
		var ii = i;
		if (builderConfig.isBidi) {
			ii = columnNum-i+1;
		}    	
        if (columnAttrJSONObj[ii].enabled == "1") {
            checked = "checked";
        }
        else {
            checked = "";
        }
        colorValue = columnAttrJSONObj[ii].bgcolor;
        borderColor = columnAttrJSONObj[ii].bordercolor;
        border = columnAttrJSONObj[ii].border;
        var inputTitle = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_COLOR;
        eachColumnBgColorStr = eachColumnBgColorStr +
        "<input type='hidden' id='" +
        wid +
        "eachColumnBgColor" +
        i +
        "' name='columnBgColor' value='" +
        colorValue +
        "'>";
        eachColumnBorderStyleStr = eachColumnBorderStyleStr +
        "<input type='hidden' id='" +
        wid +
        "eachColumnBorderColor" +
        i +
        "' name='columnBorderColor' value='" +
        borderColor +
        "'>";
        if (i > 1) {
            eachCheckBoxStr = eachCheckBoxStr +
            "<input id='" +
            wid +
            "eachColumnBgColorIndicator" +
            i +
            "_checkBox' type='checkbox'" +
            checked +
            " title=" +
            inputTitle +
            " style='display:none;'>";
            dojo.byId(wid + "eachColumnBgColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnColorIndicator(icontext.widgetId, "eachColumnBgColorIndicator" + i, "eachColumnBgColor" + i, colorValue, "none"));
            dojo.byId(wid + "eachColumnBorderStyle").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderStyleSelection(icontext.widgetId, "columnBorderSelection" + i, border, "none"));
            dojo.byId(wid + "eachColumnBorderColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createColumnBorderColorIndicator(icontext.widgetId, "columnBorderColorIndicator" + i, "eachColumnBorderColor" + i, borderColor, "none"));
        }
        else {
            eachCheckBoxStr = eachCheckBoxStr +
            "<input id='" +
            wid +
            "eachColumnBgColorIndicator" +
            i +
            "_checkBox' type='checkbox' " +
            checked +
            " title='" +
            inputTitle +
            "'>";
            
            dojo.byId(wid + "eachColumnBgColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnColorIndicator(icontext.widgetId, "eachColumnBgColorIndicator" + i, "eachColumnBgColor" + i, colorValue, ""));
            dojo.byId(wid + "eachColumnBorderStyle").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderStyleSelection(icontext.widgetId, "columnBorderSelection" + i, border, ""));
            dojo.byId(wid + "eachColumnBorderColorIndicator").appendChild(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createColumnBorderColorIndicator(icontext.widgetId, "columnBorderColorIndicator" + i, "eachColumnBorderColor" + i, borderColor, ""));
        }
        var eachColumnBorderColorIndicatorNode = dojo.byId(wid + "columnBorderColorIndicator" + i);
        var eachColumnBgColorIndicatorNode = dojo.byId(wid + "eachColumnBgColorIndicator" + i);
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(eachColumnBorderColorIndicatorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_COLUMN_BORDER_COLOR);
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(eachColumnBgColorIndicatorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_COLOR);
    }
    dojo.byId(wid + "eachColCheckBox").innerHTML = eachCheckBoxStr;
    dojo.byId(wid + "eachColumnBgColor").innerHTML = eachColumnBgColorStr;
    dojo.byId(wid + "eachColumnBorderColor").innerHTML = eachColumnBorderStyleStr;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderStyleSelection = function(widgetId, id, border, display){
    var select = document.createElement("select");
    dojo.attr(select, "title", com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_COLUMN_PROP_BORDER);
    var iwid = "_" + widgetId + "_";
    select.id = iwid + id;
    select.className = "eidtGridSelectorStyle";
    select.style.display = display;
    select.style.width = "110px";
    if (dojo.isIE) {
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("none"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px solid"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px solid"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px solid"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px dotted"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px dotted"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px dotted"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px double"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("6px double"));
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("9px double"));
    }
    else {
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("none"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px solid"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px solid"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px solid"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("1px dotted"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("2px dotted"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px dotted"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("3px double"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("6px double"), null);
        select.add(com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption("9px double"), null);
    }
    select.options[com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex(border)].selected = true;
    var index = 0;
    select.options[index++].innerHTML = com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_NONE;
    var widths = [1, 2, 3];
    var styles = [com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_SOLID, com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOTTED, com.ibm.mm.builder.coreWidgetsStrings.LAYOUT_BORDER_STYLE_DOUBLE];
    for (var i = 0; i < styles.length; i++) {
        for (var j = 0; j < widths.length; j++) {
            select.options[index++].innerHTML = widths[j] + "px " + styles[i];
        }
    }
    return select;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createBorderOption = function(val){
    var option = document.createElement("option");
    option.value = val;
    return option;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnColorIndicator = function(widgetId, id, colorDivId, bgcolor, display){
    var div = document.createElement("div");
    var iwid = "_" + widgetId + "_";
    div.id = iwid + id;
    var funName = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil._toShowColorPicker('" + iwid + "','";
    funName = funName + widgetId + "','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX+"','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY+"','";
    funName = funName + id + "','" + colorDivId + "')";
	dojo.connect(div,"onclick",null,function(){eval(funName);}); //JSLINT-IGNORE: deprecated code for mashups 3.0
	dojo.connect(div,"onkeypress",null,function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) {
			return true;
		}
        eval(funName);//JSLINT-IGNORE: deprecated code for mashups 3.0
    });
    div.className = "columnbgcolorpickerbox";
    div.style.backgroundColor = bgcolor;
    div.style.display = display;
    dojo.attr(div, "tabindex", "0");
    return div;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode = function(node,prefixTitle){
    var color = dojo.style(node, "backgroundColor");
    var titleSubstuite = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_COLOUR;
    var title;
    if (color.indexOf("rgb") != -1) {
        var rgb = color.substring(4, color.length - 1);
        var rgbArray = rgb.split(",");
        title = dojo.string.substitute(titleSubstuite, [rgbArray[0], rgbArray[1], rgbArray[2]]);
    }
    else {
        var inHexStr = color.substring(color.length - 6);
        var red = parseInt("0x" + inHexStr.substr(0, 2), 16);
        var green = parseInt("0x" + inHexStr.substr(2, 2), 16);
        var blue = parseInt("0x" + inHexStr.substr(4, 2), 16);
        title = dojo.string.substitute(titleSubstuite, [red, green, blue]);
    }
    if (prefixTitle.indexOf(":") == -1) {
		dojo.attr(node, "title", prefixTitle + ":" + title);
	}
	else{
		dojo.attr(node, "title", prefixTitle + title);
	}
};



com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createColumnBorderColorIndicator = function(widgetId, id, colorDivId, bgcolor, display){
    var div = document.createElement("div");
    var iwid = "_" + widgetId + "_";
    div.id = iwid + id;
    var funName = "com.ibm.mm.builder.iwidget.columnlayout.columnUtil._toShowColorPicker('" + iwid + "','";
    funName = funName + widgetId + "','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX+"','"+com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY+"','";
    funName = funName + id + "','" + colorDivId + "')";
    
	dojo.connect(div,"onclick",null,function(){
        var selectedColumn = dojo.byId(iwid + "columnConfigTargetSelection").value;
		if (dojo.byId(iwid + "columnBorderSelection" + selectedColumn).selectedIndex === 0) {
			return;
		}
		eval(funName);//JSLINT-IGNORE: deprecated code for mashups 3.0
    });
	dojo.connect(div,"onkeypress",null,function(event){
        var keyCode = event.keyCode;
        if (keyCode != dojo.keys.ENTER) {
			return true;
		}
        eval(funName);//JSLINT-IGNORE: deprecated code for mashups 3.0
    });
    div.className = "columnbordercolorpickerbox";
    div.style.backgroundColor = bgcolor;
    div.style.display = display;
    dojo.attr(div, "tabindex", "0");
    return div;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._isDefaultSetting = function(singleColSetting){
    var defaultsetting = com.ibm.mm.builder.columnLayoutBean.getSingleColumnDefaultSetting();
    if (singleColSetting) {
        if ((defaultsetting.bgcolor == singleColSetting.bgcolor) &&
        (defaultsetting.border == singleColSetting.border) &&
        (defaultsetting.bordercolor == singleColSetting.bordercolor) &&
        (defaultsetting.enabled == singleColSetting.enabled)) {
            return true;
        }
    }
    return false;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.validatePageMetaData = function(metadata){
    if (metadata.columnattributes && metadata.columns && metadata.pageattributes && metadata.skin) {
        var columnAttrObj = dojo.fromJson(metadata.columnattributes);
        var columnsObj = metadata.columns;
        var pageAttrObj = dojo.fromJson(metadata.pageattributes);
        var skin = metadata.skin;
        
        if (!pageAttrObj.applyDefaultSkinToAll) {
            var newObj = {};
            newObj.skin = skin;
            newObj.columns = columnsObj;
            
            var newPageAttrObj = {};
            newPageAttrObj = pageAttrObj;
            newPageAttrObj.applyDefaultSkinToAll = com.ibm.mm.builder.columnLayoutBean.getPageAttrSetting().applyDefaultSkinToAll;
            newObj.pageattributes = dojo.toJson(newPageAttrObj);
            
            var allColumn = columnAttrObj.all;
            if (!allColumn.enabled) {
                var newColumnAttrObj = {};
                newColumnAttrObj.all = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(allColumn);
                if (columnAttrObj.one) {
                    newColumnAttrObj[""+1] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj.one);
                }
                if (columnAttrObj.two) {
                    newColumnAttrObj[""+2] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj.two);
                }
                if (columnAttrObj.three) {
                    newColumnAttrObj[""+3] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj.three);
                }
                if (columnAttrObj.four) {
                    newColumnAttrObj[""+4] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert(columnAttrObj.four);
                }
                newObj.columnattributes = dojo.toJson(newColumnAttrObj);
            }
            return newObj;
        }
        else {
            return metadata;
        }
    }
	else {
		var defaultItemSet = new com.ibm.mm.builder.iwidget.columnlayout.defaultSettings();
		return dojo.mixin(metadata, {
			skin: defaultItemSet.getSelectedSkin(),
			columns: dojo.toJson(defaultItemSet.getColumnSetting()),
			columnattributes: dojo.toJson(defaultItemSet.getColumnAttrSetting()),
			pageattributes: dojo.toJson(dojo.mixin(defaultItemSet.getPageAttrSetting(), dojo.fromJson(metadata.pageattributes)))
		});
	}
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil._convert = function(oldFormat){
    var obj = {};
    obj.bgcolor = oldFormat.bgcolor;
    obj.border = oldFormat.border;
    obj.bordercolor = oldFormat.bordercolor;
    obj.enabled = "0";
    return obj;
};

com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createColumnSource = function(domNode, layout){
	return new com.ibm.mm.builder.dnd.ColumnSource(domNode,{
		layout: layout,
		creator: function(item, hint){
			if (hint === "avatar") {
				//create avatar
				var n = dojo.doc.createElement("div");
				n.id = dojo.dnd.getUniqueId();
				n.setAttribute("widgetId", item);
				n.className = "dojoDndItem";
				var widgetSkinNode = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + item);
				var node = widgetSkinNode.cloneNode(true);
				dojo.removeAttr(node, "id");	//to avoid duplicate node id
				com.ibm.mm.builder.utils.htmlUtil.removeIframe(node);
				node.style.width = domNode.style.width;
				node.style.position = "relative";
				node.style.top = "20px";
				node.style.left = "0";
				n.appendChild(node);
				return { node: n, data: item, type: ["iWidgetInstance"] };
			}
		}
	});
};

}
