if(!dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationPanel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.navigation.NavigationPanel"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");

dojo.require("com.ibm.mm.builder.widget.ExtendableShadowMenu");
dojo.require("com.ibm.mm.builder.dnd.IndicatorSource");

(function(){
var maxLen = 150;
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var navigationUtil = utils.navigationUtil;
var spaceUtil = utils.spaceUtil;
var themeUtil = utils.themeUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
/**
 * The default breadcrumb navigation
 * @version 2.0
 */
dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanel", 
	[dijit._Widget, dijit._Templated, dijit._Container],{
	
	templateString: '<ul class="navigationPanel" dojoAttachPoint="containerNode"></ul>',
	
	npItemShowNum: 4, //the max number of last navigation items to show; Others will hide in separator ...
	
	/**
	 * the iEvent handler for navigation iEvent: "refreshNavigation" 
	 * it will refresh page if necessary.
	 */
	refresh: function(pid, needSwitch){
		this._cleanup();
		
		var currentPageIdBeforeRefresh = pageUtil.getCurrentPageId();
		var locationBeforeRefresh = unescape(location.href);
		//build models and render
		var models = this._getNavigationModelArray(pid);
		
		if (!models) { //this means there is no any page
			//if the theme is different from default, load defautl theme.
			if (themeUtil.getCurrentSpaceThemeId() != themeUtil.getCurrentThemeId()) {
				pageUtil.setPageId();
				setTimeout(function(){
					window.location.reload();
				}, 10);
				return;
			}
			//prompt user to create a new page.
			var m = navigationUtil.getNavigationModel();
			var rootNode = navigationUtil.getNavigationRootNode(spaceUtil.getCurrentSpaceId());
			if (m.confirmCreate() && m.confirmInsert(null, rootNode, null) && !userUtil.isLockedDownAnonymousMode()) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.EmptyPagePanelItem());
			}
		} else {
			//reload theme if the page has new theme
			if (themeUtil.getThemeId() != themeUtil.getCurrentThemeId()) {
				var cpid = pageUtil.getCurrentPageId();
				pageUtil.setPageId(cpid);
				var redirectAddress = navigationUtil.getRedirectAddress();
				setTimeout(function(){
					//if only pid is changed, reload the page.
					//there are two conditions: 
					// 1) http://localhost:8080/mum/enabler#pid=1&
					// 2) http://localhost:8080/mum/enabler#    (this means no page before switch)
					if(redirectAddress === locationBeforeRefresh.replace(/pid=([^&]*)/, "pid=" + cpid) || 
						(locationBeforeRefresh.indexOf("pid=") < 0 && redirectAddress === locationBeforeRefresh.replace("#", "#pid="+cpid + "&"))){
						location.reload();
					}else{
						location.href = redirectAddress;
					}
				}, 10);
				return;
			}
			
			//if there is no page before refresh and new page is added, swith to new page
			if (!currentPageIdBeforeRefresh) {
				needSwitch = true;
			}
			
			// iterate all items in models and paint it
			var slashAdjust = 1;
			var _len = models.length;
			
			//if model's length reach the upper limit(here is npItemShowNum(4))
			//we will add NavPaneArrow widget(show as "...")
			if (_len > this.npItemShowNum) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavPaneArrow());
				slashAdjust = 2;
			}
			//adjust the begin item number in model
			var _begin = 0;
			if (_len > this.npItemShowNum) {
				_begin = _len - this.npItemShowNum;
			}
			
			//render the navigation items and slash
			for (var i = _begin; i < _len; i++) {
				var naviModel = models[i];
				var navPaneItem = new com.ibm.mm.builder.iwidget.navigation.NavigationPanelItem({
					navigationNode: naviModel
				});
				this.addChild(navPaneItem);
				if (i < _len - 1) {//slash between two NavPaneItem
					this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationPanelSeparator());
				}
			}
		}
		dojo.forEach(this.getChildren(), function(child){ child.startup(); });
		
		this._adjustWidthForBidiIE();
		
		pageUtil.updatePageTitle();
		
		setTimeout(function(){
			if(needSwitch){
				var pageId = pageUtil.getCurrentPageId();
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				pageUtil.setPageId(pageId);
				eventService.broadcastEvent("com.ibm.mashups.builder.pageSwitched", pageId);
			}
		}, 0);
	},
	
	_adjustWidthForBidiIE: function(){
		if ((builderConfig.isBidi && dojo.isIE)) {
			setTimeout(function(){
				var nav = dojo.query(".navigatorDiv")[0];
				if (nav){
					var piw = 0;
					dojo.query(".navigationPanelItem", nav).forEach(function(item){
						piw += dojo.coords(item, true).w;
					});
					dojo.query(".emptyPagePanelItem", nav).forEach(function(item){
						piw += dojo.coords(item, true).w;
					});
					var adjust = 5;//IE7 & IE6
					if (dojo.isIE === 8) { adjust = 30; }
					nav.style.width = piw + adjust + "px";					
				}
				if (builderConfig.isBidi && dojo.isIE === 8) {
					//use paddingRight to prevent Welcome Page and Space Selector overlap
					var navPan = dojo.query(".navigationPanel", nav)[0];
					if (navPan) { navPan.style.paddingRight = "30px"; }
				}
			}, 0);
		}
	},
	/**
	 * Init the Navigation's models array, so that the Navigation knows
	 * which item(s) it should render.
	 */
	render: function(pid) {
		this.refresh(pid, true);
	},
	
	_cleanup: function(){
		dojo.forEach(this.getChildren(), function(item){
			item.destroy();
		});
	},
	
	destroy: function(){
		this._cleanup();
		this.inherited(arguments);
	},
	/**
	 * Construct navigation model array according to parameter pid
	 * The array represents the data of navigation panel items.
	 * @param {String} pid: current page id. If it is not specified, get the current page id
	 * @return array of the models
	 */
	_getNavigationModelArray: function(pid) {
		//if parameter pid is null, used current page id;
		//if current page is null, try to find first page under root
		var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		pid = pid || currentPage.getID();
		if(!pid){
			var sid = spaceUtil.getCurrentSpaceId();
			pid = sid ? pageUtil.getFirstPageInSpace(sid) : pageUtil.getFirstRootPageId();
		}
		//if current page still is null, this means no page exists.
		if(!pid) { return null; }
		
		//update current page id and space id
		currentPage.setID(pid);
		var spaceId = spaceUtil.getSpaceIdByPageId(pid);
		if (spaceId !== spaceUtil.getCurrentSpaceId()) {
			spaceUtil.setSpaceId(spaceId);
		}
		//try to build model array
		var menuModelArrays = [];
		var navModel = navigationUtil.getNavigationModel();
		var currentModel = navModel.find(pid).start();
		var rootId = navigationUtil.getNavigationRootNodeId();
		var currentSpaceRootId = navigationUtil.getNavigationRootNodeId(spaceUtil.getCurrentSpaceId());
		//Loop to root to build the menuModelArrays array that holds all the models of the item that need to be rendered
		while(currentModel && currentModel.getID() !== rootId && currentModel.getID() !== currentSpaceRootId) {
			menuModelArrays.push(currentModel);
			currentModel = navModel.getParent(currentModel.getID()).start();
		}
		if(menuModelArrays.length === 0){ return null; } //means no any page under root
		return menuModelArrays.reverse();
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanelItem",
	[dijit._Widget, dijit._Templated, dijit._Contained],
{
	/**
	 * current page model
	 */
	navigationNode: null,
	
	/**
	 * current menu object stored for reuse
	 */
	pageMenu:null,
	
	templateString: 
		'<li dojoAttachEvent="onmouseover:_onHover,onmouseout:_onUnHover,onkeypress:_onKeyPress,onclick: _onClick">'+
			'<div dojoAttachPoint="containerNode" class="navigationPanelItem">'+
				'<div dojoAttachPoint="titleNode" tabindex="0" class="navigationPanelItemLabel truncatedLabel" widthLimit="150"></div>'+
			'</div> '+
		'</li>',

	postCreate: function(){
		var node = this.titleNode;
		var title = pageUtil.getPageTitle(this.navigationNode);
		setTimeout(function(){ //set timeout to make sure the class is applied on the node
			node.innerHTML = title;
			htmlUtil.truncateNodeText(node);
			if ((builderConfig.isBidi && dojo.isIE) || (dojo.isIE === 6)) {
				var w = htmlUtil.getStrWidth(node.innerHTML, node);
				node.style.width = w + "px";
			}
		},0);
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
				this.renderMenu(evt);
			break;
		}
	},
	
	onFocus:function(){
		dojo.addClass(this.containerNode, "navigationPanelItemHover");
		this.focus();
	},
	
	onBlur:function(){
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "navigationPanelItemHover");
		}
	},
	
	focus: function(){
		try{
			dijit.focus(this.domNode);
		}catch(e){} // this throws on IE (at least) in some scenarios
	},
	
	_onHover: function(evt){
		dojo.addClass(this.containerNode, "navigationPanelItemHover");
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){ this.focus(); }
	},
	
	_onUnHover: function(evt){
		if(!this.pageMenu || (this.pageMenu && !this.pageMenu.isShowingNow)){
			dojo.removeClass(this.containerNode, "navigationPanelItemHover");
		}
	},
	
	renderMenu: function(evt){
		//the page id should be the parent id of the current item.
		this.pageMenu = this.pageMenu || new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({
			targetNodeIds: [this.containerNode],
			siblingPageId: this.navigationNode.getID(),
			parentPanelItem: this
		});
		
		this.pageMenu._openMyself(evt);
	},
	
	_onClick: function(evt){
		this.renderMenu(evt);
	},
	
	uninitialize: function(){
		if (this.pageMenu) {
			if(this.pageMenu.isShowingNow){
				dijit.popup.close(this.pageMenu);
			}
			this.pageMenu.destroyRecursive();
			delete this.pageMenu;
			this.pageMenu = null;
		}
		this.inherited(arguments);
	}
});

/**
 * A slash line between two page items
 */
dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationPanelSeparator",
	[dijit._Widget, dijit._Templated, dijit._Contained], {

	templateString: '<li><span class="navigationPanelSeparator">/</span></li>',

	postCreate: function(){
		dojo.setSelectable(this.domNode, false);
	},
	
	isFocusable: function(){
		// summary: over ride to always return false
		return false;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavPaneArrow",
	[dijit._Widget, dijit._Templated, dijit._Contained], {
	
	templateString: '<li><div class="NavPaneArrow">...</div></li>'
	
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.EmptyPagePanelItem",
	[dijit._Widget, dijit._Templated, dijit._Contained], {

	templateString:
		'<li dojoAttachEvent="onclick:_showInput,onkeydown:_enterToShowInput" tabindex="0" class="emptyPagePanelItem">'+
			'<span dojoAttachPoint="pageTitleLabel" class="emptyPagePanleLabel truncatedLabel" widthLimit="200"></span>'+
			'<label dojoAttachPoint="realPageTitleLabel" for="${id}_input" style="display: none"></label>'+
			'<input id="${id}_input" dojoAttachPoint="pageTitleInput" dojoAttachEvent="onkeydown:_onKeyPress,onblur:_onBlur"/>'+
		'</li>',
	
	postCreate: function(){
		this._hideInput();
		htmlUtil.truncateNodeText(this.pageTitleLabel);
		dojo.attr(this.realPageTitleLabel,'innerHTML',com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE);
	},
	
	_enterToShowInput: function(evt){
		if(evt.keyCode === dojo.keys.ENTER){
			this._showInput();
		}
	},
	
	_showInput: function(evt){
		this.pageTitleLabel.style.display = "none";
		this.pageTitleInput.style.display = "";
		this.pageTitleInput.focus();
	},
	
	_hideInput: function(){
		this.pageTitleLabel.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE;
		this.pageTitleLabel.style.display = "";
		this.pageTitleInput.style.display = "none";
	},
	
	_onKeyPress: function(evt){
		switch(evt.keyCode){
			case dojo.keys.ENTER:
				var name = this.pageTitleInput.value;
				if (!pageUtil.validatePageName(name)) {	return;	}
				name = dojo.trim(name);
				pageUtil.createPage(name);
				dojo.stopEvent(evt);
				break;
			case dojo.keys.ESCAPE:
				this._hideInput();
				dijit.focus(this.domNode);
				dojo.stopEvent(evt);
				break;
		}
	},
	
	_onBlur: function(evt){
		if(!this.pageTitleInput.value){ this._hideInput(); }
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenu", com.ibm.mm.builder.widget.ExtendableShadowMenu ,{

	siblingPageId: null,
	
	parentPageId: null,
	
	parentPanelItem: null,
	
	offset_x: -1,
	
	popupDelay: 250,
	
	postCreate: function(){
		this.limitedSize = com.ibm.mm.builder.constant.NavigationPageSize;
		this.inherited(arguments);
		dojo.addClass(this.domNode, "navigationMenu");
		var navMenu = this;
		var pNodeId = this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
		
		if (this.dndDisable) { return; }
		
		if (userUtil.isLockedDownAnonymousMode()) { return; }
		this.dndSource = new com.ibm.mm.builder.dnd.IndicatorSource(this.domNode, {
			
			accept: ["navigationPage"],
			
			creator: function(item, hint){
				if(hint === "avatar"){
					var selectedNode = dojo.query("tr[dnddata='"+item+"']")[0];
					var tbody = selectedNode.parentNode.cloneNode(false);
					var n = selectedNode.parentNode.parentNode.cloneNode(false);
					tbody.appendChild(selectedNode.cloneNode(true));
					n.appendChild(tbody);
					return { node: n, data: item, type: ["navigationPage"] };
				}
				return {
					node: navMenu.createNewItem(pageUtil.getPageNode(item)).domNode,
					data: item,
					type: ["navigationPage"]
				};
			},
			
			onDndCancel: function(){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndCancel.call(this);
				dojo.forEach(navMenu.getChildren(), function(c){
					if (c.declaredClass === "dijit.PopupMenuItem") { c.setDisabled(false); }
				});
				this.hoveredPageId = "";
			},
			
			onDndStart: function(source, nodes, copy){
				if (this === source) {
					var node = dijit.byId(nodes[0].id);
					if (node && node.popup) {
						node.popup._stopPopupTimer();
						if (node.popup.isShowingNow) {
							//bug 11434, not sure why safari will close all menu when close popup.
							//timer can solve such issue.
							window.setTimeout(function(){
								dijit.popup.close(node.popup);
							}, 500);
						}
						node.setDisabled(true);
					}
				}
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndStart.call(this, source, nodes, copy);
			},
			
			onDropExternal: function(source, nodes, copy){ //this means to parent or child
				if (!navMenu.isShowingNow || !this.hoveredPageId || !this.dropIndicator) { return; }
				dijit.popup.close(navMenu._getTopMenu());
				var draggedNodeId = nodes[0].getAttribute("dnddata");
				var hoveredPageId = this.hoveredPageId;
				var position = (this.hoveredNewPage) ? "children" : ((this.before) ? "previous" : "next");
				//put the heavy operation later after dnd cancel
				setTimeout(function(){
					navigationUtil.reorderPageNode(draggedNodeId, hoveredPageId, position);
				}, 0);
			},
			
			onDropInternal: function(nodes, copy){ //this means reorder
				if (!navMenu.isShowingNow || !this.dropIndicator) { return; }
				dijit.popup.close(navMenu._getTopMenu());
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDropInternal.call(this, nodes, copy);
				var draggedNodeId = nodes[0].getAttribute("dnddata");
				var hoveredPageId = this.hoveredPageId;
				var position = (this.before) ? "previous" : "next";
				//put the heavy operation later after dnd cancel
				setTimeout(function(){
					navigationUtil.reorderPageNode(draggedNodeId, hoveredPageId, position);
				}, 0);
			},
			
			/* fix the bug 11434
			 * The menu focus behavior is incorrect in some specified dnd operation such as
			 * dragging too fast so that the mouse hovers the avatar etc. 
			 */
			onDndSourceOver: function(source){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.onDndSourceOver.call(this, source);
				if (!navMenu.isActive) { navMenu._onFocus(); }
			},
			
			removeIndicator: function(){
				if (this.dropIndicator) {
					navMenu.removeChild(this.dropIndicator);
					this.dropIndicator = null;
				}
				if (navMenu.shadow && navMenu.isShowingNow) { navMenu.shadow.resize(); }
			},
			//todo simply this method
			createIndicator: function(e){
				com.ibm.mm.builder.dnd.IndicatorSource.prototype.createIndicator.call(this, e);
				var hoveredNode = e.target.parentNode;
				if(!hoveredNode){ this.removeIndicator(); return; }
				var menuChildren = navMenu.getChildren();
				if(menuChildren.length === 3 && menuChildren[2].declaredClass == "com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem"){
					this.hoveredPageId = navMenu.parentPageId;
					this.hoveredNewPage = true;
					if (!this.dropIndicator) { this.insertIndicator(1); }
					return;
				}else if(menuChildren.length === 4 && menuChildren[1] === this.dropIndicator && 
					menuChildren[3].declaredClass == "com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem"){
					return;
				} else {
					this.hoveredPageId = hoveredNode.getAttribute("dnddata");
					if(!this.hoveredPageId){ this.removeIndicator(); return; }
				}
				this.hoveredNewPage = false;
				
				//should not insert the same position
				var draggedPageId = this.getSelectedNodes() && this.getSelectedNodes()[0] && this.getSelectedNodes()[0].getAttribute("dnddata");
				if(this.hoveredPageId === draggedPageId){ this.removeIndicator(); return; }
				
				//if previous/next page is the dragged page, should void to create indicator
				if((this.before && hoveredNode.previousSibling && hoveredNode.previousSibling.getAttribute("dnddata") === draggedPageId) ||
					(!this.before && hoveredNode.nextSibling && hoveredNode.nextSibling.getAttribute("dnddata") === draggedPageId)) {
					this.removeIndicator(); return;
				}
				//if the dragged page can't insert into current menu, the indicator will not be created.
				var navigationModel = navigationUtil.getNavigationModel();
				var page = pageUtil.getPageNode(draggedPageId);
				var parentPage = pageUtil.getPageNode(navMenu._getParentPageId());
				try {
					if (!navigationModel.confirmInsert(page, parentPage)) { return; }
				} catch (err) {
					console.log(draggedPageId, navMenu._getParentPageId());
					console.error(err);
				}
				
				var insertIndex =  navMenu.getIndexOfChild(dijit.byId(hoveredNode.id)) + ((this.before) ? 0 : 1);
				this.insertIndicator(insertIndex);
			},
			
			insertIndicator: function(insertIndex){
				this.dropIndicator = this.dropIndicator || new com.ibm.mm.builder.iwidget.navigation.NavigationMenuDNDIndicator();
				navMenu.addChild(this.dropIndicator, insertIndex);
				if(navMenu.shadow){ navMenu.shadow.resize(); }
			}
		});
		//the new source created during dragging need to init the state.
		if(dojo.dnd.manager().source && dojo.dnd.manager().source.isDragging){
			this.dndSource.isDragging = true;
		}
	},
	
	//change the dijit.Menu's default behaviour(onClick) to onItemHover when the popup menu should be shown by key
	_onKeyPress: function(evt){
		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.keyCode){
			case dojo.keys.RIGHT_ARROW:
				this.onItemHover(this.focusedChild);
				break;
			case dojo.keys.LEFT_ARROW:
				if(this.parentMenu){
					this.onCancel(false);
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},
	
	_onPageItemClick: function(pageId){
		dijit.popup.close(this._getTopMenu());
		
		setTimeout(function(){
			if (com.ibm.mm.builder.TabbedNavigationDelegate){
				// clear the global page in tabbed navigation
				com.ibm.mm.builder.TabbedNavigationDelegate.onClearGlobalPage();
			}else{
				// clear the global page in other navigations
				dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null, {expires: -1});
			}
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage", pageId);
		}, 0);
	},
	
	prepareData: function(){
		var pages;
        if (this.siblingPageId) {
		    pages = pageUtil.getSiblingPages(this.siblingPageId);
		} else if (this.parentPageId) {
		    pages = pageUtil.getChildPages(this.parentPageId);
        }
        if (!this.confirmInsert) {
            var pNodeId = this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
            this.confirmInsert = navigationUtil.getNavigationModel().confirmInsert(null, pageUtil.getPageNode(pNodeId), null);
        }
		var canCreatePage = navigationUtil.getNavigationModel().confirmCreate() && this.confirmInsert && !userUtil.isLockedDownAnonymousMode();
		
		if (pages) {
			var self = this;
			while (pages.hasNext()) {
				if (self.loadedEntriesNumber >= com.ibm.mm.builder.constant.NavigationPageSize) {
					self.hasMorePage = true;
					self.isLastItemShowed = false;
					break;
				}
				var node = pages.next();
				if (com.ibm.mm.builder.utils.pageUtil.isVisiable(node)) {
					this.addChild(this.createNewItem(node));
					this.loadedEntriesNumber++;
				}
			}
			
			if (this.loadedEntriesNumber > 0 && canCreatePage) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
			}
		}
		if(canCreatePage){
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem({
				parentPageId: this._getParentPageId()
			}));
		}
		
		this.pages = pages;
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
		
		//make sure the current panel item is highlighted when the page is openning.
		if(this.parentPanelItem && this.parentPanelItem.containerNode){
			dojo.addClass(this.parentPanelItem.containerNode, "navigationPanelItemHover");
		}
	},
	
	_getParentPageId: function(){
		return this.parentPageId || pageUtil.getParentPageId(this.siblingPageId);
	},
	
	createNewItem: function(page){
		var pageId = page.getID();
		var newChild = new dijit.PopupMenuItem({
			label: pageUtil.getPageTitle(pageId),
			popup: new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({ parentPageId: pageId }),
			postCreate:function(){
				dijit.PopupMenuItem.prototype.postCreate.call(this);
				htmlUtil.markTruncation(this.containerNode,"153");
			},
			_onClick: dojo.hitch(this, "_onPageItemClick", pageId)
		});
		
		newChild.domNode.setAttribute("dndtype", "navigationPage");
		newChild.domNode.setAttribute("dnddata", pageId);
		dojo.query(".dijitMenuArrowCell",newChild.domNode)[0].style.display = "none";
		
		dojo.addClass(newChild.domNode, "dojoDndItem");
		return newChild;
	},
	
	onClose: function(){
		this.inherited(arguments);
		if(this.parentPanelItem && this.parentPanelItem.containerNode){
			dojo.removeClass(this.parentPanelItem.containerNode, "navigationPanelItemHover");
		}
	},
	
	uninitialize: function(){
		if (this.dndSource) {
			this.dndSource.destroy();
		}
		this.parentPanelItem = null;
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NewPageMenuItem", dijit.MenuItem, {
	
	//newPageMenuItemTd is add for automation test.
	templateString:
		'<tr class="dijitReset dijitMenuItem newPageMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"' +
			'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,onclick:_onClick,onkeypress:_onKeyPressMenuItem">' +
			'<td class="dijitReset newPageMenuItemTd" dojoAttachPoint="containerNode" colspan="4">' +
				'<label dojoAttachPoint="realPageTitleLabel" for="${id}_input" style="display: none"></label>'+
				'<input type="text" dojoAttachPoint="input" id="${id}_input" style="display:none"' +
					'dojoAttachEvent="onkeypress:_onKeyPress,onfocus:_onfocus, onblur:_onblur" ></input>' +
				'<div dojoAttachPoint="textNode" class="dijitMenuItemLabel truncatedLabel" widthLimit="153"></div>' +
			'</td>'+
		'</tr>',

	parentPageId: null,
	
	postCreate: function(){
		this.inherited(arguments);
		//make sure that user can click mouse to move the caret
		dojo.setSelectable(this.domNode, true);
		
		var label = com.ibm.mm.builder.coreWidgetsStrings.I_NAVIGATION_NEW_PAGE;
		this.input.title = label;
		this.textNode.innerHTML = label;
		this.textNode.title = label;
		dojo.attr(this.realPageTitleLabel,'innerHTML',label);
	},
	
	//reactive the default key event by clearing the parent's function used to prevent the default key event. 
	//todo, if there is mem leak, try to use dojo.connect to fix
	_onfocus: function(){
		this.parentPreviousKeyPress = this.getParent()._onKeyPress;
		this.getParent()._onKeyPress = function(evt){};
	},
	
	_onblur: function(){
		this.getParent()._onKeyPress = this.parentPreviousKeyPress;
	},
	
	_onKeyPressMenuItem:function(e){
		if (e.keyCode === dojo.keys.ENTER) { this._onClick(e); }
	},
	_onClick: function(evt){
		this.textNode.style.display = "none";
		this.input.style.display = "";
		this.input.focus();
		this._resizeShadow();
	},
	
	_onKeyPress: function(evt){
        switch (evt.keyCode) {
            case dojo.keys.ENTER:
				var newPageName = this.input.value;
				if (!pageUtil.validatePageName(newPageName)) {
		            return;
		        }
				newPageName = dojo.trim(newPageName);
		
				dijit.popup.close(this.getParent()._getTopMenu());
				dojo.stopEvent(evt);
				
            	this._createNewPage(newPageName);
                break;
				
            case dojo.keys.ESCAPE:
				this._restore();
                dojo.stopEvent(evt);
                break;
        }
	},
	
	_restore: function(){
		this.input.style.display = "none";
		this.input.value = "";
		this.textNode.style.display = "";
		this._resizeShadow();
	},
	
	_createNewPage: function(newPageName){
		var cancelcb = dojo.hitch(this, function(){
			this._restore();
		});
		
		var cb = dojo.hitch(this, function(){
			pageUtil.createPage(newPageName,this.parentPageId, cancelcb);
		});
		
		com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(cb, cancelcb);
	},
	
	//have to do this..
	_resizeShadow: function(){
		var shadow = this.getParent().shadow;
		if (shadow) { shadow.resize(); }
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator", dijit.MenuSeparator, {
	
	templateString: '<tr class="dijitMenuSeparator"><td colspan=4><div class="dijitNewMenuSeparator"></div></td></tr>'
	
});

dojo.declare("com.ibm.mm.builder.iwidget.navigation.NavigationMenuDNDIndicator", dijit.MenuSeparator, {
	
	templateString: '<tr class="NavigationMenuDNDIndicator"><td colspan=4><div class="NavigationMenuDNDIndicatorInstance"></div></td></tr>'
	
});

})();

}
