if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringModel"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringModel"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringModel");
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.SelectedModel");


/**
 * The Wiring model, contains an model array represent all the widgets data and their relationships
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringModel", null, {

    constructor: function(selectedWidgetId){
		
		var pageID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		this.navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
    	var currentPage = this.navModel.find(pageID).start(); 
		this.layoutModel = this.navModel.getLayoutModel(currentPage);
		this.widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
		var selectedLc = this.layoutModel.find(selectedWidgetId).start();
		
		this.selectedWindowId = this.widgetModel.getWidgetWindow(selectedLc).start().getID();
        this.selectedWidgetId = selectedWidgetId;
		var themeModel = null;
	 	themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
		this.layouts = themeModel.getLayouts();

        this.wiringModel = [];
        this.root = null;
        this.selectedRoot = [];
        this.notRootWidgets = [];
        this.rootArray = [];
        
    },
    
    setupWiringModel: function(){
        this.setupInitialData();
        //this._setupRootArray();
        this._setupModel();
    },
    
	setupWidgetWindowMap: function() {
		var lmRoot = this.layoutModel.getRoot().start();	
		if (this.layoutModel.hasChildren(lmRoot)) {
			var iterator = this.layoutModel.getChildren(lmRoot);
			iterator.setCursorPosition(0);
			while (iterator.hasNext()) {
				// it is com.ibm.mm.enabler.layout.LayoutContainerImpl
				var node = iterator.next();
				var _iterator = this.layoutModel.getChildren(node);
				 _iterator.setCursorPosition(0);
				// iterate through the children
				while (_iterator.hasNext()) {
					// it is com.ibm.mm.enabler.layout.LayoutControlImpl
					var childNode = _iterator.next();
					if (childNode instanceof (com.ibm.mashups.enabler.layout.LayoutControl)) {
						var lcID = childNode.getID();
						var widgetWindow = this.widgetModel.getWidgetWindow(childNode).start();
						var windowID = widgetWindow.getID();
						this.widgetWindowMap[windowID] = lcID;
					}
				}
			}
		}
	},
	
    setupInitialData: function(){
        this.eventsMap = {};
		this.widgetWindowMap = {};
		var incomingWires = null;
		var eventTargetObject = {};
		var handleEvent = null;
		var incomingWire = null;

		this.setupWidgetWindowMap();
					
		// get current page
		var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var currentPID = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();	
	    var currentPage = navModel.find(currentPID).start(); 
		var lm = navModel.getLayoutModel(currentPage);	  
  	    var lc = lm.find(this.selectedWidgetId).start();
																				
        incomingWires = com.ibm.mm.builder.utils.wireUtil.getWiresTargetCSA2(lc, currentPID);
		eventTargetObject[this.selectedWidgetId] = this.selectedWidgetId;
        
        for (var n = 0; n < incomingWires.length; n++) {
            incomingWire = incomingWires[n];
            handleEvent = {};
            handleEvent[incomingWire.getSourceEventName()] = eventTargetObject;
            //TODO: check because enabler has a bug here, remove source widget will not remove the wire
			
			// #17088, the wire is still in wire model after you delete the widget..
			// so we have to workaround with, detect wether the widget is removed
			var sourceId = incomingWire.getSourceWidget().getID();
			var targetId = incomingWire.getTargetWidget().getID();
			if(this.widgetWindowMap[sourceId] && this.widgetWindowMap[targetId]) {
				this.rootArray.push({
	                sourceWidget: sourceId,
	                sourceEvent: incomingWire.getSourceEventName(),
	                targetWidget: targetId,
	                targetEvent: incomingWire.getTargetEventName()
	            });
			}
        }
        
        var widgetsArray = this._getOtherLayoutControls(currentPID);
		
        for (var i = 0; i < widgetsArray.length; i++) {
			var currLC = widgetsArray[i];
            var wires = com.ibm.mm.builder.utils.wireUtil.getWiresTargetCSA2(currLC, currentPID);
 			
            for (var j = 0, length = wires.length; j < length; j++) {
                if (wires[j].getSourceWidget().getID() == this.selectedWindowId) {
					var wire = wires[j];
                    this.rootArray.push({
                        sourceWidget: wire.getSourceWidget().getID(),
                        sourceEvent: wire.getSourceEventName(),
                        targetWidget: wire.getTargetWidget().getID(),
                        targetEvent: wire.getTargetEventName()
                    });
                }
            }
        }
     },
    
    _getOtherWidgets: function(){
        var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(this.layouts);
        
        var len = iwidgetsFromHTMLFragment.length;
        
        var widgetsArray = [];
        for (var x = 0; x < len; x++) {
            var id = iwidgetsFromHTMLFragment[x];
            if (id != this.selectedWidgetId) {
				// TODO: CSA2 Replace with model api
                var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
                widgetsArray.push(targetWrapper);
            }
        }
        return widgetsArray;
    },
	
	   _getOtherLayoutControls: function(pageID){
        var layoutControls = com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2(pageID);
        
        var len = layoutControls.length;
        
        var widgetsArray = [];
        for (var x = 0; x < len; x++) {
            var currLayout = layoutControls[x];
            if (currLayout.getID() != this.selectedWidgetId) {
               widgetsArray.push(currLayout);
            }
        }
        return widgetsArray;
    },
	
	
    /**
     * Find out the root widget from eventService
     */
    _setupRootArray: function(){
        var wires = this.eventsMap;
        for (var source in wires) {
			if (Object.prototype.hasOwnProperty.call(wires,source)) {
				for (var event in wires[source]) { 
					if (Object.prototype.hasOwnProperty.call(wires[source],event)) {
						for (var target in wires[source][event]) {
							if (Object.prototype.hasOwnProperty.call(wires[source][event],target) && wires[source][event][target].length > 0) {
								var wireItem = {
									source: source,
									event: event,
									target: target,
									dataName: ""
								};
								this.rootArray.push(wireItem);
							}//end if
						}//end for
					}//end if(wires[source])
				}//end for
			}//end if(wires)
        }//end for
    },
    
    /**
     * set up the model
     */
    _setupModel: function(){
        for (var i = 0, length = this.rootArray.length; i < length; i++) {
            var wire = this.rootArray[i];
			// TODO: CSA2 Update with correct model calls
            this._addLinkToModel(wire.sourceWidget, wire.targetWidget);
        }
	},
    
    /**
     * Add a link to the model, take
     * @param {Object} sourceId source as parent
     * @param {Object} targetId target as child
     */
    _addLinkToModel: function(sourceId, targetId){
		var _sourceLcId = this.widgetWindowMap[sourceId];
		var _targetLcId = this.widgetWindowMap[targetId];
        var sourceModel = this.getModel(_sourceLcId);
        var targetModel = this.getModel(_targetLcId);
        
        sourceModel.childrenArray.push(_targetLcId);
        targetModel.parents.push(_sourceLcId);
    },
    
    /**
     * Get the sub model centerd by selected widget
     * @param {String} selectedWidgetId
     * @return {com.ibm.mm.builder.iwidget.wiringscreen.SubWiringModel} sub model
     */
    getSelectedModelFrom: function(selectedWidgetId){
        return new com.ibm.mm.builder.iwidget.wiringscreen.SelectedModel(selectedWidgetId, this);
    },
    
    /**
     * Get the root of the a widget,
     * @param {String} widgetId
     * @return {Array} widget list
     */
    getRootFrom: function(widgetId){
        this.selectedRoot = this.getParents(widgetId);
        if (this.selectedRoot.length === 0) {
            this.selectedRoot.push(this.getModel(widgetId));
        }
        return this.selectedRoot;
    },
    
    /**
     * Get the children of the wiring model
     * @param {String} widgetId
     * @return {Array} the children list
     */
    getChildren: function(widgetId){
        var children = [];
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            if (this.wiringModel[i].id == widgetId) {
                var childrenID = this.wiringModel[i].childrenArray;
                for (var j = 0; j < childrenID.length; j++) {
                    var childInfo = this.getInfo(childrenID[j]);
                    if (childInfo) {
                        children.push(childInfo);
                    }
                }
                break;
            }
            else {
                continue;
            }
        }
        return children;
    },
    
    
    /**
     * Get the parent of the wiring model
     * @param {String} widgetId
     */
    getParents: function(widgetId){
        //return [];
        var parents = [];
        
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            if (this.wiringModel[i].id == widgetId) {
                var parentsID = this.wiringModel[i].parents;
                for (var j = 0; j < parentsID.length; j++) {
                    var parentInfo = this.getInfo(parentsID[j]);
                    if (parentInfo) {
						parents.push(parentInfo);
					}
                }
                break;
            }
            else {
                continue;
            }
        }
        
        return parents;
    },
    
    /**
     * Get the info of the specific wiring model
     * @param {String} widgetId
     * @return {Object} widgetModel
     */
    getInfo: function(widgetId){
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            if (this.wiringModel[i].id == widgetId) {
                return this.wiringModel[i];
            }
            else {
                continue;
            }
        }
    },
    
    /**
     * Get the model info for the specific wiring model, if the model is not exist, create and return
     * @param {Object} widgetId An iWidget Object
     * @return {Object} widgetModel
     */
    getModel: function(/*iWidget Object*/widgetId){
        var widgetTitle = "";
        var widgetIcon = "";
        var visibility = true;

		// get current page
		var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID(); 
		var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
		var currentPage = navModel.find(currentPageId).start();
		var lm = navModel.getLayoutModel(currentPage);
		var lc = lm.find(widgetId).start();
		var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
		var widgetWindow = widgetModel.getWidgetWindow(lc).start();
		
		var title = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(lc,dojo.locale);
		if (title == null) {
			title = "";
		}
		var icon = lc.getMetaData("icon") || lc.getMetaData("thumbnail");
		if (icon === null) {
			icon = com.ibm.mm.builder.constant.generic_widget_icon;
		}
		widgetTitle = title;
		widgetIcon = icon;
		
        var widgetModel = this.getInfo(widgetId);
        if (widgetModel === null || widgetModel === undefined) {
            widgetModel = {
                id: widgetId,
                name: widgetTitle,
                icon: widgetIcon,
                parents: [],
                childrenArray: [],
                visibility: visibility,
                position: {
                    x: 0,
                    y: 0
                },
                selected: false
            };
            
            this.wiringModel.push(widgetModel);
        }
        return widgetModel;
    },
    
    _alreadyInWidgetInfoArray: function(widgetInfo, widgetInfoArray){
        var widgetInfoList = [];
        var isAllExist = true;
        if (dojo.isArray(widgetInfo)) {
            widgetInfoList = widgetInfo;
        }
        else {
            widgetInfoList = [widgetInfo];
        }
        for (var i = 0; i < widgetInfoList.length; i++) {
//            var widgetInfo = widgetInfoList[i];
            var isExist = false;
            for (var j = 0, length = widgetInfoArray.length; j < length; j++) {
                if (widgetInfoList[i].id == widgetInfoArray[j].id) {
                    isExist = true;
                    break;
                }
            }
            isAllExist = isAllExist && isExist;
        }
        return isAllExist;
    },
    
    _removeFromWidgetInfoArray: function(widgetInfo, widgetInfoArray){
        for (var i = 0, length = widgetInfoArray.length; i < length; i++) {
            if (widgetInfo.id == widgetInfoArray[i].id) {
                widgetInfoArray.splice(i, 1);
            }
        }
    }
});

/**
 * The subclass of Wiring model. used to represent a submodel that related to the selected widget
 * It can compute the depth and width of the model tree, and the coordinate of each widget which will be rendered on the canvas.
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.SelectedModel", com.ibm.mm.builder.iwidget.wiringscreen.WiringModel, {
    constructor: function(widgetId, parentModel){
        this.size = {
            x: 1,
            y: 1
        };//size of the sub model
        this.parentsHeight = [0];
        this.childrenHeight = [0];
        this.levelHeight = []; //array contains the depth of each level in the tree
        this.parentModel = parentModel;
        this.widgetId = widgetId;
        this.wiringModel = [];
        //initial the model 
        this._setModelFrom(widgetId);
    },
    
    /**
     * Initial the selected model from the selected widget
     * @param {String} widgetId
     */
    _setModelFrom: function(widgetId){
        var centerWidgetInfo = this.parentModel.getModel(widgetId);
        if (centerWidgetInfo) {
            this._addSelectedItem(centerWidgetInfo);
            this._addParentsToModel(this.widgetId, 1);
            this._addChildrenToModel(this.widgetId, 1);
            this._computeWiringMapSize();
            this._computeWidgetsPosition();
        }
    },
    /**
     * Check weather the model has link in it
     */
    hasLink: function(){
        //if leveHeight length greater than zero, it has link in it  		
        return (this.levelHeight.length > 1);
    },
    /**
     * Add selected widget to the model
     */
    _addSelectedItem: function(centerWidgetInfo){
        centerWidgetInfo.position.y = 1;
        centerWidgetInfo.position.x = 0;
        centerWidgetInfo.selected = true;
        this.wiringModel.push(centerWidgetInfo);
    },
    
    /**
     * Add related parents to the submodel
     * @param {String} widgetId
     * @param {number} level The distance from the selected widget to this widget, start from 1
     */
    _addParentsToModel: function(widgetId, level){
        var parents = this.parentModel.getParents(widgetId);
        if (parents.length > 0 && (this.parentsHeight[level] === null || this.parentsHeight[level] === undefined)) {
            this.parentsHeight.push(0);
        }
        for (var i = 0, length = parents.length; i < length; i++) {
            if (!this.getInfo(parents[i].id)) {
                parents[i].position.x = -level;
                this.parentsHeight[level]++;
                parents[i].position.y = this.parentsHeight[level];
                parents[i].selected = false;
                this.wiringModel.push(parents[i]);
                //now we only get the directly parents
                //this._addParentsToModel(parents[i].id, level + 1);
            }
        }
    },
    /**
     * Add related child to the submodel
     * @param {String} widgetId
     * @param {number} level The distance from the selected widget to this widget, start from 1
     */
    _addChildrenToModel: function(widgetId, level){
        var children = this.parentModel.getChildren(widgetId);
        if (this._alreadyInWidgetInfoArray(children, this.wiringModel)) {
            return;
        }
        if (children.length > 0 && (this.childrenHeight[level] === null || this.childrenHeight[level] === undefined)) {
            this.childrenHeight.push(0);
        }
        for (var i = 0, length = children.length; i < length; i++) {
            if (!this.getInfo(children[i].id)) {
                children[i].position.x = level;
                this.childrenHeight[level]++;
                children[i].position.y = this.childrenHeight[level];
                children[i].selected = false;
                this.wiringModel.push(children[i]);
                //now we only get the directly children
                //this._addChildrenToModel(children[i].id, level + 1);
            }
        }
    },
    /**
     * Compute the number of number of level and max height of levels of the model tree
     */
    _computeWiringMapSize: function(){
        //compute the max width
        var maxWidth = this.parentsHeight.length + this.childrenHeight.length - 1;
        var maxHeight = 1;
		var i = 1;
        //find the max height of each level
        for (i = 1; i < this.parentsHeight.length; i++) {
            if (this.parentsHeight[i] > maxHeight) {
                maxHeight = this.parentsHeight[i];
            }
        }
        for (i = 1; i < this.childrenHeight.length; i++) {
            if (this.childrenHeight[i] > maxHeight) {
                maxHeight = this.childrenHeight[i];
            }
        }
        //record the size of the model
        this.size = {
            x: maxWidth,
            y: maxHeight
        };
        //initial the array according to the max width.
        for (i = 0; i < maxWidth; i++) {
            this.levelHeight.push(0);
        }
    },
    /**
     * Compute the position of each widget thumb on canvas
     */
    _computeWidgetsPosition: function(){
        var parentsHeight = this.parentsHeight.length - 1;
        for (var i = 0, length = this.wiringModel.length; i < length; i++) {
            //Shift the position x to the place will be drawn
            this.wiringModel[i].position.x += parentsHeight;
            //record the height of each level
            if (this.levelHeight[this.wiringModel[i].position.x] < this.wiringModel[i].position.y) {
                this.levelHeight[this.wiringModel[i].position.x] = this.wiringModel[i].position.y;
            }
        }
    }
});


}
