if(!dojo._hasResource["com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlMenuLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlMenuLoader"] = true;
dojo.provide("com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlMenuLoader");

dojo.require("com.ibm.mashups.builder.model.ContextMenuLoader");
dojo.require("com.ibm.mm.builder.DelegatedDeferredImpl");
dojo.require("dojox.xml.parser");

dojo.declare("com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlLocalized", com.ibm.mashups.enabler.Localized, {

    ns: {
        "cm": "http://www.ibm.com/xmlns/prod/sw/context-menu/1.0"
    },
    
    constructor: function(){
        this._data = [];
    },
    
    /**
     * Returns a list model containing the locales that are supported by this
     * object. The presence of a locale in this list does not mean that a title
     * <b>and</b> description is available, but rather that either one or both are available in that locale.
     * @return {Array} a list of locales defined for this object, returns an
     * empty array if no locales are supported. Can never be <code>null</code>.
     */
    getLocales: function(){
        var ret = [];
        for (var i = 0; i < this._data.length; ++i) {
            ret.push(this._data[i].locale);
        }
        return ret;
    },
    
    /**
     * Returns the title of this object in the given locale.
     * @param {String} locale the locale for which to retrieve the title,
     * must not be <code>null</code>.
     * @return {String} the title of this node in the given locale. If a title is not
     * available in the given locale, this method will return <code>null</code>.
     * It is up to the invoker of the method to implement an appropriate fallback mechanism.
     */
    getTitle: function(locale){
        var def = 0;
        for (var i = 0; i < this._data.length; ++i) {
			//if (this._data[i].locale.toLowerCase() == locale.toLowerCase()) {
            if (this._data[i].locale.toLowerCase().replace("_", "-") == locale.toLowerCase()) {
                return this._data[i].title;
            }
            else {
                if (!def && this._data[i].locale.toLowerCase().replace("_", "-") == ibmConfig["default.locale"]) {
                    def = i;
                }
            }
        }
        return (this._data[def] && this._data[def].title) ? this._data[def].title : null;
    },
    
    
    /**
     * Returns the description of this object in the given locale.
     * @param {String} locale   the locale for which to retrieve the
     * description, must not be <code>null</code>.
     * @return {String} the description of this node in the given locale. If a
     * description is not available in the given locale, this method
     * will return <code>null</code>. It is up to the invoker of the
     * method to implement an appropriate fallback mechanism.
     */
    getDescription: function(locale){
        var def = 0;
        for (var i = 0; i < this._data.length; ++i) {
			//if (this._data[i].locale.toLowerCase() == locale.toLowerCase()) {
            if (this._data[i].locale.toLowerCase().replace("_", "-") == locale.toLowerCase()) {
                return this._data[i].description;
            }
            else {
                if (!def && this._data[i].locale.toLowerCase().replace("_", "-") == ibmConfig["default.locale"]) {
                    def = i;
                }
            }
        }
        return (this._data[def] && this._data[def].description) ? this._data[def].description : null;
    },
    
    setTitles: function(_node){
        var XPath = com.ibm.mashups.enabler.xml.XPath;
        var titles = XPath.evaluateXPath("cm:title/cm:nls-string", _node, this.ns);
        var i = titles.length;
        if (i > 0) {
            while (--i >= 0) {
                var lang = com.ibm.mm.enabler.utils.Dom.getAttributeWithNS(titles[i], "xml:lang", "lang", "http://www.w3.org/XML/1998/namespace");
                if (lang !== null) {
                    var title = titles[i].firstChild.nodeValue;
                    this._data.push({
                        "locale": lang,
                        "title": title,
                        "description": null
                    });
                }
            }
        }
        else { // Try to use the content of element "title" if there is no nls string
            titles = XPath.evaluateXPath("cm:title", _node, this.ns);
            if (titles.length > 0) {
                this._data.push({
                    "locale": "en",
                    "title": titles[0].firstChild.nodeValue,
                    "description": null
                });
            }
        }
    },
    
    /**
     * Sets the title for the given locale.
     * @param {String} title    title to set; must not be <code>null</code>
     * @param {String} locale   locale to set the title for; must not be <code>null</code>
     * @return <code>null</code>
     */
    setTitle: function(title, locale){
        locale.replace(/-/g, "_");
        for (var i = 0; i < this._data.length; ++i) {
            if (this._data[i].locale == locale) {
                this._data[i].title = title;
                return null;
            }
        }
        var anItem = {
            "locale": locale,
            "title": title,
            "description": null
        };
        this._data.push(anItem);
        return null;
    },
    
    /**
     * Sets the description for the given locale.
     * @param {String} desc     description to set; must not be <code>null</code>
     * @param {String} locale   locale to set the description for; must not be <code>null</code>
     * @return <code>null</code>
     */
    setDescription: function(desc, locale){
        for (var i = 0; i < this._data.length; ++i) {
            if (this._data[i].locale == locale) {
                this._data[i].description = desc;
                return null;
            }
        }
        var anItem = {
            "locale": locale,
            "title": null,
            "description": desc
        };
        this._data.push(anItem);
        return null;
    }
    
});


dojo.declare("com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlMenuLoader", com.ibm.mashups.builder.model.ContextMenuLoader, {

    CONTEXT_MENU_PROVIDER: ibmConfig["ConfigProvider.ContextMenu_Provider"] ? ibmConfig["ConfigProvider.ContextMenu_Provider"] : "ContextMenu_Provider",
    
    CONFIG_SERVICE_PROPERTY: "contextmenu.xml",
    
    ns: {
        "cm": "http://www.ibm.com/xmlns/prod/sw/context-menu/1.0"
    },
    
    constructor: function(){
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger(this.declaredClass);
        this.xmlData = null;
    },
    
    getItems: function(/*String*/contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject){
        var mname = "getItems", lgr = this.LOGGER;
        lgr.entering(mname, arguments);
        dfd = new com.ibm.mm.builder.DeferredImpl(this, function(deferred, sync, params){
            var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters(), res;
            if (!this.xmlData) {
                var dfd = this.getData().setFinishedCallback(dojo.hitch(this, function(xmlData, status, params){
                    res = xmlData; // may be an Error
                    if (status == 200) {
                        this.xmlData = xmlData;
                        res = this._initMenuItems(contextMenuId, targetResourceId, targetResourceType, someObject);
                    }
                    if (callBack) {
                        callBack(res, status, callBackParams); // callback for success or error
                    }
                }));
                dfd.start(sync);
            }
            else {
                res = this._initMenuItems(contextMenuId, targetResourceId, targetResourceType, someObject);
                if (callBack) {
                    callBack(res, 200, callBackParams);
                }
            }
            return res;
        });
        lgr.exiting(mname, arguments);
        return dfd;
    },
    /**
     * Gets context menu items from the ConfigService using the ContextMenu_Provider.
     * @returns {com.ibm.mashups.enabler.Deferred} deferred object that loads the XML data from the ConfigService
     */
    getData: function(){
        // multiple calls to this before a previous call finishes may result in multiple requests for the same data.... depending on
        // the implementation of the ConfigService Deferred
        var mname = "getData", lgr = this.LOGGER;
        if (!this._baseLoader) {
            this._baseLoader = new com.ibm.mm.builder.DelegatorDeferredImpl(this, function(deferred, sync, params){
                var callBack = deferred.getFinishedCallback(), callBackParams = deferred.getFinishedCallbackParameters();
                lgr.trace(mname, "Start loading remote data");
                if (this.xmlData) {
                    lgr.trace(mname, "Data already loaded ${0}", [this.xmlData]);
                    if (callBack) {
                        callBack(this.xmlData, 200, callBackParams);
                    }
                }
                else {
                    this._loadFromService(sync, dojo.hitch(this, function(data, status, parms){
                        lgr.trace(mname, "Called back from service loader ${0} ${1} ${2}", [typeof(data), status, parms||""]);
                        var res = data; // may be an Error
                        if (status == 200) {
                            res = this.xmlData = com.ibm.mm.enabler.utils.Dom.createDocument(data);
                            lgr.trace(mname, "Data loaded successfully ${0}", [this.xmlData]);
                        }
                        if (callBack) {
                            callBack(res, status, callBackParams); // callback for success or error
                        }
                    }));
                }
                return this.xmlData;
            });
        }
        var dfd = new com.ibm.mm.builder.DelegatedDeferredImpl();
        this._baseLoader.addDelegate(dfd);
        return dfd;
    },
    
    _loadFromService: function(sync, callbackFunction){
        var mname = "_loadFromService", lgr = this.LOGGER;
        lgr.entering(mname, arguments);
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        var co = cs.getConfigObject(this.CONTEXT_MENU_PROVIDER);
        var propName = this.CONFIG_SERVICE_PROPERTY;
        var propNameFromConfig = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CONTEXT_MENU_NAME);
        if (propNameFromConfig && propNameFromConfig !== "") {
            propName = propNameFromConfig;
        }
        var deferred = co.getValueDeferred(propName);
        deferred.setFinishedCallback(callbackFunction);
        var res = deferred.start(sync);
        lgr.exiting(mname, [res]);
        return res;
    },
    
    _initMenuItems: function(_contextMenuItemId, _targetResourceId, _targetResourceType, _someObject){
        var mname = "_initMenuItems", lgr = this.LOGGER;
        lgr.entering(mname, arguments);
        var ret = [];
        if (this.xmlData) {
            var expr = 'cm:contextmenu/cm:menu[@definition="' + _contextMenuItemId + '"]';
            var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, this.xmlData, this.ns);
            var lclCtx = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
            
            if (nodes && nodes.length > 0) {
                expr = "cm:contextMenuItem";
                var subnodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(expr, nodes[0], this.ns);
                if (subnodes && subnodes.length > 0) {
                    for (var i = 0; i < subnodes.length; ++i) {
                        var myMetadata = this._getMetaData("cm:meta-data", subnodes[i]);
                        myMetadata = myMetadata.length === 0 ? null : myMetadata;
                        if (this._checkVisibility(subnodes[i], _targetResourceId, _targetResourceType, myMetadata, _someObject)) {
                            var isSeparator = this._checkSeparator(subnodes[i]);
                            var myLocalized = this._getLocalized(subnodes[i]);
                            var mytitle = lclCtx.getTitle(myLocalized);
                            var mydescription = lclCtx.getDescription(myLocalized);
                            var myIconClass = this._getIconClass(subnodes[i]);
                            var myState = this._getState(subnodes[i], _targetResourceId, _targetResourceType, myMetadata, _someObject);
                            var myActionName = this._getFunction("cm:action-handler", subnodes[i]);
                            var myAction;
                            if (myActionName) {
                                myAction = this._buildMethod(myActionName, _targetResourceId, _targetResourceType, myMetadata, _someObject);
                            }
                            var anItem = {
                                "isSeparator": isSeparator,
                                "localized": myLocalized,
                                "title": mytitle,
                                "description": mydescription,
                                "iconClass": myIconClass === null ? "" : myIconClass,
                                "enabled": myState,
                                "id": subnodes[i].getAttribute("id"),
                                "ordinal": subnodes[i].getAttribute("ordinal"),
                                "actionCallBackFunction": myAction,
								"actionCallBackFunctionName": myActionName
                            };
                            ret.push(anItem);
                        }
                    }
                }
            }
        }
        lgr.exiting(mname, [ret]);
        return ret;
    },
    
    /**
     * Default returns true, unless there is a javascript code that explicitly returns false "javascript:false"
     * or state function that returns false
     * @param {Object} _node
     * @param {Object} _targetResourceId
     * @param {Object} _targetResourceType
     * @param {Object} _metadata
     * @param {Object} _someObject
     */
    _checkVisibility: function(_node, _targetResourceId, _targetResourceType, _metadata, _someObject){
        var visible = true;
        var myVisible = this._getFunction("cm:visibility-provider", _node);
        if (myVisible) {
            try {
                visible = this._buildMethod(myVisible, _targetResourceId, _targetResourceType, _metadata, _someObject)();
                if (visible === null || visible === "") { //Need to check this, if the visibility function returns null or nothing, then use default value
                    visible = true;
                }
            } 
            catch (e) {
                this.LOGGER.severe("_checkVisibility", e, _node);
            }
        }
        return !!visible;
    },
    
    /**
     * Default returns false, unless there is a attributethat explicitly defines separator="true"
     * @param {Object} _node
     */
    _checkSeparator: function(_node){
        var isSeparator = _node.getAttribute("separator");
        if (isSeparator === true || isSeparator == "true") {
            return true;
        }
        return false;
    },
    
    /**
     * Default Returns "enabled", unless there is a javascript code that explicitly returns false "javascript:false"
     * or state function that returns false
     * @param {Object} _node
     * @param {Object} _targetResourceId
     * @param {Object} _targetResourceType
     * @param {Object} _metadata
     * @param {Object} _someObject
     */
    _getState: function(_node, _targetResourceId, _targetResourceType, _metadata, _someObject){
        var state = true;
        var myState = this._getFunction("cm:state-provider", _node);
        if (myState) {
            try {
                state = this._buildMethod(myState, _targetResourceId, _targetResourceType, _metadata, _someObject)();
                if (state === null || state === "") { //Need to check this, if the state function returns null or nothing, then use default value
                    state = true;
                }
            } 
            catch (e) {
                this.LOGGER.severe("_getState", e, _node);
            }
        }
        return !!state;
    },
    
    _buildMethod: function(_myMethod, _targetResourceId, _targetResourceType, _metadata, _someObject){
        var method = null;
        try {
            if (_myMethod.match("^" + "javascript:") == "javascript:") { // deal with something like "javascript:alert(1)" or "javascript:false", even "javascript:this.inNva" // JSLINT-IGNORE: <no script url, work on purpose>
                if (_someObject && _someObject.context) {
                    method = dojo.hitch(_someObject.context, function(){
                        return eval(_myMethod); // JSLINT-IGNORE: <eval is neccessary to turn string into expression or function>
                    });
                }
                else {
                    method = function(){
                        return eval(_myMethod); // JSLINT-IGNORE: <eval is neccessary to turn string into expression or function>
                    };
                }
            }
            else {
                if (_someObject && _someObject.context) {
                    method = dojo.hitch(_someObject.context, function(){
                        return eval(_myMethod).call(_someObject.context, _targetResourceId, _targetResourceType, _metadata, _someObject); // JSLINT-IGNORE: <eval is neccessary to turn string into expression or function>
                    });
                }
                else {
                    method = function(){
                        return eval(_myMethod).call(this, _targetResourceId, _targetResourceType, _metadata, _someObject); // JSLINT-IGNORE: <eval is neccessary to turn string into expression or function>
                    };
                }
            }
        } 
        catch (e) {
            this.LOGGER.severe("_buildMethod", e, _myMethod);
            method = function(){
            }; //never return null to avoid the possible error when the function is invoked
        }
        return method;
    },
    
    _getLocalized: function(_node){
        var myloc = new com.ibm.mm.builder.model.contextMenu.ConfigServiceXmlLocalized();
        myloc.setTitles(_node);
        nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath("cm:description", _node, this.ns);
        if (nodes && nodes.length > 0) {
            myloc.setDescription(nodes[0].firstChild.nodeValue, "en");
        }
        return myloc;
    },
    
    _getFunction: function(_expr, _node){
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(_expr, _node, this.ns);
        if (nodes && nodes.length > 0 && nodes[0].firstChild) {
            return nodes[0].firstChild.nodeValue;
        }
        return null;
    },
    
    /**
     * Default returns null, unless there is a attributethat explicitly defines an iconClass value
     * @param {Object} _node
     */
    _getIconClass: function(_node){
        return _node.getAttribute("iconClass");
    },
    
    _getMetaData: function(_expr, _node){
        var myArray = [];
        var nodes = com.ibm.mashups.enabler.xml.XPath.evaluateXPath(_expr, _node, this.ns);
        if (nodes && nodes.length > 0) {
            for (var i = 0; i < nodes.length; ++i) {
                if (nodes[i].firstChild) {
                    var anItem = {
                        "key": nodes[i].firstChild.nodeValue,
                        "value": nodes[i].firstChild.nodeValue
                    };
                    myArray.push(anItem);
                }
            }
        }
        return myArray;
    }
});

}
