if(!dojo._hasResource["com.ibm.mm.builder.utils.navigationUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.navigationUtil"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.navigationUtil");

dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("com.ibm.mm.builder.utils.userUtil");
dojo.require("com.ibm.mm.builder.utils.pageUtil");
dojo.require("com.ibm.mm.builder.utils.spaceUtil");
dojo.require("com.ibm.mm.builder.constant");
dojo.require("dojo.cookie");

/**
 * Return navigation model, if refresh is true, the cache will be clean and retrieve the model again.
 * @param {boolean} refresh
 * @param {string} id
 */
(function(){
var enabler = com.ibm.mashups.enabler;
var builder = com.ibm.mm.builder;
var strategy = enabler.strategy;
var ef = enabler.model.Factory;
var ems = enabler.model.state;
var af = ems.AccessorFactory;
var pageUtil = builder.utils.pageUtil;
var userUtil = builder.utils.userUtil;
var spaceUtil = builder.utils.spaceUtil;
var cs = com.ibm.mashups.services.ServiceManager.getService(enabler.services.ConfigService.SERVICE_NAME);
var es = com.ibm.mashups.services.ServiceManager.getService("eventService");
var logger = enabler.logging.Logger.getLogger("com.ibm.mm.builder.utils.navigationUtil");
			
var navigationUtil = {
    getNavigationModel: function(doNotPreload){
        if (!this._navModel) {
            var _navModel = ef.getNavigationModel();
            
            
            // list loadahead strategy
            var llaStrategy = new strategy.ListLoadAheadStrategy(com.ibm.mm.builder.constant.NavigationPageSize);
            var strats = [];
            var isFromHub = dojo.trim(ibmConfig["com.ibm.mashups.builder.contentShelf.mode"] || "") == "hub";
            if (isFromHub) {                
                strats = [llaStrategy];
            } else {
                var ulaStrategy = new strategy.UserLoadAheadStrategy(true);
                ulaStrategy.setUserModel(builder.utils.userUtil.getUserModel());
                strats = [llaStrategy, ulaStrategy];  
            }           
            
            for(var i=0; i<strats.length; i++) {
                _navModel.addStrategy(strats[i]);
            }
            
            this._navModel = _navModel;
            
            //clean cache
            com.ibm.mm.builder.utils.pageUtil.currentPageNode = null;
            this.personalSpaceNavigationRootNode = null;
        }
        
        // we should not add and remove strategies for every single get
        if (typeof doNotPreload != "undefined") {
            var plaStrategy = null;
            if (doNotPreload)
                plaStrategy = new strategy.PageLoadAheadStrategy(true, false, false);
            else    
                plaStrategy = new strategy.PageLoadAheadStrategy(true, true, true);
                
            this._navModel.removeStrategy("com.ibm.mashups.enabler.strategy.PageLoadAheadStrategy");
            this._navModel.addStrategy(plaStrategy);
        }
        
        return this._navModel;
    },
	
	getSharedNavigationModel: function(){
		if (!this._sharedNavModel) {
			var _sharedNavModel = ef.getSharedNavigationModel();
			_sharedNavModel.setStrategy(new enabler.strategy.ListLoadAheadStrategy(com.ibm.mm.builder.constant.NavigationPageSize));
			this._sharedNavModel = _sharedNavModel;
		}
		return this._sharedNavModel;
	},
	
	getNavigationStateModel: function(){
		if (!this.navigationStateModel) {
			this.navigationStateModel = ems.NavigationStateModelFactory.getNavigationStateModel();
		}
		return this.navigationStateModel;
	},
	
	getNavigationRootNode: function(spaceId){
		if(spaceId){
			 // find the selected node
			var space = spaceUtil.getSpaceModel().find(spaceId).start();
			if (space) {
				return pageUtil.getPageNode(space.getRootNavigation().getID());
			}
		}
		return this.getPersonalSpaceNavigationRootNode();
	},
	
	getPersonalSpaceNavigationRootNode: function(){
		if(!this.personalSpaceNavigationRootNode){
			this.personalSpaceNavigationRootNode = this.getNavigationModel().getRoot().start();
		}
		return this.personalSpaceNavigationRootNode;
	},
	
	getPersonalSpaceNavigationRootId: function(){
		return this.getPersonalSpaceNavigationRootNode().getID();
	},
	
	getNavigationRootNodeId: function(spaceId){
		return this.getNavigationRootNode(spaceId).getID();
	},
	
	getSharedNavigationRootNode: function(){
		return this.getSharedNavigationModel().getRoot().start();
	},
	
	getFirstPageNode: function(){
		//autoaccept shared page in LockedDownAnonymousMode
		if(userUtil.isLockedDownAnonymousMode()){
			this.autoAcceptAllPages();
		}
		
		//get page id from cookie or location hash
		var pid = pageUtil.getPageIdFromSpace();
		
		//refresh and login from global page, direct to previous page instead of page from navigation state api
		if (dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid)) {
			pid = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid);
			dojo.cookie(com.ibm.mm.builder.constant.cookieKey_previous_pid, null,{expires: -1});
		}
		
		//get page id form cookie
		if (pid) {
			var page = pageUtil.getPageNode(pid);
			if (page) { return page; }
			else {
				//try to auto accept page, todo refactor with personal space auto accept
				try {
					page = this.getSharedNavigationModel().find(pid).start();
					var _navModel = this.getNavigationModel();
					var root = this.getPersonalSpaceNavigationRootNode();
					// auto accept shared page
					_navModel.insert(page, root, null);
					_navModel.commit().start();
					return _navModel.find(pid).start();
				} catch (e) {}
			}
		}
		if (this.isLastPageWhenLogin()) { //goto last vistied page in space if user's setting is last page
			//go to first page in last visited space, if the space is not hidden
			if (!pid && spaceUtil.getCurrentSpaceId()) {
				if(spaceUtil.getSpaceNode(spaceUtil.getCurrentSpaceId())){
					pid = pageUtil.getFirstPageInSpace(spaceUtil.getCurrentSpaceId());
					return pageUtil.getPageNode(pid);
				}else{
					return this.gotoHomeSpace();
				}
			}
		}
		
		var sid = spaceUtil.getCurrentSpaceId();
		if (sid) {
			pid = pageUtil.getFirstPageInSpace(sid);
			if (pid) {
				var apage = pageUtil.getPageNode(pid);
				if (apage) { return apage; }
			}
			spaceUtil.setSpaceId(sid);
			return null;
		}
		
		if(dojo.cookie("inPersonalSpace") && dojo.cookie("inPersonalSpace") !== "null") {
			return this.gotoPersonalSpace();
		}
		return this.gotoHomeSpace();
	},
	
	gotoHomeSpace: function(){
		var homespaceId = spaceUtil.getHomeSpaceId();
		if (homespaceId && spaceUtil.getSpaceNode(homespaceId)) {
			spaceUtil.setSpaceId(homespaceId);
			var pid = pageUtil.getFirstPageInHomeSpace();
			if (pid) {
				var page = pageUtil.getPageNode(pid);
				if (page) {
					return page;
				}
				else {
					return null;
				}
			}
			else {
				// if no pages in space return the root navigation for the space
				var space = spaceUtil.getSpaceModel().find(homespaceId).start();
				if (space) {
					return pageUtil.getPageNode(space.getRootNavigation().getID());
				}
				else {
					return null;
				}
			}
		}
		
		// see if there is a welcome space
        var welcomespaceId = spaceUtil.getWelcomeSpaceId();
		if (welcomespaceId && spaceUtil.getSpaceNode(welcomespaceId)) {
			spaceUtil.setSpaceId(welcomespaceId);
			var wpid = pageUtil.getFirstPageInSpace(welcomespaceId);
			if (wpid) {
				var wpage = pageUtil.getPageNode(wpid);
				if (wpage) { return wpage; }
			}
			return null;
		}
		return this.gotoPersonalSpace();
	},
	
	gotoPersonalSpace: function(){
		spaceUtil.setSpaceId(null);
		
		//goto personal space
		var _navModel = this.getNavigationModel();
		var root = this.getPersonalSpaceNavigationRootNode();
		var pid = pageUtil.getPageIdFromSpace();
		if (pid) {
			try {
				var page = this.getSharedNavigationModel().find(pid).start();
				// auto accept shared page
				_navModel.insert(page, root, null);
				_navModel.commit().start();
				return this.getNavigationModel().find(pid).start();
			} catch (e) {}
		}
		// if there is no any page, auto accept all pages from share navigation node
		if (!_navModel.hasChildren(root)) {
			this.autoAcceptPagesFromDefaultGroup();
		}
		//return first page on the space
		return pageUtil.getFirstChildPage(root.getID());
	},
	
	/**
	 * Auto accept pages that shared from 'default' user group in personal space
	 */
	autoAcceptPagesFromDefaultGroup: function() {
		
		var navigationModel = this.getNavigationModel();
		var navgationRootNode = this.getNavigationRootNode();
		var sharedNavigationModel = this.getSharedNavigationModel();
		var sharedRoot = this.getSharedNavigationRootNode();
		
		var iter = sharedNavigationModel.getChildren(sharedRoot);
		while (iter.hasNext()) {
			var pageNode = iter.next();
			//ideally we only accept pages shared among the default user group
			//because of the unstable community js api, so far we accept all pages
			var isInDefaultGroup = false;
			var autoAcceptName = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.CLIENT_AUTO_ACCEPT_SHARED_GROUPNAME);
			if (autoAcceptName == "*") {
				isInDefaultGroup = true;
			} else {
				sharedNavigationModel.find(pageNode.getID()).start();
				var layoutModel = sharedNavigationModel.getLayoutModel(pageNode.getID());
				if (layoutModel) {
					var layoutNode = layoutModel.getRoot().start();
					var acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode);
					var userList = com.ibm.mm.builder.utils.acModelUtil.getAllMembersInModel(acModel);
					
					var autoAcceptGroupNames = autoAcceptName.split(';');
					for (var i = 0, n = userList.length; i < n; i++) {
						var userName = userList[i].getDisplayName();
						for (var x = 0, y = autoAcceptGroupNames.length; x < y; x++) {
							if (autoAcceptGroupNames[x] == userName) {
								isInDefaultGroup = true;
								break;
							}
						}
					}
				}
			}
			if (isInDefaultGroup) {
				var page = sharedNavigationModel.find(pageNode.getID()).start();
				navigationModel.insert(page, navgationRootNode);
			}
		}
	    navigationModel.commit().start();
	},
	
	/**
	 * Auto accept pages that shared to anonymous
	 */
	autoAcceptAllPages: function(){
		try {
			var navigationModel = this.getNavigationModel();
			var navgationRootNode = this.getNavigationRootNode();
			var sharedNavigationModel = this.getSharedNavigationModel();
			var sharedRoot = this.getSharedNavigationRootNode();
			
			var iter = sharedNavigationModel.getChildren(sharedRoot);
			while (iter.hasNext()) {
				navigationModel.insert(iter.next(), navgationRootNode);
			}
			navigationModel.commit().start();
		} 
		catch (e) {
			console.log(e);
		}
	},
	
	getRedirectAddress: function(){
		return enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(this.getNavigationStateModel());
	},
	
	/**
	 * Re-order page
	 * @param {String} pageId ID of the page to be re-ordered
	 * @param {String} targetPageId ID of the page to be inserted
	 * @param {String} position insert position, include "next", "previous", "children".
	 */
	reorderPageNode: function(pageId, targetPosPageId, position) {
		
		var retVal = null;
		
		try {
			var navigationModel = this.getNavigationModel();
			var context = this.getReorderPageContext(targetPosPageId, position),
				page = pageUtil.getPageNode(pageId),
				parent = context.parent,
				next = context.next;
			// @Stephan #11481 Start
			// please fix enabler api: js error when page is not null and parent is root.
			if(navigationModel.confirmInsert(page, parent, next)){
				navigationModel.insert(page, parent, next);		
				var deferred = navigationModel.commit();		
				var newNode = null;
				deferred.setOperationCallback( function (result) {
					var request = result.request;
					if (request) {					
						if (request.statusCode >= 400) {
							if (request.responseText) {
								retVal = request.responseText;
							}
							else {
								var bundle = dojo.i18n.getLocalization("com.ibm.mm.builder", "coreWidgetsMessages");
								retVal = dojo.string.substitute(bundle.E_PUB_API_MOVE_PAGE_1,[request.statusCode]);													
							}
						}						
					}
				}, null, true);				
				deferred.setFinishedCallback( function(result) {
					if (result.statusCode < 400) {
						es.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
					}
				}, null, true);
				deferred.start(true);
			}
			// @Stephan #11481 End
		} catch (e) {
			retVal = e.message;
			logger.severe("reorderPageNode", retVal);
		}
		
		return retVal;
	},
	
	getReorderPageContext: function(pageId, position) {
		var navigationModel = this.getNavigationModel(),
	    	page = pageUtil.getPageNode(pageId),
			parent = null,
			next = null;
		
		switch (position) {
			case "previous":
			    parent = navigationModel.getParent(pageId).start();
			    next = page;
				break;
			case "next":
			    parent = navigationModel.getParent(pageId).start();
				var childrenIter = navigationModel.getChildren(parent);
				while (childrenIter.hasNext()) {
					var child = childrenIter.next();
					if (child.getID() === pageId) {
						next = childrenIter.next();
						break;
					}
				}
			    break;
			default:  // children as default
			    parent = page;
		}
		return {
			parent: parent,
			next: next
		};
	},
	
	getPageContext: function(pageId) {
		var navigationModel = this.getNavigationModel(),
	    	page = pageUtil.getPageNode(pageId),
			parent = null,
			next = null,
			previous = null;
		
	    parent = navigationModel.getParent(pageId).start();
		var childrenIter = navigationModel.getChildren(parent);
		while (childrenIter.hasNext()) {
			var child = childrenIter.next();
			if (child.getID() === pageId) {
				if(childrenIter.hasNext()){
					next = childrenIter.next();
				}
				break;
			}
			previous=child;
		}
		
		return {parent:parent,previous:previous,next:next};
	},
	
	/**
	 * Check if descendantPage is descendant of parent
	 * @param {String} parentPageId
	 * @param {String} descendantPageId
	 * @param {int} generation .null/0 unlimited, 1 direct child, 2 grand child, etc
	 */
	isDescendant: function(parentPageId, descendantPageId,generation){
		var navigationModel = this.getNavigationModel();
		var rootId = this.getNavigationRootNodeId();
		var pageId = descendantPageId;
		if(!generation || generation<=0){
			generation=0;
		} 
		var currentGen=0;
		while (parentPageId !== pageId) {
			var parent = navigationModel.getParent(pageId).start();
			if (!parent) { return false; }
			pageId = parent.getID();
			currentGen++;
			if(generation>0 && currentGen >=generation){
				//generation is set, break when currentGen is no less the requiredGeneration
				break;
			}
			if (rootId === pageId) {
				break;
			}
		}
		if(generation<=0 || currentGen ==generation ){
			return parentPageId === pageId;
		}else {
			return false;
		}
		
	},
	
    isPortal: function() {
        if (ibmCfg.portalConfig.portalContext) { 
            return true;
        }
        return false;
    },
    
    isLastPageWhenLogin: function() {
        // 18968: return true in a portal environment
        if (this.isPortal()) { 
            return true;
        }
        try {
            var u = com.ibm.mm.builder.utils.userUtil.getCurrentUser();
            return u.getAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN") === "lastpage";

        } catch (e) {
            return true;
        }
    },
    
    setPageIDCookie: function(pageID) {
        // don't do this on Portal
        if (this.isPortal()) {
            return;
        }
        dojo.cookie("url_pid", "pid="+pageID, {path: "/"});
    },
	
	updateSpaceTitleInNavBar: function() {
		var currentSpace = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceNode();
		var globalSpaceId = dojo.cookie(com.ibm.mm.builder.constant.cookieKey_globalPageOpenedSpaceId);
		if (globalSpaceId) {
			currentSpace = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(globalSpaceId);
		}
		var spanNode = dojo.query("span#spaceName")[0];
		if(spanNode) {
			var oldNode = dojo.query("h2",spanNode);
			if(oldNode[0]) {
				var n = spanNode.removeChild(oldNode[0]);
				dojo.destroy(n);
			}
			currentSpaceTitle = currentSpace? com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(currentSpace):null;
			if (currentSpaceTitle) {
				var newNode = dojo.create("h2", {
					innerHTML: currentSpaceTitle
				}, spanNode);
				dojo.style(newNode, "width", "auto");
				dojo.style(newNode, "padding", "15px 20px 0px");
			}
		}
	}
};

com.ibm.mm.builder.utils.navigationUtil = navigationUtil;
})();

}
