if(!dojo._hasResource["com.ibm.mm.builder.utils.wireUtil"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.utils.wireUtil"] = true;
/**
 * Util class for wiring widget
 @author <a href="mailto:bizheng@cn.ibm.com">Zheng Bi</a>
 @author Marshall (shiwcsdl@cn.ibm.com)
 @author Yi Ming Huang (huangyim@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.utils.wireUtil");

com.ibm.mm.builder.utils.wireUtil.LOGGER = com.ibm.mashups.enabler.logging.Logger
	.getLogger("com.ibm.mm.builder.utils.wireUtil");

com.ibm.mm.builder.utils.wireUtil.highlightWidget = function(id) {
	var lcDiv = com.ibm.pb.layout.LayoutParser.findById(id);
	var coords = dojo.coords(lcDiv);
	var scroll = dojo._docScroll();
   	var highlightDiv = dojo.byId("mmDiv_highlight");
    if (!highlightDiv) {
        highlightDiv = document.createElement("div");
        highlightDiv.id = "mmDiv_highlight";
        highlightDiv.style.position = "absolute";
        highlightDiv.style.backgroundImage = "url('" + builderConfig.builderPath + "/images/widget_highligh_color.png')";
        document.body.appendChild(highlightDiv);
    }
    highlightDiv.style.display = "none";
	highlightDiv.style.cssText += "; left: " + (coords.x + scroll.x) + "px; "
								+ "top: " + (coords.y + scroll.y) + "px; "
								+ "width: " + coords.w + "px; "
								+ "height: " + coords.h + "px; "
								+ "zIndex: 780;";
    highlightDiv.style.display = "";			
};

com.ibm.mm.builder.utils.wireUtil.removeHighlight = function() {
	var highlightDiv = dojo.byId("mmDiv_highlight");
	if (highlightDiv){
		highlightDiv.style.display = "none";
	}
};

/**
 * Trigger auto wire logic for the specific widget
 * @param {Object} lcId: LayoutControl ID
 */
com.ibm.mm.builder.utils.wireUtil.triggerAutowire = function(lcId) {
	var isAutoWireEnabled = com.ibm.mashups.builder.model.Factory.getRuntimeModel()
			.getCurrentPage().getAutoWiringEnablement();
	// If auto wire is enabled on the current page
	if(isAutoWireEnabled) {
		var widgetAWEnabled = com.ibm.mm.builder.utils.wireUtil.isAutowireEnabled(lcId);
		if(widgetAWEnabled) {
			com.ibm.mashups.services.ServiceManager.getService("eventService")
				.broadcastEvent("com.ibm.mashups.builder.createAutoWire", lcId);
		}
	}
};

/**
 * Check whether the widget is auto wire enabled
 * @param {Object} lcId: layout control/widget ID
 */
com.ibm.mm.builder.utils.wireUtil.isAutowireEnabled = function(lcId) {
	var lc = com.ibm.mm.builder.utils.wireUtil.getLayoutControl(lcId);
	//var autowire = widgetDef.getMetaData("com.ibm.mashups.builder.autoWiringEnabled");
	var autowire = lc.getMetaData("onAutoWire");
	return (autowire=="true" ? true : false);
};

/**
 * @param {Object} lcId: layoutControl ID
 * @return {Object} LayoutControl
 */
com.ibm.mm.builder.utils.wireUtil.getLayoutControl = function(lcId) {
	var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	var currentPage = navModel.find(pageId).start();
	var layoutModel = navModel.getLayoutModel(currentPage);
	var layoutControl = layoutModel.find(lcId).start();
	return layoutControl;
};

// # 17780 when the same event is both published and handled
// the event object returned by eventProvider.getEvent(eventName) is arbitrary
com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType = function(eventProvider, eventName, type) {
	var filter = new Object();
	filter[type] = true;
	var events = eventProvider.getEvents(filter);
	var event = null;
    for (var i=0,l=events.length; i<l; i++) {
		var evt = events[i];
		if (evt.getName() == eventName)
		    event = eventProvider.getEventByID(evt.getID());
	}
	return event;
};

/**
 * Setup wire
 * @param {Object} sourceId: sending widget/lc ID
 * @param {Object} sourceEvent: sending event name
 * @param {Object} targetId: receiving widget/lc ID
 * @param {Object} targetEvent: receiving event name
 * @return {boolean} wire setup or not
 */
com.ibm.mm.builder.utils.wireUtil.addWireCSA2 = function(sourceId, sourceEvent, targetId, targetEvent) {
	var currentPageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
    var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
    var currentPage = navModel.find(currentPageId).start();
	var layoutModel = navModel.getLayoutModel(currentPage);
    var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
    
	var sourcelc = layoutModel.find(sourceId).start();
    var sourceWidgetWindow = widgetModel.getWidgetWindow(sourcelc).start();
    var sourceEventProvider = widgetModel.getHierarchicalEventProvider(sourceWidgetWindow).start();
	//var sourceEventObject = sourceEventProvider.getEvent(sourceEvent);
	var sourceEventObject = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
			sourceEventProvider, sourceEvent, com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS);
						
    var targetlc = layoutModel.find(targetId).start();
    var targetWidgetWindow = widgetModel.getWidgetWindow(targetlc).start();
    var targetEventProvider = widgetModel.getHierarchicalEventProvider(targetWidgetWindow).start();
    //var targetEventObject = targetEventProvider.getEvent(targetEvent);
	var targetEventObject = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
			targetEventProvider, targetEvent, com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS);
    
    var ctx = {};
    ctx.sourceWidgetId = sourceWidgetWindow;
    ctx.sourcePageId = currentPage;
    ctx.sourceEventId = sourceEventObject;
    ctx.targetWidgetId = targetWidgetWindow;
    ctx.targetPageId = currentPage;
    ctx.targetEventId = targetEventObject;
    // create the wire
    var wireModel = layoutModel.getWireModel();
    var wire = wireModel.create(ctx);
	
	var isWireAlreadyCreated = com.ibm.mm.builder.utils.wireUtil
		.isWireCreated(wireModel, wire, sourceWidgetWindow);
    
	// insert the wire
    if (!isWireAlreadyCreated && wire) {
        wireModel.insert(wire, null);
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
    }
	// true: create a wire, false: already exist, not create
	return !isWireAlreadyCreated;
};

/**
 * weather the newly created wire is already exist
 * @param {Object} wireModel: WireModel
 * @param {Object} newWire: newly created wire (not inserted)
 * @param {Object} sourceId: source widget/lc ID
 */
com.ibm.mm.builder.utils.wireUtil.isWireCreated = function(wireModel, newWire, sourceWidgetWindow) {
	var wires = wireModel.findBySourceWidget(sourceWidgetWindow).start();
	for(var i=0; i<wires.length; i++) {
		var wire = wires[i];
		var sourceID1 = wire.getSourceWidget().getID();
		var sourceID2 = newWire.getSourceWidget().getID();
		var targetID1 = wire.getTargetWidget().getID();
		var targetID2 = newWire.getTargetWidget().getID();
//		var sourceEvt1 = wire.getSourceEventName();
//		var sourceEvt2 = newWire.getSourceEventName();
//		var targetEvt1 = wire.getTargetEventName();
//		var targetEvt2 = newWire.getTargetEventName();
		var sourceEvt1 = wire.getSourceEvent().getID();
		var sourceEvt2 = newWire.getSourceEvent().getID();
		var targetEvt1 = wire.getTargetEvent().getID();
		var targetEvt2 = newWire.getTargetEvent().getID();
		if(sourceID1==sourceID2 && targetID1==targetID2 
				&& sourceEvt1==sourceEvt2 && targetEvt1==targetEvt2) {
			return true;
		}
	}
	return false;
};

/**
 * Get all lc on the page
 * @param {Object} pageID
 * @return [] all lc
 */
com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2 = function(pageID) {
	// get layoutControls from the layoutmodel for the page
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
    var currentPage = navModel.find(pageID).start(); 
	var layoutModel = navModel.getLayoutModel(currentPage);
	var widgets = [];
	
	if(layoutModel) {
		var lmRoot = layoutModel.getRoot().start();	
		if (layoutModel.hasChildren(lmRoot)) {
			widgets = com.ibm.mm.builder.utils.wireUtil._findControlInContainer(layoutModel, lmRoot, widgets);
		}
	}
	return widgets;
};

com.ibm.mm.builder.utils.wireUtil._findControlInContainer = function(layoutModel, node, widgets) {
	if(node.getLayoutNodeType() == "LayoutContainer") {
		var _iterator = layoutModel.getChildren(node);
		_iterator.setCursorPosition(0);
		while (_iterator.hasNext()) {
			var childNode = _iterator.next();
			widgets = com.ibm.mm.builder.utils.wireUtil._findControlInContainer(layoutModel, childNode, widgets);
		}
	} else if(node.getLayoutNodeType() == "LayoutControl") {
		widgets.push(node);
	}
	return widgets;
};

// TODO: deprecated
com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts = function(layouts) {
	var widgets = [];
	if(layouts) {
		for(var i = 0; i < layouts.length; i++) {
			//Temp fix for defect 8300, since all layout may call this due to fix on 7931
			try {
				var oneLayout = eval("_" + layouts[i] + "_iContext.scope.getWidgets()");  // JSLINT-IGNORE:
				widgets = widgets.concat(oneLayout);
			}catch(e){
				continue;
			}
	    }
	}
	return widgets;
};

// TODO: deprecated
/**
 * Get all the widgets which contains event that can handle (with match or trasformable payload type) the specify event of this widget
 * @param {string} id: the uid of the widget
 * @param {string} eventName: the event name of the widget's query event
 * @param (Array)  List contains all wrapper widget(layout widget) id
 * @return (Array) widgets: all the widgets object(include their match event)have the match handle events
 */
com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEvents = function(id, eventName,layouts){
    com.ibm.mm.builder.utils.wireUtil.LOGGER.entering("wireUtil: getMatchHandleEvents with " + eventName);
    //Get the widget instance and the event object

	var widgets = [];
    var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
	if (!sourceWrapper) {
		return widgets;
	}
	
    var pubEvent = sourceWrapper.getPublicEvent(eventName);
    
    var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
    
    var len = iwidgetsFromHTMLFragment.length;
   
    var totalWiredEvents = 0;
    // query all other widgets one by one
    // only care about the non-system widget
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
		var iwidgetSpan = dojo.byId(spanId);
        //can not be the same widget
        if (spanId != id && iwidgetSpan.getAttribute("internalWidget") != "true") {
            totalWiredEvents = 0;
            // Get the compare widget instance

			// update the find
            var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
			if (!targetWrapper || targetWrapper.isLoaded() === false) {
				continue;
			}
            var matchedEvents = [];
            var hasMatchEvent = false;
            var wiredEvents = [];
            
            var type = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(spanId);
            // Get all the handle events of the widget 
            var hanEvents = targetWrapper.getWidgetHandledEvents();
			if(hanEvents !== null){
	            for (var n = 0; n < hanEvents.length; n++) {
	                var hanEvent = hanEvents[n];
	                //CHECK PRIVATE
	                if (hanEvent.getAttribute("private") != "true"){
		                var isWired = false;
		                var isMatch = false;
		                // Compare the handel event and the source widget's publish eventpayload type
						var isEventCompatible = com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatible(pubEvent,hanEvent);
		                //if (matchInfo.isAMatch() || matchInfo.canAutoTransform()) { // if the event payload is match
		                if (isEventCompatible) { // if the event payload is match
		                    hasMatchEvent = true;
		                    isMatch = true;
							
		                    var wires = targetWrapper.getWires();
		                    if (wires === null) {
								wires = [];
							}
		                    for (var i = 0; i < wires.length; i++) {
		                        aWire = wires[i];
		                        //if the wire already exist
		                        if (id == aWire.getSourceWidgetID() && eventName == aWire.getSourceEventName() && hanEvent.name == aWire.getTargetEventName()) {
		                            isWired = true;
		                            totalWiredEvents++;
		                            wiredEvents.push(aWire);
		                        }
		                    }
		                }
		                //matchInfo.addExInfo(spanId, type, isMatch, isWired, hanEvent.name, hanEvent.type, hanEvent.description);
						var matchInfo = com.ibm.mm.builder.utils.wireUtil.createMatchEvent(spanId, type, isMatch, isWired, hanEvent.name, hanEvent.type, hanEvent.description);
		                matchedEvents.push(matchInfo);
	                }
	            }
			}
            widgets.push(com.ibm.mm.builder.utils.wireUtil.createMatchWidget(spanId, type, hasMatchEvent, totalWiredEvents, matchedEvents, wiredEvents, targetWrapper.getWires()));
        }
    }
    com.ibm.mm.builder.utils.wireUtil.LOGGER.exiting("wireUtil: getMatchHandleEvents with " + eventName);
    return widgets;
};

// TODO: deprecated
/**
 * Get all send events which can be wired with the given receive event of the given widget
 * @param {string} id: the uid of one widget
 * @param {string} eventName: the receive event name of the widget
 * @param (Array)  List contains all wrapper widget(layout widget) id
 * @return (Array) widgets: all the widgets object(include their match event)have the match sender events
 */
com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEvents = function(id, eventName,layouts){
    com.ibm.mm.builder.utils.wireUtil.LOGGER.entering("wireUtil: getAllMatchPubEvents");
	
    var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
	var widgets = [];
	if (!targetWrapper) {
		return widgets;
	}
    var targetEvent = targetWrapper.getPublicEvent(eventName);
	
	var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
  
    var len = iwidgetsFromHTMLFragment.length;
    
    var wires = targetWrapper.getWires();
    if (wires === null) {
		wires = [];
	}
                 
    // only care about the non-system widget
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
		var iwidgetSpan = dojo.byId(spanId);
        //another widget
        if (spanId != id && iwidgetSpan.getAttribute("internalWidget") != "true") {
            var totalWiredEvents = 0;
            var matchedEvents = [];
            var hasMatchEvent = false;
            var wiredEvents = [];
            var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
			if (!sourceWrapper || sourceWrapper.isLoaded() === false) {
				continue;
			}			
            var type = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(spanId);
            var pubEvents = sourceWrapper.getWidgetPublishedEvents();
			if (pubEvents !== null) {    
	            for (var n = 0; n < pubEvents.length; n++) {
	            	var pubEvent = pubEvents[n];
	            	//CHECK PRIVATE
	                if (pubEvent.getAttribute("private") != "true"){
		                var isWired = false;
		                var isMatch = false;
						var isEventCompatible = com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatible(pubEvent,targetEvent);
		                if (isEventCompatible) { // if the event payload is match
		                    hasMatchEvent = true;
		                    isMatch = true;
		                    for (var i = 0; i < wires.length; i++) {
		                        aWire = wires[i];
		                        //if the wire already exist
		                        if (spanId == aWire.getSourceWidgetID() && pubEvent.name == aWire.getSourceEventName() && eventName == aWire.getTargetEventName()) {
		                            isWired = true;
		                            totalWiredEvents++;
		                            wiredEvents.push(aWire);
		                        }
		                    }
		                }
		                var matchInfo = com.ibm.mm.builder.utils.wireUtil.createMatchEvent(spanId, type, isMatch, isWired, pubEvent.name, pubEvent.type, pubEvent.description);
		                matchedEvents.push(matchInfo);
	                }
	            }
			}
            widgets.push(com.ibm.mm.builder.utils.wireUtil.createMatchWidget(spanId, type, hasMatchEvent, totalWiredEvents, matchedEvents, wiredEvents, sourceWrapper.getWires()));
        }
    }
    com.ibm.mm.builder.utils.wireUtil.LOGGER.exiting("wireUtil: getAllMatchPubEvents");
    return widgets;
};

 /**
 * Create js object contains the widget info
 */
com.ibm.mm.builder.utils.wireUtil.createMatchWidget = function(
		id, type, hasMatchEvent, totalWiredEvents, events, wiredEvents, wires) {
    var widget = {};
    widget.id = id;
    widget.type = type;
    widget.hasMatchEvent = hasMatchEvent;
    widget.totalWiredEvents = totalWiredEvents;
    widget.events = events;
    widget.wiredEvents = wiredEvents;
    widget.receivedWires = wires;
    return widget;
};

/**
* Create js object contains the event info
*/
com.ibm.mm.builder.utils.wireUtil.createMatchEvent = function(
		id, type, isMatch, isWired, eventName, eventType, eventDesc) {
    var event = {};
    event.id = id;
    event.type = type;
    event.isMatch = isMatch;
    event.isWired = isWired;
    event.name = eventName;
    event.payloadType = eventType;
    event.description = eventDesc;
    return event;
};

 /**
 * Create the span which will be stored in microformat for saving the wire info
 */
com.ibm.mm.builder.utils.wireUtil.createWireSpan = function(sourceId, sourceEvent, targetEvent){
    var recEvent = document.createElement("span");
    recEvent.className = com.ibm.mm.builder.constant.receivedEvent;
    
    var srcWidget = document.createElement("a");
    srcWidget.className = com.ibm.mm.builder.constant.iwSourceEvent;
    srcWidget.setAttribute("href", "#" + sourceId);
    srcWidget.innerHTML = sourceEvent;
    
    var tarEvent = document.createElement("span"); //what event will handle the fired event
    tarEvent.className = com.ibm.mm.builder.constant.iwTargetEvent;
    tarEvent.innerHTML = targetEvent;
    
    recEvent.appendChild(srcWidget);
    recEvent.appendChild(tarEvent);
    return recEvent;
};

// TODO: deprecated
 /**
 * This function will be called when one widget is dropped on another and their payloads are match.
 * It will add a wire in memory and update the dom node at same time
 * @param sourceId(String): the dropped widget's id
 * @param targetId(String): the already-in-canvas widget's id
 */
com.ibm.mm.builder.utils.wireUtil.addWireWhenMatch = function(sourceId, targetId){
	
    var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(sourceId);
    if (!sourceWrapper) {
		return false;
	}
    var pubEvents = sourceWrapper.getWidgetPublishedEvents(); //never null, since the events have been checked
    var sourceEventName = pubEvents[0].name;
    
    var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(targetId);
	if (!targetWrapper) {
		return false;
	}
    var hanEvents = targetWrapper.getWidgetHandledEvents(); //never null, since the events have been checked
    //the handle events' names of the target widget 
    var targetEventName = hanEvents[0].name;
    
    var rc = com.ibm.mm.builder.utils.wireUtil.addWire(sourceId, sourceEventName, targetId, targetEventName);
    return rc;
};

// TODO: deprecated
 /**
 * Called by addWireWhenMatch() to add a wire in memory and update the dom node
 */
com.ibm.mm.builder.utils.wireUtil.addWire = function(sourceId, sourceEvent, targetId, targetEvent){ 
	
	var rc = false;
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
	var widgetwrapper = widgetModel.find(targetId);
	if (widgetwrapper !== null){
		var widgetinstance = widgetwrapper.getIWidgetInstance();
		widgetinstance.addWire(sourceId,sourceEvent,targetEvent);
		var deferred = widgetModel.commit();
		deferred.start(false);
		rc = true;
	}	
    return rc;
    
};

// TODO: deprecated
com.ibm.mm.builder.utils.wireUtil.isWireExist = function(sourceId, sourceEvent, targetId, targetEvent){
	
	var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(targetId);
	if (!targetWrapper) {
		return false;
	}
    var targetWires = targetWrapper.getWires();
    var isWireExist = false;
    for(var i = 0; i < targetWires.length; i++) {
    	var wire = targetWires[i];
    	if(sourceId == wire.getSourceWidgetID() && sourceEvent == getSourceEventName() && targetId == getTargetWidgetID() && targetEvent == getTargetEventName()) {
    		isWireExist = true;
    		break;
    	}
    }
    return isWireExist;
};

// TODO: deprecated
/**
 * remove a wire in memory and update the dom node
 */
com.ibm.mm.builder.utils.wireUtil.removeWire = function(sourceId, sourceEvent, targetId, targetEvent){
		
	var rc = false;
	var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
	var widgetwrapper = widgetModel.find(targetId);
	if (widgetwrapper !== null){
		var widgetinstance = widgetwrapper.getIWidgetInstance();
		widgetinstance.removeWire(sourceId,sourceEvent,targetEvent);
		var deferred = widgetModel.commit();
		deferred.start();
		rc = true;
	}	
    return rc;
};

/**
 * Get dataTypeChecker
 */
com.ibm.mm.data.dataTypeChecker = null;
com.ibm.mm.builder.utils.wireUtil.dataTypeChecker =  function() {
	if (com.ibm.mm.data.dataTypeChecker === null) {
		com.ibm.mm.data.dataTypeChecker = new com.ibm.mm.data.datatypes();
	}
	return com.ibm.mm.data.dataTypeChecker;
};

/**
 * Check whether the payload type of two events is compatible
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventCompatible = function(/** Object */ sourceEvent, /** Object */ targetEvent){
    if (sourceEvent === null || targetEvent === null) {
		return false;
	}
	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeMatch(targetEvent.type, sourceEvent.type);
    return result;
};

/**
 * Check whether the payload type of two events is compatible with more flex rules
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatible = function(/** Object */sourceEvent, /** Object */ targetEvent){
	if (sourceEvent === null || targetEvent === null) {
		return false;
	}
	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeFlexMatch(targetEvent.type, sourceEvent.type);
    return result;
};

// TODO: deprecated
/**
 * Check whether the payload type of two widget is compatible
 * @param sourceId(string) : the id of the drop widget
 * @param targetId(string) : the id of the target widget
 */
com.ibm.mm.builder.utils.wireUtil.isWidgetCompatible = function(sourceId, targetId){
	if (sourceId === null || targetId === null || sourceId == targetId) {
		return false;
	}
	var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(targetId);
	if (!targetWrapper) {
		return false;
	}
	var hanEvents = targetWrapper.getWidgetHandledEvents();
	
	var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(sourceId);
	if (!sourceWrapper) {
		return false;
	}
	var pubEvents = sourceWrapper.getWidgetPublishedEvents();
	
    if (pubEvents === null || hanEvents === null || pubEvents.length < 1 || hanEvents.length < 1) {
		return false;
	}
    
	var publishPayloadType = pubEvents[0].type;
	var handlePayloadType = hanEvents[0].type;
    var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeMatch(handlePayloadType, publishPayloadType);
    return result;
};

/**
 * The prototype of checking whether the event is match: 
 * 1) event name is the same; 
 * 2) event payload is the same.
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire = function(/** Object */ sourceEvent, /** Object */ targetEvent){
	if (sourceEvent === null || targetEvent === null){return false;}
    //check the id or name is the same, currently no out-of-box widgets can work if add this condition
    if (sourceEvent.name != targetEvent.name) {return false;}
    if (sourceEvent.type == "any" ||  targetEvent.type == "any" || sourceEvent.type != targetEvent.type) {return false;}
    return true;
	//	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	//	var result = checker.doesTypeFlexMatch(targetEvent.type, sourceEvent.type);
	//    return result;
};

/**
 * The prototype of checking whether the event is match: 
 * 1) event name is the same;
 * 2) event payload is the same
 * 3) payload type of 'any' will not considered as compatible
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowireCSA2 = function(/** Object */sourceEvent, /** Object */ targetEvent){
	if (sourceEvent === null || targetEvent === null)
		return false;
    if (sourceEvent.getName() != targetEvent.getName()) 
		return false;
    if (sourceEvent.getPayloadType() == "any" || targetEvent.getPayloadType() == "any" 
			|| sourceEvent.getPayloadType() != targetEvent.getPayloadType()) 
		return false;
    return true;
};

/**
 * Setup auto wire between newly created auto widget and other existing widgets
 * @param {string} id: the uid of the widget
 */
com.ibm.mm.builder.utils.wireUtil.setupAutoWiring = function(id){
    //Get the widget instance and the event object
	var result = {
		"widgetId": id,
		"hasAutoWire": false,
		"publishTo": [],
		"receiveFrom": []
	};
	
	// TODO: dojo.byId(id).getAttribute("autowiringenabled") != "true"
	var lcId = id;
	var publishTo = {};
	var receiveFrom = {};
	
	var lc = com.ibm.mm.builder.utils.wireUtil.getLayoutControl(lcId);

	var pubEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(lc);
	var hanEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(lc);
	
	var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
	var allWidgets = com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2(pageId);
	var len = allWidgets.length;
	for(var x=0; x<len; x++) {
		var _lc = allWidgets[x];
		if(_lc.getID() != lcId) {	// other widgets
			var widgetAWE = com.ibm.mm.builder.utils.wireUtil.isAutowireEnabled(_lc.getID());
			if(widgetAWE) {	// other widget is also AW enabled
				if(pubEvents != null) {
					var pubEvtNo = pubEvents.length;
					for(var y=0; y<pubEvtNo; y++) {
						var targetWidgetHandledEvts = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(_lc);
						if(targetWidgetHandledEvts != null) {
							for(var n=0; n<targetWidgetHandledEvts.length; n++) {
								var targetHandledEvt = targetWidgetHandledEvts[n];
								var compt = com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowireCSA2(pubEvents[y], targetHandledEvt);
								if(compt) {
									var targetId = _lc.getID();
									com.ibm.mm.builder.utils.wireUtil.addWireCSA2(lcId, pubEvents[y].getName(), targetId, targetHandledEvt.getName());
									result.hasAutoWire = true;
									if(publishTo[targetId] == undefined) {
										result.publishTo.push(targetId);
										publishTo[targetId] = true;
									}					
								}
							}
						}
					}
				}
				if(hanEvents != null) {
					var hanEvtNo = hanEvents.length;
					for(var z=0; z<hanEvtNo; z++) {
						var sourcePubEvts = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(_lc);
						if(sourcePubEvts != null) {
							for(var m=0; m<sourcePubEvts.length; m++) {
								var sourcePubEvt = sourcePubEvts[m];
								var compt = com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowireCSA2(sourcePubEvt, hanEvents[z]);
								if(compt) {
									var sourceId = _lc.getID();
									com.ibm.mm.builder.utils.wireUtil.addWireCSA2(sourceId, sourcePubEvt.getName(), lcId, hanEvents[z].getName());
									result.hasAutoWire = true;
									if(receiveFrom[sourceId] == undefined) {
										result.receiveFrom.push(sourceId);
										receiveFrom[sourceId] = true;
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return result;
};

/**
 * Check whether the widget clicked can be auto-wired with other widgets on page (CSA2)
 * @param {Object} id: LayoutControl/wigdet ID
 * @return {boolean} can autowire or not
 */
com.ibm.mm.builder.utils.wireUtil.checkAutoWiringCSA2 = function(id) {
	// 1. this widget should auto wire enabled
	var awEnable = com.ibm.mm.builder.utils.wireUtil.isAutowireEnabled(id);
	if(!awEnable)
		return false;
	
	var lc = com.ibm.mm.builder.utils.wireUtil.getLayoutControl(id);

	var pubEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(lc);
	var hanEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(lc);
		
	var pageId = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
	var allWidgets = com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2(pageId);
	
	var len = allWidgets.length;
	// 2. check other widgets
	for (var x = 0; x < len; x++) {
		var _lc = allWidgets[x];
		if (_lc.getID() != id) { // other widgets
			var widgetAWEnabled = com.ibm.mm.builder.utils.wireUtil.isAutowireEnabled(_lc.getID());
			if(widgetAWEnabled) {
				if (pubEvents != null) {
					var pubEvtNo = pubEvents.length;
					for (var y = 0; y < pubEvtNo; y++) {
						var targetWidgetHandledEvts = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(_lc);
						if (targetWidgetHandledEvts != null) {
							for (var n = 0; n < targetWidgetHandledEvts.length; n++) {
								var targetHandledEvt = targetWidgetHandledEvts[n];
								var compt = com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowireCSA2(pubEvents[y], targetHandledEvt);
								if(compt) return true;
							}
						}
					}
				}
				if (hanEvents != null) {
					var hanEvtNo = hanEvents.length;
					for (var z = 0; z < hanEvtNo; z++) {
						var sourcePubEvts = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(_lc);
						if (sourcePubEvts != null) {
							for (var m = 0; m < sourcePubEvts.length; m++) {
								var sourcePubEvt = sourcePubEvts[m];
								var compt = com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowireCSA2(sourcePubEvt, hanEvents[z]);
								if (compt) return true;
							}
						}
					}
				}
			}
		}
	}
	return false;
};

// TODO: deprecated
/**
 * Check if the new created widget can be auto wired to other existing widgets on the page.
 * @param {string} id: the uid of the widget
 */
com.ibm.mm.builder.utils.wireUtil.checkAutoWiring = function(id){
		
    //Get the widget instance and the event object
	if (dojo.byId(id) === null || dojo.byId(id).getAttribute("autowiringenabled") != "true") {
		return false;
	}
	
    var widgetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
    var pubEvents = widgetWrapper.getWidgetPublishedEvents();
    var hanEvents = widgetWrapper.getWidgetHandledEvents();
    
    var themeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentTheme();
    var layouts = themeModel.getLayouts();
    var iwidgetsFromHTMLFragment = com.ibm.mm.builder.utils.wireUtil.getAllWidgetsInLayouts(layouts);
    
    var len = iwidgetsFromHTMLFragment.length;
    
    for (var x = 0; x < len; x++) {
        var spanId = iwidgetsFromHTMLFragment[x];
        //can not be the same widget
        if (spanId != id) {
            // Get the compare widget instance
        	var iwidgetSpan = dojo.byId(spanId);
        	if(iwidgetSpan.getAttribute("autowiringenabled") == "true" && iwidgetSpan.getAttribute("internalWidget") != "true") {
	            var targetWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(spanId);
	            if(pubEvents !== null) {
		            for(var y = 0; y < pubEvents.length; y++) {
		            	// Get all the handle events of the widget 
			            var targetHanEvents = targetWrapper.getWidgetHandledEvents();
						if (targetHanEvents !== null){
				            for (var n = 0; n < targetHanEvents.length; n++) {
				                var targetHanEvent = targetHanEvents[n];
				                // Compare the handle event and the source widget's publish event name and payload type
								if (com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire(pubEvents[y],targetHanEvent)){
									return true;
								}
				            }//end for
						}//end if
		            }
	            }//end if pubEvents
	            if(hanEvents !== null) {
		            for(var z = 0; z < hanEvents.length; z++) {
		            	// Get all the handle events of the widget 
			            var sourcePubEvents = targetWrapper.getWidgetPublishedEvents();
						if (sourcePubEvents !== null){
				            for (var m = 0; m < sourcePubEvents.length; m++) {
				                var sourcePubEvent = sourcePubEvents[m];
				                // Compare the handle event and the source widget's publish event name and payload type
								if (com.ibm.mm.builder.utils.wireUtil.isEventCompatibleForAutowire(sourcePubEvent, hanEvents[z])){
									return true;
								}
				            }//end for
						}//end if
		            }
	            }//end if hanEvents
        	}// end if getAttribute("autowiring") == true
        }
    }
    return false;
};

/**
 * @param {Object} layoutControl
 * @return [] events
 */
com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2 = function(layoutControl){
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start(); 
	   
	// query events
	var hierEventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
	var filter = new Object();
    filter[com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS] = true;
	var hierEvents = hierEventProvider.getEvents(filter);
	return hierEvents;	
};

/**
 * @param {Object} layoutControl
 * @return [] events
 */
com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2= function(layoutControl) {
	//return a reference of events array
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start(); 
	   
	// query events
	var hierEventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
	var filter = new Object();
    filter[com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS] = true;
    var hierEvents = hierEventProvider.getEvents(filter);
	return hierEvents;	
};

// TODO: need refactor
/**
 * Get all matching published events for the given widget's handled event
 * @param {Object} layoutControl
 * @param {String} eventName
 * @param {String} pageID
 * @param {Object} matchingType
 */
com.ibm.mm.builder.utils.wireUtil.getAllMatchPubEventsCSA2 = function(layoutControl, eventName, pageID, matchingType){
    com.ibm.mm.builder.utils.wireUtil.LOGGER.entering("wireUtil: getAllMatchPubEventsCSA2");
    
	var widgets = [];
	if (!layoutControl) {
		return widgets;
	}
	
	//Find associated models
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
    var currentPage = navModel.find(pageID).start(); 
	var lm = navModel.getLayoutModel(currentPage);
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start(); 
	var eventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
    // Find target event
	//var targetEvent = eventProvider.getEvent(eventName);
	var targetEvent = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
			eventProvider, eventName, com.ibm.mashups.enabler.widget.Constants.FILTER_HANDLED_EVENTS);
	
	var layoutControls = com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2(pageID);
    var len = layoutControls.length;
    
    // only care about the non-system widget
    for (var x = 0; x < len; x++) {
        var otherLc = layoutControls[x];
		var otherWindow = widgetModel.getWidgetWindow(otherLc).start();
        if (otherLc != layoutControl ) {
            var totalWiredEvents = 0;
            var matchedEvents = [];
            var hasMatchEvent = false;
            var wiredEvents = [];
//			var widgetWindow = widgetModel.getWidgetWindow(otherLc).start(); 
//			var widgetDef = widgetModel.getWidgetDefinitionByWindow(widgetWindow).start(); 
//          var type = widgetDef.getTitle(ibmConfig["default.locale"]);
			var type = otherLc.getTitle(dojo.locale);
            if (!type) {
                var widgetDef = widgetModel.getWidgetDefinitionByWindow(otherWindow).start(); 
                type = widgetDef.getTitle(dojo.locale);
            }
					
            var pubEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetPublishedEventsCSA2(otherLc);
			if (pubEvents !== null) {    
	            for (var n = 0; n < pubEvents.length; n++) {
	            	var pubEvent = pubEvents[n];
	            	//CHECK PRIVATE 
					
//	                if (pubEvent.getAttribute("private") != "true"){ 
		                var isWired = false;
		                var isMatch = false;
						var isEventCompatible = com.ibm.mm.builder.utils.wireUtil
							.isEventCompatibleCSA2(pubEvent,targetEvent,matchingType);
		                if (isEventCompatible) { // if the event payload is match
		                    hasMatchEvent = true;
		                    isMatch = true;
							//Remove the following 3 lines, no need to find the wires again
							var wires = com.ibm.mm.builder.utils.wireUtil.getWiresSourceCSA2(otherLc, pageID);
                            if (wires === null) {
								wires = [];
							}						
							
		                    for (var i = 0; i < wires.length; i++) {
		                       var aWire = wires[i];
		                       //if the wire already exist
							   // TODO: should compare by name
		                        if (otherWindow.getID() == aWire.getSourceWidget().getID() && 
									widgetWindow.getID() == aWire.getTargetWidget().getID() &&
//                                  pubEvent.getName() == aWire.getSourceEventName() && 
//                                  targetEvent.getName() == aWire.getTargetEventName()
									pubEvent.getID() == aWire.getSourceEvent().getID() && 
                                    targetEvent.getID() == aWire.getTargetEvent().getID()
									) {
									
		                            isWired = true;
		                            totalWiredEvents++;
		                            wiredEvents.push(aWire);
		                        }
		                    }
		                }
		                var matchInfo = com.ibm.mm.builder.utils.wireUtil.createMatchEvent(
							otherLc.getID(), type, isMatch, isWired, pubEvent.getName(), pubEvent.getPayloadType(), pubEvent.getDescription(ibmConfig["default.locale"]));
		                matchedEvents.push(matchInfo);
//	                } 
	            }
			}
			var sourceWires = com.ibm.mm.builder.utils.wireUtil.getWiresSourceCSA2(otherLc, pageID);
            widgets.push(com.ibm.mm.builder.utils.wireUtil.createMatchWidget(
				otherLc.getID(), type, hasMatchEvent, totalWiredEvents, matchedEvents, wiredEvents, sourceWires));
        }
    }
    com.ibm.mm.builder.utils.wireUtil.LOGGER.exiting("wireUtil: getAllMatchPubEvents");
    return widgets;
};

com.ibm.mm.builder.utils.wireUtil.getPublicEventCSA2= function(layoutControl, eventName){
	//return a reference of events array
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start(); 
	
	var hierEventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
	var filter = null;
	var hierEvents = hierEventProvider.getEvents(filter);
	
	if (hierEvents && hierEvents !== null){
		var handledEvents = [];
		for (var i = 0; i < hierEvents.length; i++) {
			if (hierEvents[i].isHandled()) {
				handledEvents.push(hierEvents[i]);
			}
		}
		return handledEvents;
	}	
	return null;	
};
	
	
com.ibm.mm.builder.utils.wireUtil.getWiresTargetCSA2= function(layoutControl, pageID){
	//return a reference of events array
   // get Models
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	var currentPage = navModel.find(pageID).start(); 
	var lm = navModel.getLayoutModel(currentPage);
	var wireModel = lm.getWireModel();
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
	
	// get wires
	var wires = [];
	// TODO: replace with find on WireModel
	var wireIter = wireModel.iterator();
	if (wireIter !== null) {
		wireIter.setCursorPosition(0);
		while(wireIter.hasNext()) {
			var wireNode = wireIter.next();
			// Need to see if this wire has the current widgetWindow as target
			if (wireNode.getTargetWidget().getID() == widgetWindow.getID()) {
				wires.push(wireNode);
			}
		}
		return wires;
	} 
	return null;	
};
	
com.ibm.mm.builder.utils.wireUtil.getWiresSourceCSA2= function(layoutControl, pageID){
	//return a reference of events array
	// get Models
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
	var currentPage = navModel.find(pageID).start(); 
	var lm = navModel.getLayoutModel(currentPage);
	var wireModel = lm.getWireModel();
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
	
	// get wires
	var wires = [];
	// TODO: replace with find on WireModel
	var wireIter = wireModel.iterator();
	if (wireIter !== null) {
		wireIter.setCursorPosition(0);
		while(wireIter.hasNext()) {
			var wireNode = wireIter.next();
			// Need to see if this wire has the current widgetWindow as source
			if (wireNode.getSourceWidget().getID() == widgetWindow.getID()) {  				
				wires.push(wireNode);
			}
		}
		return wires;
	} 
	return null;	
};	
	
/**
 * Check whether the payload type of two events is compatible with more flex rules
 * @param sourceEvent(Object) : the publishEvent of the drop widget
 * @param targetEvent(Object) : the handleEvent of the underlay widget
 */
com.ibm.mm.builder.utils.wireUtil.isEventFlexCompatibleCSA2 = function(/** Object */ sourceEvent, /** Object */ targetEvent){
    if (sourceEvent === null || targetEvent === null) {
		return false;
	}
	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeFlexMatch(targetEvent.getPayloadType(), sourceEvent.getPayloadType());
    return result;
};

com.ibm.mm.builder.utils.wireUtil.isEventCompatibleByName = function ( sourceEvent, targetEvent ) {
	if ( sourceEvent === null || targetEvent === null ) {
		return false;
	}
	result = ( sourceEvent.getName() === targetEvent.getName() );
	return result;
};

com.ibm.mm.builder.utils.wireUtil.isEventCompatibleByPayloadType = function(/** Object */ sourceEvent, /** Object */ targetEvent){
    if (sourceEvent === null || targetEvent === null) {
		return false;
	}
	var checker = com.ibm.mm.builder.utils.wireUtil.dataTypeChecker();
	var result = checker.doesTypeFlexMatch(targetEvent.getPayloadType(), sourceEvent.getPayloadType());
    return result;
};

com.ibm.mm.builder.utils.wireUtil.isEventCompatibleCSA2 = function ( /* Object*/ sourceEvent, targetEvent, matchingType ) {
	var wireUtil = com.ibm.mm.builder.utils.wireUtil;
	
	var constants = {
		SEMANTIC_TYPES_ONLY: 0,
		PAYLOAD_TYPES_ONLY: 1,
		SEMANTIC_OR_PAYLOAD_TYPES: 2
	};
	
	var result = false;
	
	if ( matchingType === constants.SEMANTIC_TYPES_ONLY ) {
		result = wireUtil.isEventCompatibleByName( sourceEvent, targetEvent ); 
	} else if ( matchingType === constants.PAYLOAD_TYPES_ONLY ) {
		result = wireUtil.isEventCompatibleByPayloadType( sourceEvent, targetEvent );
	} else {
		result = ( wireUtil.isEventCompatibleByName( sourceEvent, targetEvent ) ||
			wireUtil.isEventCompatibleByPayloadType( sourceEvent, targetEvent ) );
	}
	
	return result;
};

// TODO: need refactor
/**
 * Get all the widgets which contains event that can handle (with match or trasformable payload type) the specify event of this widget
 * @param {string} id: the uid of the widget
 * @param {string} eventName: the event name of the widget's query event
 * @param (Array)  List contains all wrapper widget(layout widget) id
 * @return (Array) widgets: all the widgets object(include their match event)have the match handle events
 */
com.ibm.mm.builder.utils.wireUtil.getAllMatchHandleEventsCSA2 = function(layoutControl, eventName,pageID, matchingType){
    com.ibm.mm.builder.utils.wireUtil.LOGGER.entering("wireUtil: getMatchHandleEvents with " + eventName);
    //Get the widget instance and the event object

	var widgets = [];
	// layout  
    //   var sourceWrapper = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(id);
	if (!layoutControl) {
		return widgets;
	}
	
	var navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
    var currentPage = navModel.find(pageID).start(); 
	var lm = navModel.getLayoutModel(currentPage);
	var widgetModel = com.ibm.mashups.enabler.widget.Factory.getWidgetModel();
	var wireModel = lm.getWireModel();
	
	// get widgetWindow
	var widgetWindow = widgetModel.getWidgetWindow(layoutControl).start();
    var eventProvider = widgetModel.getHierarchicalEventProvider(widgetWindow).start();
    // Find target event
    //var pubEvent = eventProvider.getEvent(eventName);
	var pubEvent = com.ibm.mm.builder.utils.wireUtil.getEventByNameAndType(
			eventProvider, eventName, com.ibm.mashups.enabler.widget.Constants.FILTER_PUBLISHED_EVENTS);
	
	var layoutControls = com.ibm.mm.builder.utils.wireUtil.getAllLayoutControlsCSA2(pageID);
    var len = layoutControls.length;
   
    var totalWiredEvents = 0;
	
	// Get wires for target layoutcontrol
	var targetWires = wireModel.findByTargetWidget(widgetWindow.getID()).start(true);
    if (targetWires === null) {
		targetWires = [];
	}
	
    // query all other widgets one by one
    // only care about the non-system widget
    for (var x = 0; x < len; x++) {
        var otherLc = layoutControls[x];
		var otherWindow = widgetModel.getWidgetWindow(otherLc).start();
        //can not be the same widget
        if (otherLc != layoutControl) {
             totalWiredEvents = 0;
            // Get the compare widget instance
			// update the find
            
            var matchedEvents = [];
            var hasMatchEvent = false;
            var wiredEvents = [];
			
//			var spanWidgetWindow = widgetModel.getWidgetWindow(otherLc).start(); 
//			var spanWidgetDef = widgetModel.getWidgetDefinitionByWindow(spanWidgetWindow).start(); 
//          var type = spanWidgetDef.getTitle(ibmConfig["default.locale"]);
			var type = otherLc.getTitle(dojo.locale);
            if (!type) {
                var widgetDef = widgetModel.getWidgetDefinitionByWindow(otherWindow).start(); 
                type = widgetDef.getTitle(dojo.locale);
            }
			
            // Get all the handle events of the widget 
            var hanEvents = com.ibm.mm.builder.utils.wireUtil.getWidgetHandledEventsCSA2(otherLc);
			if(hanEvents !== null){
	            for (var n = 0; n < hanEvents.length; n++) {
	                var hanEvent = hanEvents[n];
	                //CHECK PRIVATE
//	                if (hanEvent.getAttribute("private") != "true"){   
		                var isWired = false;
		                var isMatch = false;
		                // Compare the handel event and the source widget's publish eventpayload type
						var isEventCompatible = com.ibm.mm.builder.utils.wireUtil.isEventCompatibleCSA2(pubEvent,hanEvent,matchingType);
		                //if (matchInfo.isAMatch() || matchInfo.canAutoTransform()) { // if the event payload is match
		                if (isEventCompatible) { // if the event payload is match
		                    hasMatchEvent = true;
		                    isMatch = true;
							var wires = wireModel.findByTargetWidget(otherWindow.getID()).start(true);							
		                    if (wires === null) {
								wires = [];
							}
		                    for (var i = 0; i < wires.length; i++) {
		                        aWire = wires[i];
		                        //if the wire already exist
		                        if (otherWindow.getID() == aWire.getTargetWidget().getID() && 
								  widgetWindow.getID() == aWire.getSourceWidget().getID() &&
                                  //pubEvent.getName() == aWire.getSourceEventName() && 
                                  //hanEvent.getName() == aWire.getTargetEventName()
								  pubEvent.getID() == aWire.getSourceEvent().getID() && 
                                  hanEvent.getID() == aWire.getTargetEvent().getID()
								  ) {

		                            isWired = true;
		                            totalWiredEvents++;
		                            wiredEvents.push(aWire);
		                        }
		                    }
		                } 
		                //matchInfo.addExInfo(otherLc, type, isMatch, isWired, hanEvent.name, hanEvent.type, hanEvent.description);
					
						var matchInfo = com.ibm.mm.builder.utils.wireUtil.createMatchEvent(
							otherLc.getID(), type, isMatch, isWired, hanEvent.getName(), hanEvent.getPayloadType(), hanEvent.getDescription(ibmConfig["default.locale"]));
		                matchedEvents.push(matchInfo);
	        //        }   
	            }
			}

            widgets.push(com.ibm.mm.builder.utils.wireUtil.createMatchWidget(
				otherLc.getID(), type, hasMatchEvent, totalWiredEvents, matchedEvents, wiredEvents, targetWires));
        }
    }
    com.ibm.mm.builder.utils.wireUtil.LOGGER.exiting("wireUtil: getMatchHandleEvents with " + eventName);
	return widgets;
};

}
