// functions referenced by action menus
dojo.provide("com.ibm.pb.contextMenu.sharedActions");

dojo.require("com.ibm.pb.iwidget.control");
dojo.require("com.ibm.pb.extension.Operations");
dojo.require("com.ibm.pb.layout.LayoutParser");

(function(){
	
var enabler = com.ibm.mashups.enabler,
	builder = com.ibm.mashups.builder,
	iwidgetControl = com.ibm.pb.iwidget.control,
	runtimeModel = builder.model.Factory.getRuntimeModel(),
	eventService = com.ibm.mashups.services.ServiceManager.getService("eventService"),
	navModel = enabler.navigation.Factory.getNavigationModel(),
	allowedOpsModel = enabler.ac.operation.AllowedOperationsModelFactory.getAllowedOperationsModel(),
	pbOperations = com.ibm.pb.extension.Operations,
	navStateModelFactory = enabler.model.state.NavigationStateModelFactory,
	accessorFactory = enabler.model.state.AccessorFactory,
	layoutParser = com.ibm.pb.layout.LayoutParser,
	localizedContext = enabler.context.Factory.getLocalizedContext();

var ctxMenus = {
	/** CONTENT SHELF **/
	confirmShowAddContent: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		// Cannot show Add Content when:
		//		1. the user does not have edit access to the page
		//		2. there is a maximized widget on the page
		//		3. the page has a legacy layout
		if(!ctxMenus.canEditPage(currentPageID)) { return false; }
		else if(_someObject.isMaximized) { return false; }
		else if(ctxMenus.isLegacyPage(currentPageID,_someObject.layoutMetadataKey,_someObject.layoutFileMetadataKey)) { return false; }
		else { return true; }
	},
	confirmShowChangeStyle: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		// Cannot show Change Style when:
		//		1. the user does not have edit access to the page
		//		2. the user does not have editor access to the page
		var page = navModel.find(currentPageID).start();
		if(!ctxMenus.canEditPage(currentPageID)) { return false; }
		else if(!page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) { return false; }
		else { return true; }
	},
	confirmShowChangeLayout: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		// Cannot show Change Layout when:
		//		1. the user does not have edit access to the page
		//		2. there is a maximized widget on the page
		//		3. the user does not have editor access to the page
		//		4. the page has a legacy layout
		var page = navModel.find(currentPageID).start();
		if(!ctxMenus.canEditPage(currentPageID)) { return false; }
		else if(_someObject.isMaximized) { return false; }
		else if(!page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) { return false; }
		else if(ctxMenus.isLegacyPage(currentPageID,_someObject.layoutMetadataKey,_someObject.layoutFileMetadataKey)) { return false; }
		else { return true; }
	},
	showAddContent: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		if(!ibmCfg.controllers.addContent){
			var maxLabelLength = ibmConfig.fontSizeEnlarged ? _someObject.maxLabelLengthLarge : _someObject.maxLabelLength;
			var acConfig = ibmPortalConfig.isWcmPresent ? _someObject.addContentWCM : _someObject.addContent;
			var widgetModel = enabler.widget.Factory.getWidgetModel();
			ibmCfg.controllers.addContent = new com.ibm.pb.customize.AddContentPaletteContainer({
				logger: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.AddContentController"),
				smallWidget: true,
				draggable: true,
				dndType: "sm",
				numRows: ibmCfg.portalConfig.portalContext ? 3 : 4,
				maxLabelLength: maxLabelLength,
				imagePath: _someObject.imagePath,
				blankImg: _someObject.blankImg,
				jsonFile: acConfig,
				allowedListJsonFile: _someObject.addContentAllowed,
				navModel: navModel,
				widgetModel: widgetModel
			}, document.createElement("div"));
		}
		return ibmCfg.controllers.addContent;
	},
	showChangeStyle: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		if(!ibmCfg.controllers.changeStyle){
			var page = navModel.find(currentPageID).start(),
				url = page.getMetaData(_someObject.styleMetadataKey);
			var itemLimit = 9;
			if (ibmCfg.portalConfig && ibmCfg.portalConfig.portalContext){
				itemLimit = 16;
			}
			var style = (url) ? url.substring(url.lastIndexOf("/")+1) : _someObject.pageDefaultStyle;
			var maxLabelLength = ibmConfig.fontSizeEnlarged ? _someObject.maxLabelLengthLarge : _someObject.maxLabelLength;
			ibmCfg.controllers.changeStyle = new com.ibm.pb.customize.ChangeStylePaletteContainer({
				logger: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.ChangeStyleController"),
				currentSet: style,
				itemLimit: itemLimit, 
				numRows: 2,
				maxLabelLength: maxLabelLength,
				jsonFile: _someObject.changeStyle,
				imagePath: _someObject.imagePath,
				navModel: navModel
			}, document.createElement("div"));
			dojo.subscribe("com.ibm.pb.customize.pageStyleChanged", function(url) {
				var style = (url) ? url.substring(url.lastIndexOf("/")+1) : _someObject.defaultStyle;
				ibmCfg.controllers.changeStyle.currentSet = ibmCfg.controllers.changeStyle.current = style;
				if(ibmCfg.controllers.changeStyle.started) { dojo.hitch(ibmCfg.controllers.changeStyle, "changeSelected", style)(); }
			});
		}
		return ibmCfg.controllers.changeStyle;
	},
	showChangeLayout: function (currentPageID,somepassedinResourceType,_metadata,_someObject) {
		var page = navModel.find(currentPageID).start(),
			content = page.getContent().start(),
			url = content.getMetaData(_someObject.layoutMetadataKey);
		var layout = _someObject.defaultLayout;
		if(url){
			if(url.lastIndexOf("/") == url.length-1) { url = url.substring(0,url.length-1); } 
			layout = url.substring(url.lastIndexOf("/")+1);
		}
		if(!ibmCfg.controllers.changeLayout){
			var maxLabelLength = ibmConfig.fontSizeEnlarged ? _someObject.maxLabelLengthLarge : _someObject.maxLabelLength;
			var itemLimit = 9;
			if (ibmCfg.portalConfig && ibmCfg.portalConfig.portalContext){
				itemLimit = 16;
			}
			ibmCfg.controllers.changeLayout = new com.ibm.pb.customize.ChangeLayoutPaletteContainer({
				logger: com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.pb.customize.enabler.ChangeLayoutController"),
				currentSet: layout,
				itemLimit: itemLimit, 
				numRows: 2,
				maxLabelLength: maxLabelLength,
				jsonFile: _someObject.changeLayout,
				imagePath: _someObject.imagePath,
				navModel: navModel
			}, document.createElement("div"));
		} else {
			ibmCfg.controllers.changeLayout.currentSet = ibmCfg.controllers.changeLayout.current = ibmCfg.controllers.changeLayout.current = layout; 
			if(ibmCfg.controllers.changeLayout.started) { dojo.hitch(ibmCfg.controllers.changeLayout, "changeSelected", layout)(); }
		}
		return ibmCfg.controllers.changeLayout;
	},
	hasAllowedPortletsList: function(pageId){
		// summary: returns true if the page has an allowed portlets list
		var page = navModel.find(pageId).start(),
			layout = navModel.getLayoutModel(page.getID()),
			root = layout.getRoot().start(),
			xml = root.getXml(),
			expr = '//*[model:allPortletsAllowed="false"]';
		return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
			atom: "http://www.w3.org/2005/Atom",
			model: "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements"
		});
	},
	    isLegacyPage: function(pageId,layoutMetadataKey,layoutFileMetadataKey){
        // summary: returns true if the page has a legacy layout and false otherwise
        if(pageId){
            var page = navModel.find(pageId).start();
            if(page.getNavigationElementType() === com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
                page = page.getContent().start();
            }
            var hasStaticXml = true;
            if(ibmCfg.portalConfig.portalContext) {
                hasStaticXml = com.ibm.mashups.enabler.xml.XPath.evaluateBoolean (
                    "//model:static-content-page",
                    page.getXml(),
                    { atom: "http://www.w3.org/2005/Atom", model: "http://www.ibm.com/xmlns/prod/websphere/portal/v6.0.1/portal-model-elements" }
                );
            }
            if(!page) { return true; }
            else if((page.getMetaData(layoutFileMetadataKey) || page.getMetaData(layoutMetadataKey)) && hasStaticXml) { return false; }
            else { return true; }
        } else { return true; }
    },
	isStaticPage: function(pageId){
		// summary: returns true if the page has a legacy layout and false otherwise
		if(pageId){
			var page = navModel.find(pageId).start();
			if(!page) { return true; }
			if(page.getMetaData("com.ibm.portal.static.page.file.name.html")) { return true; }
		} 
		return false; 
				
	},
	canEditPage: function(pageId){
		// summary: returns true if the user can edit the current page
		if(pageId){
			page = navModel.find(pageId).start();
			if(!page) { return false; }
			if(page.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || 
				page.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) ||
				page.hasRole("Privileged User")){
				return true;
			} else { return false; }
		} else { return false; }
	},
	/** PAGE: EDIT **/
	confirmAdvancedActions: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		currentContentID = ctxMenus.getContentId(currentPageID);
	    return ( ctxMenus.isOperationAllowed(enabler.ac.operation.Constants.EDIT_LAYOUT, {contentNode: currentContentID}) ||
	        ctxMenus.isOperationAllowed(enabler.ac.operation.Constants.EDIT_PROPERTIES, {contentNode: currentPageID}) ||
			ctxMenus.confirmEditPageProperties(currentPageID,somepassedinResourceType, {operation:enabler.ac.operation.Constants.EDIT_PROPERTIES},_someObject) );
	},
	confirmEditPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		if (!ctxMenus.isAuthenticated) return false;
		var page = navModel.find(currentPageID).start(), ret = false;
		var type = page.getNavigationElementType();
		if (type == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) {
			if(page.getContent) {
				if (ctxMenus.isStaticPage(currentPageID)) {
					var sc = page.getContent().start();
					ret = sc.confirmSetStaticMarkup("");
				}
				else {
					ret = ctxMenus.canEditPage(currentPageID);
				}
			}
		}	
		return ret;	
	},
	
	isEditActive: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		//not used b/c if isEditActive = true, "Edit" will show up even if confirmEditPage = false
		return (runtimeModel.getCurrentPage().getPageMode() != "edit");
	},
	editPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    // broadcasts the changePageMode ievent with an edit payload
        var userModel = enabler.user.Factory.getUserModel();
	    if (userModel.getAnonymousMode() != enabler.user.AnonymousMode.ANONYMOUS &&
	        runtimeModel.getCurrentPage().getPageMode() != "edit") {
	    		/* If the rendering controller exists and is in place, delegate mode changes to it */
	    		var controller = dojo.getObject("ibmCfg.controllers.rendering");
	    		if(controller) {
	    			controller.changePageMode("edit");
	    		}
	            else {
	            	eventService.broadcastEvent("com.ibm.mashups.builder.changePageMode", mode);
					runtimeModel.getCurrentPage().setPageMode(mode);
	            }
	    }
	},
	isOperationAllowed: function(operation, jsonContext) {
        if(jsonContext && typeof jsonContext.contentNode == "string"){
            var page = navModel.find(jsonContext.contentNode).start();
            jsonContext.contentNode = page.getContent().start();
        }
		return allowedOpsModel.getOperation(operation,jsonContext).start().isAllowed();
	},
	confirmOperation: function(ID,somepassedinResourceType, _metadata,_someObject){
		var mapping = {id: ID};
		if(!somepassedinResourceType || somepassedinResourceType == "com.ibm.mashups.enabler.navigation.NavigationNode") {
			mapping.navID = ID;
		}
		else {
			mapping.navID = runtimeModel.getCurrentPage().getID();
		}
		//mapping.contentID = ctxMenus.getContentId(mapping.navID);
		if(_metadata.operation == com.ibm.mashups.enabler.ac.operation.Constants.EDIT_PROPERTIES) { mapping.contentID = mapping.navID; }  // always use the navigation node id when checking permission for Edit Page Properties
		var jsonContext = ctxMenus.replaceMapVars(mapping, _metadata.jsonContext);
		return ctxMenus.isOperationAllowed(_metadata.operation,jsonContext);
	},
	confirmEditPageProperties: function(ID,somepassedinResourceType, _metadata,_someObject){
		var page = navModel.find(ID).start();
		var mapping = {id:ID,navID:ID,contentID:ID,contentNode:page};
		return allowedOpsModel.getOperation(_metadata.operation,mapping).start().isAllowed();
	},
	confirmChangeLayout: function(ID,somepassedinResourceType, _metadata,_someObject){
		var page = navModel.find(ID).start();
		if(!page.getContent) { return false; }
		var content = page.getContent().start();
		if(content.getMetaData("com.ibm.portal.layout.template.ref") || page.getMetaData("com.ibm.portal.static.page.file.name.html")){
			return false;
		} else {
			return ctxMenus.confirmOperation(ID,somepassedinResourceType, _metadata,_someObject);
		}
	},
	confirmAssignPermissions: function(ID,somepassedinResourceType, _metadata,_someObject){
		var page = navModel.find(ID).start();
		var type = page.getNavigationElementType();
		if (type != com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE) { return false; }
		return ctxMenus.confirmOperation(ID,somepassedinResourceType, _metadata,_someObject);
	},
	/** PAGE: TAGGING AND RATING **/
	confirmTagAndRatePage: function(currentPageID,somepassedinResourceType, _metadata,_someObject){
		return true;
	},
	confirmCPAction: function(resourceId, resourceType, metadata, someObject){
		/*
		 * For this to work, the metadata.metadataName must be in the node.  If it's hidden
		 * for some reason, it should have been added to the hidden metadata loading strategy
		 * for that model.
		 */
		var configCheck = metadata.configCheck,
			resourceCheck = false,
			node = null;
		
		if (configCheck) {
			if(resourceType === "com.ibm.mashups.enabler.navigation.NavigationNode") {
				node = navModel.find(resourceId).start();
			}
			else if(resourceType === "com.ibm.mashups.iwidget.widget.IWidgetDefinition") {
				var nsm = navStateModelFactory.getNavigationStateModel();
				var spaceId = accessorFactory.getSpaceAccessor(nsm).getSpaceID();
				var pageAccessor = accessorFactory.getPageAccessor(nsm, spaceId);
				var currentPageID = pageAccessor.getPageID();
				var currentPage = navModel.find(currentPageID).start();
				var layoutModel = navModel.getLayoutModel(currentPage); 			
				node = layoutModel.find(resourceId).start();
			}
			else {
				console.warn("resourceType %o is not valid for a CP action", resourceType);
				return;
			}
			
			var scope = node.getMetaData(metadata.metadataName); 
			resourceCheck = scope !== "true";
		}
		return (configCheck && resourceCheck);
	},
	confirmbrowseTags: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    return true;
	},
	browseTags: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
    	var params = {};
    	params.uri = "tm:browsetags";
    	params.rmparam = "rm:oid:" + currentPageID;
    	var url = ctxMenus.createURL( currentPageID, params );
    	
    	ctxMenus.savePageChecker(function(){top.location.href = url;});
	},
	/** PAGE: SHARING **/
	confirmSharing: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    return ( ctxMenus.confirmAddSharedPages(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
			ctxMenus.confirmSharePage(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
	        ctxMenus.isOperationAllowed(enabler.ac.operation.Constants.ASSIGN_ROLES, {contentNode: currentPageID}));
	},
	confirmSharePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
        if (!currentPageID) { return false; }
        if (!navModel.hasLayoutModel(currentPageID)) { return false; }
		return ctxMenus.isPrivatePage(currentPageID) && ctxMenus.isPageOwner(currentPageID);
	},
	sharePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var node = navModel.find(currentPageID).start();
		try {
			var nodeLocale = localizedContext.getLocale(node);
		} catch (e) { //this exception is thrown out when node is created by builder
		}
		var pageName = node.getTitle(nodeLocale || dojo.locale) || node.getTitle(ibmConfig["default.locale"]) || "";          	
		var title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_ACL_DIALOG_TITLE, [pageName]);
		ctxMenus.showInShareDialog(currentPageID, title);
    },
	assignPagePermissions: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var title = dojo.i18n.getLocalization("com.ibm.bundles", "Theme")["assignPagePermissions_title"];
		ctxMenus.showInShareDialog(currentPageID, title);
	},
	showInShareDialog: function (currentPageID, title){
		var payload = {
			widgetTypeId: "sharePage",
			eventName:  "com.ibm.mashups.builder.sharePage",
			eventPayload:  currentPageID,
			requestRefresh: true,
			dialogParam: {
				title: title.replace(/&/g,"&amp;").replace(/"/g,"&quot;").replace(/</g,"&lt;").replace(/>/g,"&gt;"),
				nodeWidth: "774px",
				hasRightBottomResizer: false
			}
		};
		ctxMenus.savePageChecker(function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
		}, function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage",currentPageID);
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
		});
    },
	confirmAddSharedPages: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var parent = navModel.find(ibmConfig.sharedPagesParent).start();
		if(parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR) || parent.hasRole("Privileged User")) { return true; }
		return false;
	},
	addSharedPages: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		dojo.require("dojo.i18n");
		dojo.requireLocalization("com.ibm.bundles", "Theme");
		nlsBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		var title = nlsBundle["theme_add_pages_shared"];
		var dialogParam = {
			nodeWidth: "600px",
			containerBackgroundColor: "white",
			hasLeftBottomResizer: false,
			hasRightBottomResizer: false,
			title: title
		};
			var payload = {
			widgetTypeId: "viewMorePage",
			eventName: "com.ibm.mashups.builder.viewMorePage",
			eventPayload: "",
			dialogParam: dialogParam,
			requestRefresh: true
		};
		ctxMenus.savePageChecker(function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload); 
		}, function(){
			eventService.broadcastEvent("com.ibm.mashups.builder.switchPage",currentPageID);
			eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload); 
		});
    },
	/** PAGE: ACTIONS **/
	confirmPageActions: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    return ( ctxMenus.confirmMovePage(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
	        ctxMenus.confirmDeletePage(currentPageID,somepassedinResourceType, _metadata,_someObject) ||
			ctxMenus.confirmCreatePage(currentPageID,somepassedinResourceType, _metadata,_someObject) );
	},
	confirmCreatePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var currentNavNode = navModel.find(currentPageID).start();
		return allowedOpsModel.getOperation(pbOperations.CREATE_PAGE,{navNode: currentNavNode}).start().isAllowed();
	},
	createPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		ctxMenus.savePageChecker(function(){
			iwidgetControl.onLoad(_metadata && _metadata.widgetId, function(){
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
				eventService.broadcastEvent("com.ibm.mashups.builder.createPage", {
					spaceId: spaceAccessor.getSpaceID(),
					parentPageId: currentPageID
				});
			});
		});
	},
	confirmCreateSiblingPage: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var isAuth = com.ibm.pb.contextMenu.sharedActions.isAuthenticated.apply(this,arguments);
		var pageNode = navModel.find(currentPageID).start();
		var parentPageNode = navModel.getParent(pageNode).start();
		var isPage = (pageNode.getNavigationElementType() == com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE);
		var isOpAllowed = allowedOpsModel.getOperation(pbOperations.CREATE_PAGE,{navNode: parentPageNode}).start().isAllowed();
		return isAuth && isPage && isOpAllowed;
	},
	createSiblingPage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var pageNode = navModel.find(currentPageID).start();
		var parentNode = navModel.getParent(pageNode).start();
		ctxMenus.savePageChecker(function(){
			iwidgetControl.onLoad(_metadata && _metadata.widgetId, function(){
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
				eventService.broadcastEvent("com.ibm.mashups.builder.createPage", {
					spaceId: spaceAccessor.getSpaceID(),
					parentPageId: parentNode.getID()
				});
			});
		});
	},
	confirmMovePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var page = navModel.find(currentPageID).start();
		if (page.getNavigationElementType() === com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_PAGE){
			if(ctxMenus.isPrivatePage(currentPageID)) {
				return true;
			}
			var parent = navModel.getParent(page).start();
	        if (parent === null) {
	            return false;
	        }
			if (parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.ADMIN) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.MANAGER) || parent.hasRole(com.ibm.mashups.enabler.ac.RoleType.EDITOR)) { 
				return true; 
			}
		}
		return false;
	},
	movePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    ctxMenus.savePageChecker(function(){
			var payload = {
				widgetTypeId: "reorderPage",
				eventName: "com.ibm.mashups.builder.reorderPage",
				eventPayload: {
					pageId: currentPageID,
					spaceId: null
				},
				requestRefresh: true,
				dialogParam: {
					id: currentPageID + "_reorderPane",
					title: dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_REORDER_PAGE_DIALOG_TITLE,[com.ibm.mm.builder.utils.pageUtil.getPageTitle(currentPageID)]),
					nodeWidth: "461px",
					containerBackgroundColor: "white",
					hasRightBottomResizer: false
				}
			};
			com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
		});
	},
	isRemovePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    // check for (A) navigationNode.confirmRemove and (B) contentNode.confirmRemove
	    // if (A) and (B) is true, show "Delete this page"
	    // if (A) is true and (B) is false, show "Remove from navigation"
	    // in every other case hide delete
	    var node = navModel.find(currentPageID).start(),
			navRemove = navModel.confirmRemove(node),
			contentId = ctxMenus.getContentId(currentPageID),
			contentNode = navModel.find(contentId).start(),
			contentRemove = navModel.confirmRemove(contentNode);
	    if (navRemove && contentRemove) {
	        return false;
	    } else {
	        return true;
	    }
	},
	confirmDeletePage: function (currentPageID,somepassedinResourceType, _metadata,_someObject) {
	    var node = navModel.find(currentPageID).start();
	    return navModel.confirmRemove(node);
	},
	deletePage: function (currentPageID, somepassedinResourceType, _metadata, _someObject) {
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		var pageNode = navModel.find(currentPageID).start();
		if(confirm(dojo.string.substitute(bundle[_metadata.confirmMsgKey], [localizedContext.getTitle(pageNode)]))){
			var node = navModel.find(currentPageID).start();
			var parent = navModel.getParent(node).start();
			if ( navModel.confirmRemove(node) ) {
				navModel.remove(node);
			}
			navModel.commit().setFinishedCallback(function(resource, status, params){
				// clear all widget edit modes since we're deleting and discarding any changes
				com.ibm.pb.contextMenu.sharedActions.widgetEditModeClearer();	
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(null);
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				if(status < 400 || status === 404) {
					// switch to parent
					// 404 is okay because this happen on most successful page deletions
					var navStateModel = navStateModelFactory.getNavigationStateModel();
					var pageAccessor = accessorFactory.getPageAccessor(navStateModel, null);
					pageAccessor.setPageID(parent.getID());
					navStateModel.commit().setFinishedCallback(function(){
						var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
						evtSvc.broadcastEvent("com.ibm.mashups.builder.switchPage", parent.getID());
						evtSvc.broadcastEvent("com.ibm.mashups.builder.refreshNavigation", parent.getID());
					}).start();
				} else {
					// error
					dojo.publish("/portal/status/theme", ["error", dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_PUB_API_DELETE_PAGE_1,[status]), null]);
				}
			}).start();
		}
	},
	deletePage2: function (currentPageID, somepassedinResourceType, _metadata, _someObject) {
		// 19552: 2nd version of deletePage that Mashups has moved to. Moves to the nearest
		// sibling page from the deleted page rather than just to the parent page of the deleted
		// page, which is a usability improvement. If/when Portal is able to move to the new 
		// behavior, they can switch to this function and delete the 1st version of the function.
		var bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
		var pageNode = navModel.find(currentPageID).start();
		if(confirm(dojo.string.substitute(bundle[_metadata.confirmMsgKey], [localizedContext.getTitle(pageNode)]))){
			var node = navModel.find(currentPageID).start();
			var parent = navModel.getParent(node).start();
			var previousSibling = parent; // default to parent if no siblings
			var children = navModel.getChildren(parent);
			var child;
			// find previous sibling
			while (children.hasNext()) {
				child = children.next();
				if (child.getID() === currentPageID) {
					// if first child, and there are other children, use second child (next sibling)
					if (previousSibling === parent && children.hasNext()) {
						previousSibling = children.next();
					}
					break;
				}
				previousSibling = child;
			}			
			if ( navModel.confirmRemove(node) ) {
				navModel.remove(node);
			}
			navModel.commit().setFinishedCallback(function(){
				// clear all widget edit modes since we're deleting and discarding any changes
				com.ibm.pb.contextMenu.sharedActions.widgetEditModeClearer();	
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setID(null);
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(false);
				// switch to previous sibling
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				var pageAccessor = accessorFactory.getPageAccessor(navStateModel, null);
				pageAccessor.setPageID(previousSibling.getID());
				navStateModel.commit().setFinishedCallback(function(){
					var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
					evtSvc.broadcastEvent("com.ibm.mashups.builder.switchPage", previousSibling.getID());
					evtSvc.broadcastEvent("com.ibm.mashups.builder.refreshNavigation", previousSibling.getID());
				}).start();
			}).start();
		}
	},
	
	/** WIDGET: RESIZE **/
	resizeWidget: function(ID, resourceType, metadata, someObject) {
		var layoutControl = com.ibm.mm.builder.utils.pageUtil.getLayoutControlByWidgetId(ID);
		var widgetTitle = com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(layoutControl,dojo.locale);
		var dialogTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_RESIZE_WIDGET_PROMPT, [widgetTitle]);
		var containerType = ctxMenus.getContainerType(ID);
		
		if(!com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog) {
			dojo.require("com.ibm.mm.builder.widget.RuntimeResizeWidget");
			com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog = new com.ibm.mm.builder.widget.RuntimeResizeWidget({
				dlgPara: {
					title: dialogTitle,
					nodeWidth: "395px",
					containerBackgroundColor: "white",
					requestRefresh: true
				},
				skinId: ID,
				showHeight: containerType != "row",
				showWidth: containerType != "column"
			});
		} else {
			com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog.setTitle(dialogTitle);
			com.ibm.pb.contextMenu.sharedActions.resizeWidgetDialog.setupDialog(ID, containerType != "column", containerType != "row");
		}
	},
	confirmResizeWidget: function(ID, resourceType, metadata, someObject) {
		if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "view") {
			return false;
		}
		var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
		
		var	currentMode = ctxMenus.getWidgetAccessor(windowID).getWindowState() || com.ibm.mm.iwidget.Constants.windowstate.NORMAL;
		return currentMode == com.ibm.mm.iwidget.Constants.windowstate.NORMAL;
	},
	getContainerType: function(controlId) {
		// returns "row" "column" "freeform" or null
		var control = layoutParser.findById(controlId),
			container = control.parentNode; 
		while (!dojo.hasClass(container,"component-container") && container.id != "layoutContainers") {
			container = container.parentNode;
		}
		if (dojo.hasClass(container, "ibmDndColumn")) {
			return "column";
		} else if (dojo.hasClass(container, "ibmDndRow")) {
			return "row";
		} else if (dojo.hasClass(container, "ibmDndFreeform")) {
			return "freeform";
		} else {
			return null;
		}
	},
	/** WIDGET: WIRING **/
	confirmEditWiring: function(ID, resourceType, metadata, someObject) {
		if(runtimeModel.getCurrentPage().getPageMode() == "view") { return false; }
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			wireModel = layoutModel.getWireModel();
		return wireModel.confirmCreate();
	},
	editWiring: function(ID, resourceType, metadata, someObject) {
		var dialogParam = {
				nodeWidth: '486px',
				title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME || "Wiring",
				leftBarWidth: '18px',
				rightBarWidth: '12px',
				displayCloseButton: true,
				hasRightBottomResizer: false
			};
			var payload = {
				widgetTypeId: 'wireInterface',
				eventName:  'com.ibm.mashups.builder.editWire',
				eventPayload: ID,
				dialogParam:  dialogParam,
				hasRightBottomResizer: false,
				requestRefresh: true
			};
			eventService.broadcastEvent('com.ibm.mashups.builder.displayInMashupDialog', payload);
			if(typeof ibmc !== "undefined") ibmc.publish("my.setDirtyPage", [ true ]);
			runtimeModel.getCurrentPage().setDirty(true);
	},
	/** WIDGET: CHANGE MODE **/
	confirmChangeWidgetMode: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: returns true if the control with the given ID can change into the given mode
		var currentMode = ctxMenus.getWidgetAccessor(ID).getWidgetMode() || com.ibm.mm.iwidget.Constants.mode.VIEW;
		if(currentMode == _metadata.mode) { return false; }  // already in this mode
		
		return ctxMenus.confirmOperation(ID, somepassedinResourceType, _metadata, _someObject);
	},
	changeWidgetMode: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: changes the mode of the control with the given ID by publishing an event or generating a new state url
		if (_metadata.mode == com.ibm.mm.iwidget.Constants.mode.HELP){  // only works in SSA, need to fire event for CSA but this will prb save state
			// help mode is launched in a new window in solo mode
			var urlGen = com.ibm.mashups.enabler.model.state.UrlGeneratorFactory.getURLGenerator(),
				navStateModel = navStateModelFactory.getNavigationStateModel(),
				widgetAccessor = ctxMenus.getWidgetAccessor(ID);
			widgetAccessor.setWidgetMode(com.ibm.mm.iwidget.Constants.mode.HELP);
			urlGen.getURL(navStateModel, function(url) {
				window.open(url,'','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,status=no,width=800,height=600,screenX=10,screenY=10,top=10,left=10');
				navStateModel.discard();
			}, {"newWindow": true, "themeTemplate":"Plain", "soloState":{"portletWindowID":ID,"returnSelection":runtimeModel.getCurrentPage().getID()}});
		} else {
            var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
			eventService.publishEvent(_metadata.event, {id:windowID, newMode:_metadata.mode});  // fire event, does nothing for portlets
			if (!ibmCfg.themeConfig.isPageRenderModeCSA && ctxMenus.getWidgetAccessor(windowID).getWidgetMode() != _metadata.mode) {
				// change navigational state and refresh page for portlets to change their modes
				// NOTE: this is only triggered for portlets (SSA only), so this code should never run in Mashups
				var navStateModel = navStateModelFactory.getNavigationStateModel();
				ctxMenus.getWidgetAccessor(windowID).setWidgetMode(_metadata.mode);
				runtimeModel.getCurrentPage().setID(runtimeModel.getCurrentPage().getID());
				navStateModel.commit().start();
				ctxMenus.savePageChecker(function(){
					document.location.href = enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(navStateModel);
				});
			}
		}
	},
	getWidgetAccessor: function(id) {
		// summary: returns a widget accessor for the given widget/portlet id
		var navStateModel = navStateModelFactory.getNavigationStateModel(),
			widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, id);
		return widgetAccessor;
	},
	/** WIDGET: CHANGE STATE **/
	confirmChangeWindowState: function (ID,somepassedinResourceType, _metadata,_someObject) {
		if(ctxMenus.isPlainThemeTemplate()) { return false; }
		var navStateModel = navStateModelFactory.getNavigationStateModel();
        var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, windowID);
		var currentWindowState = widgetAccessor.getWindowState();
		
		if(!currentWindowState){ currentWindowState = widgetAccessor.NORMAL; }		

		// Mashup fixes for hiding max/min/restore for hidden widgets
        var hiddenContainerID = ctxMenus.getHiddenContainerID();
        var hiddenContainerNode = layoutParser.findById(hiddenContainerID);
        if(hiddenContainerNode) { // if hidden container is null, this will find the node globally (not what we want)
	        var result = dojo.query(".id-"+ID,hiddenContainerNode);
	        if (result.length>0) {
	            return false;
	        }
        }
		// End
		
		if(_metadata.newWindowState == widgetAccessor.NORMAL && currentWindowState == widgetAccessor.NORMAL){
			return false;
		}else if(_metadata.newWindowState == widgetAccessor.MIN && currentWindowState == widgetAccessor.MIN){
			return false;
		}else if(_metadata.newWindowState == widgetAccessor.MAX && currentWindowState == widgetAccessor.MAX){
			return false;
		}
		return true;
	},
	
	changeWindowState: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: changes the window state of the control with the given ID by publishing an event
		var navStateModel = navStateModelFactory.getNavigationStateModel();		
        var windowID = ID; // we can assume that window ID and control ID are always the same, even in live preview
		var widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, windowID);

		if(ibmCfg.themeConfig.isPageRenderModeCSA){
			var currentWindowState = widgetAccessor.getWindowState();
			if(!currentWindowState){ currentWindowState = widgetAccessor.NORMAL; }
			eventService.publishEvent(_metadata.event, {id: windowID, controlId: ID, newWindowState: _metadata.newWindowState, oldWindowState: currentWindowState});	
		}else{
			var pid = runtimeModel.getCurrentPage().getID();
			widgetAccessor.setWindowState(_metadata.newWindowState);
			runtimeModel.getCurrentPage().setID(pid);
			navStateModel.commit().start();
			if(!_metadata.noRefresh){
				ctxMenus.savePageChecker(function(){
					top.location.href = enabler.model.state.UrlGeneratorFactory.getUrlGenerator().getUrl(navStateModel);
				});
			}else{  // this is triggered when a widget needs to be unmaximized before being deleted or hidden
				var currentWindowState = widgetAccessor.MAX;
				eventService.publishEvent(_metadata.event, {id: windowID, controlId: ID, newWindowState: _metadata.newWindowState, oldWindowState: currentWindowState});	
			}
		}		
	},
	/** WIDGET: DISPLAY **/
	confirmDisplayControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		if (runtimeModel.getCurrentPage().getPageMode() == "view") { 
			return false; 
		}
        var hiddenContainerID = ctxMenus.getHiddenContainerID();
        if (!hiddenContainerID) {
            return false; // there is no hidden container
        }
        var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
            control = layoutModel.find(ID).start();
        if (!control) { return false; }
        var parent = layoutModel.getParent(control).start();
        if (parent.getID() == hiddenContainerID) {
            return true; // the container is already hidden
        }
        return false;
	},
	
	displayControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID());
		var rootDef = layoutModel.getRoot();
		var root = rootDef.start(); 
		var iter = layoutModel.getChildren(root); 
		var firstContainerDiv = null;
		var layoutContainers = dojo.byId("layoutContainers");
		var container = null;
		var childNodes = dojo.query(".component-container",layoutContainers);
		for (var i=0;i<childNodes.length;i++){
			if (dojo.hasClass(childNodes[i],"hiddenWidgetsContainer")==false){
				firstContainerDiv=childNodes[i];
				break;
			}
		}
		while(iter.hasNext()){
			container = iter.next();
			if (firstContainerDiv == layoutParser.findById(container.getID())){
				break;
			}
		}
		if (container) {
			var control = layoutModel.find(ID).start();
			var nextSibling = null;
			var iter = layoutModel.getChildren(container);
			if(iter.hasNext()) { nextSibling = iter.next(); }
			if(nextSibling && !(nextSibling instanceof com.ibm.mashups.enabler.layout.LayoutControl)) { 
				nextSibling = null;
			}
			layoutModel.insert(control, container, nextSibling);
			var controlDiv = layoutParser.findById(control.getID());
			if (nextSibling){
				firstContainerDiv.insertBefore(controlDiv,layoutParser.findById(nextSibling.getID()));
			}else{
				firstContainerDiv.appendChild(controlDiv); 
			}
			if(typeof ibmc !== "undefined") ibmc.publish("my.setDirtyPage", [ true ]);
			runtimeModel.getCurrentPage().setDirty(true);
			eventService.broadcastEvent("com.ibm.mashups.builder.widgetMoved", ID);
			if(com.ibm.pb.control.DNDController){
				com.ibm.pb.control.DNDController.getController().dndSources[container.getID()].sync();
			}
		} 
	},		
	/** WIDGET: HIDE **/
	confirmHideControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: returns true if the control with the given ID can be moved into the hidden widget container
        if(runtimeModel.getCurrentPage().getPageMode() == "view") { return false; }
        var hiddenContainerID = ctxMenus.getHiddenContainerID();
        if(!hiddenContainerID) {
            return false;  // there is no hidden container
        }
        var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
            control = layoutModel.find(ID).start();
        if (!control) { return false; }
        var parent = layoutModel.getParent(control).start();
        if(parent.getID() == hiddenContainerID) {
            return false;  // the container is already hidden
        }
        var hiddenContainer = ctxMenus.getHiddenContainer();
        return layoutModel.confirmInsert(control, hiddenContainer);  // return if user can insert into the hidden container
	},
	hideControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: moves the control with the given ID into the hidden widgets container
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			hiddenContainer = ctxMenus.getHiddenContainer(),
			hiddenContainerDom = layoutParser.findById(hiddenContainer.getID()),
			control = layoutModel.find(ID).start(),
			controlDom = layoutParser.findById(control.getID());
		ctxMenus.changeWindowState(ID, somepassedinResourceType, {
			newWindowState: "normal",
			event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE,
			noRefresh: true
		}, _someObject);
			
		layoutModel.insert(control, hiddenContainer);
		hiddenContainerDom.appendChild(controlDom);
		if(typeof ibmc !== "undefined") ibmc.publish("my.setDirtyPage", [ true ]);
		runtimeModel.getCurrentPage().setDirty(true);
		eventService.broadcastEvent("com.ibm.mashups.builder.widgetMoved", ID);
		if(com.ibm.pb.control.DNDController){
			var dndS = com.ibm.pb.control.DNDController.getController().dndSources;
			if(dndS[hiddenContainer.getID()]) {
				dndS[hiddenContainer.getID()].sync();
			}
		}
	},
	/** WIDGET: DELETE **/
	confirmDeleteControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
		// summary: returns true if the control with the given ID can be deleted
		if(runtimeModel.getCurrentPage().getPageMode() == "view") { return false; }
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			control = layoutModel.find(ID).start();
		if (!control) { return false; }
		return layoutModel.confirmRemove(control);
	},
    deleteControl: function (ID, somepassedinResourceType, _metadata, _someObject) {
        // summary: removes the control with the given ID from the layout model and then the DOM
        var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
            domNode = layoutParser.findById(ID);
        var control = layoutModel.find(ID).start();
        var wid = ID; // we can assume that window ID and control ID are always the same, even in live preview
        ctxMenus.changeWindowState(ID, somepassedinResourceType, {
			newWindowState: "normal",
			event: com.ibm.mashups.iwidget.Constants.CHANGE_WIDGETWINDOWSTATE,
			noRefresh: true
		}, _someObject);
        layoutModel.remove(control);
        if(domNode) {
			var parent = domNode.parentNode;
            parent.removeChild(domNode);

			//20637: if freeform layout then we may have to adjust the bottom layout border to remove the empty space where the deleted control was
			if (dojo.hasClass(parent, "ibmFreeform")){
				// get the vertical position of the bottommost widget in the layout
                // also as the default is to have a freeForm of 700px, the default bottommostWidgetBorder is 690
                var bottommostWidgetBorder = 690;
                
                dojo.query(".component-control", this.node ).forEach(function(widgetNode, index, arr){
                    // dojo style should always return a number of px
                    var widgetTop = dojo.style(widgetNode, "top");
                    var widgetHeight = dojo.style(widgetNode, "height");
                
                    var widgetBottom = widgetTop + widgetHeight;
                    
                    // check if this widget is below any other widget
                    if (widgetBottom > bottommostWidgetBorder) {
                        bottommostWidgetBorder = widgetBottom;
                    }
                }, this);
                
                // calculate the old and the new height of the container
                var oldContainerHeight = dojo.style(parent, "height");
                var newContainerHeight = bottommostWidgetBorder + 10;

                // if the heights are different, assign them
                if (oldContainerHeight != newContainerHeight){
                    // set the style
                    dojo.style(parent, "height", newContainerHeight+"px");
                    var _containerId = layoutParser.extractID(parent);
                    var ctrol = layoutModel.find(_containerId).start();
                    ctrol.setMetaData("css-style", "height:"+ newContainerHeight +"px;");
                }
			}
        }

		if(typeof ibmc !== "undefined") ibmc.publish("my.setDirtyPage", [ true ]);
        runtimeModel.getCurrentPage().setDirty(true);
        eventService.broadcastEvent("com.ibm.mashups.builder.widgetDeleted", ID);
        eventService.broadcastEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS,[wid]);
    },
	/** HELPERS **/
	widgetEditModeChecker: function() {
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var widgets = widgetModel.getAllWidgets();
		var hasWidgetInEditMode = false;
		for(var i in widgets) {
			if(Object.prototype.hasOwnProperty.call(widgets, i)) {
				var mode = widgets[i].currentMode;
				if(mode && mode != "view") {	// mode could be undefined
					hasWidgetInEditMode = true;
					break;
				}
			}
		}
		if(hasWidgetInEditMode) {
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			/* Late lazy load */
			dojo["require"]("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");
			// No callback here since we always force users to back to page
			var confirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING3,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST2,
		        btnSaveText: cws.I_COMMON_RETURN,
		        btnCancelText: cws.I_COMMON_CANCEL,
				hideNotSave: true,
				savePageOnSave: false
		    });
		    confirmDlg.show();
		}
		return hasWidgetInEditMode;
	},
	widgetEditModeClearer: function() {
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();
		var widgets = widgetModel.getAllWidgets();
		for(var i in widgets) {
			if(Object.prototype.hasOwnProperty.call(widgets, i)) {
				var mode = widgets[i].currentMode;
				if(mode && mode != "view") {	// mode could be undefined
					widgets[i].currentMode = "view";
				}
			}
		}
	},
	savePageChecker: function(callbackSave, callbackNoSave, cancelcb){
		if(runtimeModel.getCurrentPage().isDirty()){
			ibmCfg.themeConfig.savePageCheckerUnloading = true;
			if(!callbackNoSave) callbackNoSave = callbackSave;
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			/* Late lazy load */
			dojo["require"]("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");
			var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
		        btnSaveText: cws.I_COMMON_SAVE,
		        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
		        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
				hideNotSave: true,
		        callbackSave: function(){ibmCfg.themeConfig.savePageCheckerUnloading=false;if(callbackSave)callbackSave();},
		        callbackNotSave: function(){ibmCfg.themeConfig.savePageCheckerUnloading=false;if(callbackNoSave)callbackNoSave();},
				callbackCancel: function(){ibmCfg.themeConfig.savePageCheckerUnloading=false;if(cancelcb)cancelcb();}
		    });
		    saveConfirmDlg.show();
		} else {
			if (callbackSave) {
				callbackSave();
			}
		}
	},
	getContentId: function(navId) {
		var navNode = navModel.find(navId).start();
		if(navNode && navNode.getContent) {
			var content = navNode.getContent().start();
			if(content) {
				navId = content.getID();
			}
		}
		return navId;
	},
    getHiddenContainerID: function () {
        var dom = dojo.query(".hiddenWidgetsContainer", layoutParser.getRootNode());
        if (dom && dom[0]) {
            return layoutParser.extractID(dom[0]);
        }
        return null;
    },
	getHiddenContainer: function () {
		// summary: returns the layout control with the name "ibmHiddenWidgets"
		var layoutModel = ctxMenus.getLayoutModel(runtimeModel.getCurrentPage().getID()),
			root = layoutModel.getRoot().start(),
			children = layoutModel.getChildren(root);
		while(children.hasNext()) {
			var child = children.next();
			if(child.getMetaData("com.ibm.portal.layoutnode.localname") == "ibmHiddenWidgets") {
				return child;
			}
		}
		return null;
	},
	getLayoutModel: function (pageId) {
		// summary: returns the layout model for the current page
		return navModel.getLayoutModel(pageId);
	},
	isPrivatePage: function(pageId){
		var navNode = navModel.find(pageId).start(),
			xml = navNode.getXml(),
			expr = "./atom:content/*/ac:allowed-access[@ac:private='true']";
		return com.ibm.mashups.enabler.xml.XPath.evaluateBoolean(expr, xml, {
			app: "http://www.w3.org/2007/app",
			atom: "http://www.w3.org/2005/Atom",
			ac: "http://www.ibm.com/xmlns/prod/lotus/access-control/v1.0"
		});
	},
	isPageOwner: function(pageId){
		var layoutModel = ctxMenus.getLayoutModel(pageId),
			layoutNode = layoutModel.getRoot().start(),
			acModel = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(layoutNode),
			pageOwner = acModel.getOwner();
		if (pageOwner) {
			var userModel = com.ibm.mashups.enabler.user.Factory.getUserModel(),
				currentUser = userModel.findCurrentUser().start();
			if (pageOwner.getID() == currentUser.getID()) { return true; }
		}
		return false;
	},
	isAuthenticated: function() {
        var userModel = enabler.user.Factory.getUserModel();
		return userModel.getAnonymousMode() != enabler.user.AnonymousMode.ANONYMOUS;
	},
	isAnonymous: function() {
		return !ctxMenus.isAuthenticated();
	},
	isPlainThemeTemplate: function() {
		if (ibmCfg && ibmCfg.portalConfig && ibmCfg.portalConfig.bootstrapState 
			&& ibmCfg.portalConfig.bootstrapState.indexOf("<theme-template>Plain</theme-template>") >= 0) {
			return true;
		} else {
			return false;
		}
	},
	broadcastEventFromCurrentPage: function(currentResourceID,resourceType, metadata,someObject) {
		return ctxMenus.broadcastEvent.call(this,runtimeModel.getCurrentPage().getID(),resourceType, metadata,someObject);
	},
	broadcastEvent: function(currentResourceID,somepassedinResourceType, _metadata,_someObject) {
		var evtSvc = com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService");
		evtSvc.broadcastEvent(_metadata.event, {resourceId: currentResourceID, resourceType: somepassedinResourceType, domNode: this});
	},
	openWidget: function(currentResourceID,somepassedinResourceType, _metadata,_someObject) {
		var scope = this;
		iwidgetControl.onLoad(_metadata && _metadata.widgetId, function(iWidgetWrapper){
			if(iWidgetWrapper && iWidgetWrapper.iScope) {
				iWidgetWrapper.iScope.open({resourceId: currentResourceID, resourceType: somepassedinResourceType, domNode: scope});
			}
		});
	},
	loadURL: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		ctxMenus.savePageChecker(function(){top.location.href = _metadata.url;});
	},
	refreshPage: function () {
		ctxMenus.savePageChecker(function () {
			var url = ctxMenus.createRefreshURL();
			dojo.cookie( "DigestTracker", (new Date()).getTime(), {path: "/"} );
			top.location.href = url;
		});
	},
	createRefreshURL: function () {
		var navStateModel = navStateModelFactory.getNavigationStateModel();
		var urlGen = enabler.model.state.UrlGeneratorFactory.getURLGenerator();
		return urlGen.getURL( navStateModel, null, { "nohash": true } );
	},
	createURL: function(targetPageID,urlParams){
		var navStateModel = navStateModelFactory.getNavigationStateModel();
		var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
		var pageAccessor = accessorFactory.getPageAccessor(navStateModel, spaceAccessor.getSpaceID());
		pageAccessor.setPageID(targetPageID);
		var urlGen = enabler.model.state.UrlGeneratorFactory.getURLGenerator();
		// add params to urlParams
		return (urlGen.getURL(navStateModel, null, {}) + "?" + dojo.objectToQuery(urlParams));
	},
	createURL: function(targetPageID,urlParams,widgetParams){
		var navStateModel = navStateModelFactory.getNavigationStateModel();
		var spaceAccessor = accessorFactory.getSpaceAccessor(navStateModel);
		var pageAccessor = accessorFactory.getPageAccessor(navStateModel, spaceAccessor.getSpaceID()),
			widgetAccessor, widgetState;
			
		pageAccessor.setPageID(targetPageID);
		
		/**
		 * widgetParams map has this format
			{
			  "widgetId_1": {
				mode: com.ibm.mm.iwidget.Constants.mode.EDIT,
				windowState: com.ibm.mm.iwidget.Constants.windowstate.MAXIMIZE,
				parameters: {
					"param1": "value1",
					"param2": ["value2", "value3"]
				}
			  },
			  "widgetId_2": {
				parameters: {
					"param1": "value1"
				}
			  }
			}
		 */
		for(var id in widgetParams) {
			widgetState = widgetParams[id];
			widgetAccessor = accessorFactory.getWidgetAccessor(navStateModel, id);
			if(widgetState.mode) {
				widgetAccessor.setWidgetMode(widgetState.mode);
			}
			if(widgetState.windowState) {
				widgetAccessor.setWindowState(widgetState.windowState);
			}
			for(var p in widgetState.parameters) {
				widgetAccessor.setWidgetState(p, widgetState.parameters[p]);
			}
		}
		
		var urlGen = enabler.model.state.UrlGeneratorFactory.getURLGenerator();
		// add params to urlParams
		return (urlGen.getURL(navStateModel, null, {}) + "?" + dojo.objectToQuery(urlParams));
	},
	navigateToPageFromCurrent: function(currentPageID,resourceType,metadata,someObject) {
		return ctxMenus.redirectToHiddenPage.call(this,runtimeModel.getCurrentPage().getID(),resourceType,metadata,someObject);
	},
	navigateToPage: function() {
		return ctxMenus.redirectToHiddenPage.apply(this, arguments);
	},
	redirectToHiddenPage: function(currentPageID,somepassedinResourceType, _metadata,_someObject) {
		var contentNodeId = currentPageID,
			targetPageNavNode = navModel.find(currentPageID).start();
		if(targetPageNavNode.getContent) {
			var contentNode = targetPageNavNode.getContent().start();
			contentNodeId = contentNode.getID();
		}
		// TODO: do we need to do some error checking if the IDs are null or leave the error handling to the target page?
		var mapping = {
		    navID: currentPageID,
		    contentID: contentNodeId
		};
		var newParams = ctxMenus.replaceMapVars(mapping, _metadata.urlParams);
		var widgetParams = ctxMenus.replaceMapVars(mapping, _metadata.widgetParams);
		var url = ctxMenus.createURL(_metadata.targetPageID, newParams, widgetParams);
		ctxMenus.savePageChecker(function(){
			if(_metadata && _metadata.refreshCache) {
				dojo.cookie( "DigestTracker", (new Date()).getTime(), {path: "/"} );
			}
			top.location.href = url;
		});
	},
	replaceMapVars: function(mapping, template) {
		var ret = template;
		if(dojo.isString(template)) {
			ret = dojo.string.substitute(template, mapping, function(value, key){
				if(value === undefined) {
					if(key === "contentID") {
						return ctxMenus.getContentId(mapping.navID);
					}
					else {
						return "";
					}
				}
				else {
					return value;
				}
			});
		}
		else if(dojo.isArray(template)){
			ret = [];
			for(var i=0; i<template.length; i++) {
				ret.push(ctxMenus.replaceMapVars(mapping, template[i]));
			}
		}
		else if(dojo.isObject(template)) {
			ret = {};
			for(var key in template) {
				ret[key] = ctxMenus.replaceMapVars(mapping, template[key]);
			}
		}
		return ret;
	},
	
	confirmLogout: function() {
		if(com.ibm.pb.contextMenu.sharedActions.widgetEditModeChecker()) {
			// skip the page dirty check and display another confirm dialog if there is unsaved widget
			return;
		}
		if(runtimeModel.getCurrentPage().isDirty()){
			var cws = com.ibm.mm.builder.coreWidgetsStrings;
			/* Late lazy load */
			dojo["require"]("com.ibm.mm.builder.dialog.PageSaveConfirmDialog");
			var saveConfirmDlg = new com.ibm.mm.builder.dialog.PageSaveConfirmDialog({
		        contentWarning: cws.I_PAGE_SAVE_WARNING,
		        contentQuestion: cws.I_PAGE_SAVE_SUGGEST,
		        btnSaveText: cws.I_COMMON_SAVE,
		        btnNotSaveText: cws.I_PAGE_SAVE_NO_SAVE,
		        btnCancelText: cws.I_PAGE_SAVE_KEEP_EDIT,
		        hideNotSave: false,
		        callbackSave: function() {
					var deffered = navModel.commit();
					deffered.setFinishedCallback(function() {
						com.ibm.pb.contextMenu.sharedActions.logout();
					});
					deffered.start();
				},
		        callbackNotSave: function() {
					com.ibm.pb.contextMenu.sharedActions.logout();
				},
				callbackCancel: function() {}
		    });
		    saveConfirmDlg.show();
		} else {
			com.ibm.pb.contextMenu.sharedActions.logout();
		}
	},
	
	logout: function() {
		
		// handle when current page is a global page
		com.ibm.pb.control.NavigationController.getController().setLastNonGlobalPage();
		
		com.ibm.pb.control.NavigationController.getController().clearLoginFlag();
		
        var cs = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
		location.pathname = cs.getValue(com.ibm.mashups.enabler.services.ConfigConstants.LOGOUT_URL);
	}
};
com.ibm.pb.contextMenu.sharedActions = ctxMenus;

})();

