if(!dojo._hasResource["com.ibm.widgets.Breadcrumbs"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.Breadcrumbs"] = true;
dojo.provide("com.ibm.widgets.Breadcrumbs");

dojo.require("com.ibm.widgets.InlineEditorWrapper");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "NavWidget");
dojo.requireLocalization("com.ibm.bundles", "Theme");
dojo.requireLocalization("com.ibm.bundles", "Shelf");

dojo.declare("com.ibm.widgets.Breadcrumbs",
			[dijit._Widget, dijit._Templated],
			{
				model: null,				// a selection model on which to base the breadcrumb trail
				treeModel: null,			// the tree model backing the selection model 
				item: null,					// the currently selected item with in the model
				parent: null,				// the parent of item
				siblings: {},				// an associative array of item => DOM node pairs
				startLevel: null,			// the number of the level to start rendering the breadcrumbs at
				levels: Number.MAX_VALUE,	// the number of levels to render in the trail, Number.MAX_VALUE is used to represent all levels
				renderSiblings: true,		// true if siblings of the current selection should be rendered in the trail
				newSiblingText: "",			// text to display in the link to create a new sibling item
				newSiblingDefaultValue: "",
				embeddedEditorWidget: "dijit.form.TextBox",
				allowNew: true,				// true if a link should be rendered allowing the user to create a new sibling item
				newEditor: null,			// a dijit.form.ValidationTextBox to create new pages
				embeddedEditorParams: {},	// parameters for the dijit.form.ValidationTextBox
				introText: "",				// text to display before the trail begins
				listDOM: "ul",				// the type of DOM node that holds the trail links
				itemDOM: "li",				// the type of DOM node to act as a trail node
				containerClass: "",			// the class to put on the outer container div to the trail
				listClass: "",				// the CSS class to put on the container of the trail links
				ancestorClass: "",			// the CSS class to put on any ancestor nodes in the trail
				siblingClass: "",			// the CSS class to put on any sibling nodes in the trail
				newClass: "",				// the CSS class to put on the link to create a new item
				ancestorSeparator: " > ",	// the text separation to put between ancestor nodes
				siblingSeparator: " | ",	// the text separation to put between sibling nodes
				templateString: '<div dojoAttachPoint="focusNode" class="${containerClass}"><span dojoAttachPoint="introTextNode"></span><${listDOM} dojoAttachPoint="trail" class="${listClass}"></${listDOM}></div>',
					
				constructor: function() {
					this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "NavWidget");
					this.theme = dojo.i18n.getLocalization("com.ibm.bundles", "Theme");
					this.introText = this.bundle["breadcrumb_intro"];
					this.newSiblingText = this.bundle["breadcrumb_new_page_label"];			
					this.newSiblingDefaultValue = this.bundle["nav_new_page_default_value"];
					this.currentlySelected = this.theme["currently_selected"];
				},
				
				postMixInProperties: function() {
					this.inherited(arguments);
					if(!this.embeddedEditorParams.invalidMessage) this.embeddedEditorParams.invalidMessage = this.bundle["nav_new_page_invalid_message"];
					if(!this.embeddedEditorParams.promptMessage) this.embeddedEditorParams.promptMessage = this.bundle["nav_new_page_prompt_message"];
				},
				
				postCreate: function(){
					// summary: populate some of the class variables and set up listeners
					//this.parent = this.model.getParent(this.item);
					// set up listeners on the model for when an item is removed/inserted/moved
					this.treeModel = this.model.treeModel;
					this.connect(this.model, "onSelectionPathChange", "redraw");
					this.connect(this.treeModel, "onTreeChange", "onModelTreeChange");
				},
				
				startup: function() {
					this.inherited(arguments);
					// populate the breadcrumbtail
					this.draw();
				},
					
				draw: function(){
					// summary: populates the breadcrumb trail with ancestors and siblings (if specified) to the current item
					var path = this.model.getPath();
					this.parent = path[1];
					if(path.length - this.startLevel <= 1){
						this.introTextNode.innerHTML = "";
						return;
					}
					this.introTextNode.innerHTML = this.introText;
					for(var i = 1; i < path.length && i <= this.levels && i < (path.length - this.startLevel); i++) {
						this.createDomLink(path[i], this.ancestorClass, this.ancestorSeparator, this.trail.firstChild);
					}
					// retrieve and add the siblings to the current item
					if(this.renderSiblings){	
						this.siblings = [];
						this.shelfBundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
						var loading = document.createTextNode(this.shelfBundle["shelf_loading"]);
						this.trail.appendChild(loading);
						this.treeModel.getChildren(path[1], dojo.hitch(this, function(siblings){
							this.trail.removeChild(loading);
							// render the current item
							this.createDomText(path[0], this.siblingClass, this.siblingSeparator, null);
							// render the siblings
							var curPageId = this.treeModel.getIdentity(path[0]);
							dojo.forEach(siblings, function(sibling) {  
								if(curPageId != this.treeModel.getIdentity(sibling)) 
									this.siblings.push({item: sibling, node: this.createDomLink(sibling, this.siblingClass, this.siblingSeparator, null)});
							}, this)
							this.createEditBox();
						}));
					} else { // do not add siblings
						this.createDomText(path[0], this.siblingClass, this.siblingSeparator, null);
						this.createEditBox();
					}
				},
				
				redraw: function(/*Boolean*/ selectionChanged) {
					this.trail.innerHTML = "";
					this.draw();
				},
				
				onModelTreeChange: function(/*Item*/ childItem, /*Item*/ oldParentItem, /*Item*/ newParentItem, /*Item*/ nextSiblingItem) {
					// summary: Listens to changes in the tree model where items are inserted, deleted, or moved within the tree.
					// 		This only cares about insertions and deletions under the current selection's parent node.
					var currentlySelectedItem = this.model.getPath()[0];
					if(oldParentItem != newParentItem && childItem != currentlySelectedItem) {
						if(this.parent == oldParentItem) {
							this.onModelRemoveChild(childItem);
						}
						else if(this.parent == newParentItem) {
							var isNew = (!oldParentItem)?true:false;
							this.onModelInsertChild(childItem, isNew);
						}
					}
				},
				
				onModelRemoveChild: function(/*Item*/childItem){
					// summary: Responds to events which cause a node to be removed from the current selection's parent node
					// 		in the model either by moving or deletion of an item.
					// childItem: the item that was deleted
					var path = this.model.getPath();
					if(path.length - this.startLevel <= 1) return;
					for(var i = 0; i < this.siblings.length; i++) {
						if(childItem == this.siblings[i].item) {
							this.trail.removeChild(this.siblings[i].node);
							delete this.siblings[i].item;
							delete this.siblings[i].node;
							this.siblings.splice(i, 1);						
							return;
						}
					}
				},
				
				onModelInsertChild: function(/*Item*/childItem,/*bool*/isNew){
					// summary: Responds to events which cause a node to be inserted under the current selection's parent
					// 		node in the model either by moving or creation of a new item. 
					// childItem: the new/moved item
					// isNew: true if the child is new, as opposed to having been moved from a different parent
					var path = this.model.getPath();
					if(path.length - this.startLevel <= 1) return;
					if(this.renderSiblings){ 
						// this.item has a new sibling
						// find the new item editor link and insert the new sibling item BEFORE this node
						var editor = this.newEditor;
						var insertBefore = (editor)?editor.domNode:null;
						var node = this.createDomLink(childItem,this.siblingClass,this.siblingSeparator,insertBefore);
						if(isNew) dojo.addClass(node,"disabled");
						this.siblings.push({item: childItem, node: node});
						
						if(!childItem.created) {
							setTimeout(function(){
								dijit.focus(node);
							},0);
							var conn = dojo.connect(childItem, "onCreate", this, function(){
								node.firstChild.href = top.location.href + "?uri=" + this.treeModel.getIdentity(childItem);
								dojo.removeClass(node,"disabled");
								dojo.disconnect(conn);
							});
						}
					}
				},
				
				createDomLink: function(item, className, separator, node){
					// summary: creates a DOM node in the breadcrumb trail with a link as inner html
					// item: the item for which to create the DOM node
					// className: the CSS class to put on the new DOM node
					// separator: a text separator to append after the item link
					// node: a DOM item before which to place the new DOM link, null to place it at the end of the list
					var domItem = document.createElement(this.itemDOM);
					dojo.addClass(domItem, className);
					var link = document.createElement("a");
					domItem.appendChild(link);
					domItem.appendChild(document.createTextNode(separator));
					link.appendChild(document.createTextNode(this.treeModel.getLabel(item)));
					var url = top.location.href;
					// check to see if url has reference anchors or parameters, and if so, then discard them
					if(url.indexOf('#') > -1)
						url = url.substring(0, url.indexOf('#'));
					if(url.indexOf('?') > -1)
						url = url.substring(0, url.indexOf('?'));
					link.href = url + "?uri=" + this.treeModel.getIdentity(item);
					this.trail.insertBefore(domItem, node);
					return domItem;
				},
				
				createDomText: function(item, className, separator, node){
					// summary: creates a DOM node in the breadcrumb trail with plain text inner html
					// item: the item for which to create the DOM node
					// className: the CSS class to put on the new DOM node
					// separator: a text separator to append after the item text
					// node: a DOM item before which to place the new DOM text, null to place it at the end of the list
					var domItem = document.createElement(this.itemDOM);
					dojo.addClass(domItem, className);
					var hiddenText = dojo.create("span", {innerHTML: this.currentlySelected, className: "ibmPortalHiddenText ibmHiddenText wpthemeAccess"});
					var hiddenSpan = dojo.create("span");
					hiddenSpan.appendChild(hiddenText);
					domItem.appendChild(document.createTextNode(this.treeModel.getLabel(item)));
					domItem.appendChild(hiddenText);
					domItem.appendChild(document.createTextNode(separator));
					this.trail.insertBefore(domItem, node);
					return domItem;
				},
				
				createEditBox: function(){
					// summary: creates a link to create a new sibling item iff this.allowNew is true
					if(this.allowNew){
						this.newEditor = new com.ibm.widgets.BreadcrumbsEditor({
							embeddedEditorWidget: this.embeddedEditorWidget,
							embeddedEditorParams: this.embeddedEditorParams,
							"class": this.newClass,
							label: this.newSiblingText,
							defaultValue: this.newSiblingDefaultValue
						});
						
						this.newEditor.editor.width = "10em";
						this.newEditor.editor.lineHeight = "1.5em";
						
						//this.newEditor = new dijit.InlineEditBox({value:this.newSiblingText,width:"10em",lineheight:"1.5em",editor:"dijit.form.ValidationTextBox",editorParams:this.embeddedEditorParams},link);
						this.connect(this.newEditor, "onChange", "createNewSiblingItem");
						this.trail.appendChild(this.newEditor.domNode);
					}
				},
				
				onClickItem: function(item){
					// summary: redirects the browser to the url associated with item
					// item: the item with the link to redirect to
					if(!item.created) return false;
					top.location.href = top.location.href + "?uri=" + this.treeModel.getIdentity(item);
				},
				
				createNewSiblingItem: function(/*Object*/value, focus){
					// summary: triggered by the onChange event from the dijit.InlineEditBox used for creating new items
					// value: Object key-value map of attributes to set on the new item
					var newItem = null;
					var onComplete = function() {
						newItem.onCreate();
					}
					newItem = this.treeModel.newItem(dojo.mixin(value, {onComplete: onComplete, scope: this}),this.parent); // create the new item as a sibling to this.item
					newItem._onCreate = function(){ /*do nothing*/ };  // make sure _onCreate is a non null function
				}
				
			}
);

dojo.declare("com.ibm.widgets.BreadcrumbsEditor",
	[dijit._Widget, dijit._Templated, com.ibm.widgets.InlineEditorWrapper],
	{
		templateString: '<span class="inlineEditor ${class}" waiRole="presentation"><a dojoAttachPoint="editor,focusNode" class="newPageLink" href="javascript:;">${label}</a></span>'
		
	}
);

}
