if(!dojo._hasResource["com.ibm.widgets.InlineEditorWrapper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.widgets.InlineEditorWrapper"] = true;
dojo.provide("com.ibm.widgets.InlineEditorWrapper");

dojo.require("dijit.InlineEditBox");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.CheckBox");

// mix this into any other widget to get wrapped inline editor support with an optional popup
// advanced editor
dojo.declare("com.ibm.widgets.InlineEditorWrapper",
			null,
			{
				embeddedEditorWidget: "dijit.form.TextBox",
				embeddedEditorParams: {},
				
				popupWidget: "com.ibm.widgets.InlineEditorPopup",
				popupParams: {},
				
				postMixInProperties: function() {
					this.inherited(arguments);
					this.popupParams = dojo.mixin({}, this.popupParams);
				},
				
				postCreate: function() {
					this.inherited(arguments);
					if(!this._supportingWidgets) this._supportingWidgets = [];
					
					this._supportingWidgets.push(this.editor = new com.ibm.widgets.WrappedInlineEditBox({
						value: this.label,
						title: this.title,
						editor: this.embeddedEditorWidget,
						editorParams: this.embeddedEditorParams,
						canExit: dojo.hitch(this, function(){
							if(this.popupFocused || (this.editorFocused && !this.editor._wantsFocus)) {
								this.editor.editWidget._exitInProgress = false;
								return false;
							}
							return true;
						}),
						saveIsValid: function() {
							if(this.disabled || !this.editing || me.popupFocused || (
								this.editWidget.editWidget &&
								this.editWidget.editWidget.validate &&
								!this.editWidget.editWidget.validate()
								)) {
									this.editWidget._exitInProgress = false;
									return false;
							}
							return true;
						}
					}, this.editor));
					
					var _save = this.editor.save;
					var me = this;
					
					var _edit = dojo.hitch(this.editor, this.editor.edit);
					this.editor.edit = dojo.hitch(this, function() {
						this.editor.attr("value", this.defaultValue);
						_edit();
						
						// disable popup for checking private or public
						//this.editorPopup = this._getPopup();
						if(this.editorPopup) {
							this.editorPopup.attr("value", this.popupDefaultValue);
							dijit.popup.open({
								parent: this,
								popup: this.editorPopup,
								around: this.domNode,
								onCancel: dojo.hitch(this, this.editor.cancel),
								onClose: function(){ }
							});
						}
					});
					
					this.connect(this.editor, "onChange", "_onChange");
					this.connect(this.editor, "onCancel", "_onCancel");
					this.connect(this.editor, "edit", "onEdit");
				},
				_getPopup: function() {
					if(this.editorPopup) return this.editorPopup;
					if(!this.popupWidget) return null;
					var cls = dojo.getObject(this.popupWidget);
					if(cls) {
						this.editorPopup = new cls(this.popupParams);
						dijit.popup.prepare(this.editorPopup.domNode);
						this.editorPopup.startup();
						this.popupDefaultValue = this.editorPopup.attr("value");
						this.connect(this.editorPopup, "onFocus", function() {
							this.popupFocused = true;
							this.editorFocused = false;
						});
						this.connect(this.editorPopup, "onBlur", function() {
							this.popupFocused = false;
							setTimeout(dojo.hitch(this, function(){
								if(!this.editorFocused && this.editor.editWidget) {
									this.editor.editWidget._onBlur();
								}
							}),50);
						});
						this.connect(this.editor, "onFocus", function(){
							this.editorFocused = true;
							this.popupFocused = false;
						});
						this.connect(this.editor, "onBlur", function(){
							this.editorFocused = false;
						});
						
						return this.editorPopup;
					}
					return null;
				},
				startup: function() {
					this.editor.startup();
				},
				isEditing: function() {
					return this.editor && this.editor.editing;
				},
				_onChange: function(value) {
					// change the value back to its default, and call onChange with the
					// saved value
					this.editor.attr("value", this.label);
					var compositeValue = {label: value};
					if(this.editorPopup) {
						compositeValue = dojo.mixin(this.editorPopup.attr("value"), compositeValue);
						dijit.popup.close(this.editorPopup);
					}
					this.onChange(compositeValue, this.editor._wantsFocus);
				},
				onChange: function(value, focus) {
					// summary: Extension point for getting notifications about when this editor
					//		changes values.
					// value: New value of the inline editor
					// focus: Boolean indicating whether or not focus should stay on the inline editor
					//		usually because the ENTER key was pressed to save the value as opposed to
					//		an onblur event.
				},
				_onCancel: function() {
					this.editor.attr("value", this.label);
					if(this.editorPopup) dijit.popup.close(this.editorPopup);
					this.onCancel(this.editor._wantsFocus);
				},
				onCancel: function(focus) {
					// summary: Extension point for getting notifications about when this editor
					//		is canceled during an edit operation.
				},
				onEdit: function() {
					// summary: Extension point for getting notifications about when this editor
					//		goes into edit mode.
				}
			}
);

dojo.declare("com.ibm.widgets.WrappedInlineEditBox",
	dijit.InlineEditBox,
	{
		waitTime: 50,
		
		_wantsFocus: false,
		
		constructor: function() {
			this._connections = [];
		},
		canExit: function() {
			return true;
		},
		waitToExit: function(fname, argsArray) {
			setTimeout(dojo.hitch(this, function(){
				if(this.canExit() && this[fname + "IsValid"]()) {
					dijit.InlineEditBox.prototype[fname].apply(this, argsArray);
					this._wantsFocus = false;
				}
			}), this.waitTime);
		},
		saveIsValid: function() {
			return true;
		},
		cancelIsValid: function() {
			return true;
		},
		save: function(focus) {
			this._wantsFocus = focus;
			this.waitToExit("save", arguments);
		},
		cancel: function(focus) {
			this._wantsFocus = focus;
			this.waitToExit("cancel", arguments);
		},
		edit: function() {
			this.inherited(arguments);
			this._wantsFocus = false;
			var ew = this.editWidget;
			this._connections.push(dojo.connect(ew, "focus", this, "onFocus"));
			this._connections.push(dojo.connect(ew.editWidget, "onFocus", this, "onFocus"));
			this._connections.push(dojo.connect(ew, "onBlur", this, "onBlur"));
			var destroyConnection = dojo.connect(ew.editWidget, "destroy", this, function(){
				dojo.forEach(this._connections, dojo.disconnect);
				dojo.disconnect(destroyConnection);
			});
		}
	}
);

dojo.declare("com.ibm.widgets.InlineEditorPopup",
	dijit.layout.ContentPane,
	{
		"class": "inlineEditorPopup",
		
		content: 
			'<form dojoType="dijit.form.Form" encType="multipart/form-data" action="" method="POST" onSubmit="return false;" onReset="return false;">'
				+'<input name="isPrivate" checked="checked" dojoType="dijit.form.CheckBox">'
				+'<label for="isPrivate">Make this my private page</label>'
			+'</form>',

		onFocus: function() {
			
		},
			
		_getValueAttr: function() {
			var childWidgets = dojo.query("> [widgetId]", this.containerNode).map(dijit.byNode);
			if(childWidgets.length > 0)	return childWidgets[0].attr("value");
			return null;
		},
		_setValueAttr: function(value) {
			var childWidgets = dojo.query("> [widgetId]", this.containerNode).map(dijit.byNode);
			if(childWidgets.length > 0)	childWidgets[0].attr("value", value);
		}
	}
);

}
