/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.TextBox");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");

dojo.declare("com.ibm.mm.builder.pagePropertyEditor", com.ibm.mm.builder.iwidget.SystemTemplatedWidget, {
	
    pageId: "",
    
    pageTitle: "",
    
	pageDesc:"",
	
    pageTheme: "",
    
    autoWiringEnabled: builderConfig.pageAutoWiringDefault,
    
	userModel:null,
	
	displayTab:null,
	
	isEditCurrentPage: true,
	
    onLoad: function(){
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.pagePropertyEditor");
	    this.resourceMessage = com.ibm.mm.builder.coreWidgetsMessages;
        this.WID = "_" + this.iContext.widgetId + "_";
	},
	
	onUnload:function(){
		dojo.disconnect(this.overHoverHandler);
		dojo.disconnect(this.outHoverHandler);
		this.overHoverHandler = null;
		this.outHoverHandler = null;
	},
	
	onView: function(){
		this.inherited(arguments);

	    this.pagePropertyAdvanceSection.style.display = "none";
		dojo.style(this.accountSettingsContent, "display", "none");
		dojo.style(this.pagePropertiesContent, "display", "");
		
    	if (!this.overHoverHandler) {
			this.overHoverHandler = dojo.connect(this.pagePropertyShowChangeOwner,'onmouseover',this.pagePropertyShowChangeOwner,function() {
				dojo.addClass(this, 'hover');
	        },true);
		}
    	if (!this.outHoverHandler) {
			this.outHoverHandler = dojo.connect(this.pagePropertyShowChangeOwner,'onmouseout',this.pagePropertyShowChangeOwner,function() {
        		dojo.removeClass(this,'hover');
        	},true);
		}
	},
	    
	onDisplayPageProperty: function(iEvent){
		if (builderConfig.isBidi){
			this.pagePropertyAdvanceIcon.src = builderConfig.builderPath + "/images/nextRtl.gif";	
		} else {
			this.pagePropertyAdvanceIcon.src = builderConfig.builderPath + "/images/next.gif";	
		}
	    
		if(iEvent.payload && iEvent.payload.pageId){
			this.pageId = iEvent.payload.pageId;
			this.editPageInSpaceManager = iEvent.payload.editPageInSpaceManager;
		}else{
			this.pageId = iEvent.payload;
			this.editPageInSpaceManager = false;
		}
		
		this.isEditCurrentPage = (this.pageId === com.ibm.mm.builder.utils.pageUtil.getCurrentPageId());
		
		if (this.isEditCurrentPage) {
			this.currentPageModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
		}
		
		// if page id is specified, only show the page properties tab
        if (this.pageId) {	// show page settings
			dojo.style(this.accountSettingsContent, "display", "none");
			dojo.style(this.pagePropertiesContent, "display", "");
			this.displayTab = "pageProperty";
            this.initPagePropertyDiv();
            this.initThemeSelection();
        } else {			// show account settings
			dojo.style(this.pagePropertiesContent, "display", "none");
			dojo.style(this.accountSettingsContent, "display", "");
			this.displayTab = "accountSettings";
			this.initAccountSetting();
        }
    },
	
	onPageOwnerChanged: function(iEvent){
		//iEvent.payload: userID
		this._displayCurrentOwner();
		this._hideChangeOwner();
	},
	
	getBooleanValue:function(value){
		if(value === true || value == "true"){
			return true;
		}
		return false;
	},
	
	initAccountSetting:function(){
    	//The reason why put code here instead of onView is: postpone the request until user display the properties UI
		if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {  //lookaside is enabled
		    this.userModel = com.ibm.mm.builder.utils.userUtil.getUserModel();
			var user = com.ibm.mm.builder.utils.userUtil.getCurrentUser();
			var v1 = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS");
			var v2 = user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS");
			
			this.displaySuccessNotification = this.getBooleanValue(v1);
	       	this.displayDisabledNotification = this.getBooleanValue(v2);
			
	       	this.displayNotiCheck.checked = this.displaySuccessNotification;
			this.notifyMeCheck.checked =  this.displayDisabledNotification;
		} else {
			//disable the checkbox and radio button so user can not change this.
			this.displayNotiCheck.checked = false;
			this.notifyMeCheck.checked = false;
			this.loginHomeSpaceRadio.checked =  false;
			this.loginLastPageRadio.checked = true;
			this.displayNotiCheck.disabled = true;
			this.notifyMeCheck.disabled = true;
		}
		
		if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
			var isLast = com.ibm.mm.builder.utils.navigationUtil.isLastPageWhenLogin();
			this.loginHomeSpaceRadio.checked = !isLast;
			this.loginLastPageRadio.checked = isLast;
		} else {
			dojo.style(this.accountSettingsLoginContent, "display", "none");
			this.loginHomeSpaceRadio.disabled =  true;
			this.loginLastPageRadio.disabled = true;
		}
	},
	
    /**
     * create the page property UI elements
     */
    initPagePropertyDiv: function(){
		this.pageTitle = com.ibm.mm.builder.utils.pageUtil.getUnescapedPageTitle(this.pageId);
		this.pageTitleInput.value = this.pageTitle;
		this._displayCurrentOwner();
		this._hideChangeOwner();
		
		this.pageDesc = com.ibm.mm.builder.utils.pageUtil.getPageDescription(this.pageId);
	    this.pagePropertyDescription.value = this.pageDesc;

		var _isEnabled = this.enablerUtil.getPageMetaData("com.ibm.mashups.builder.autoWiringEnabled", this.pageId);
		if(_isEnabled !== null && (_isEnabled == "true" || _isEnabled == "false" || _isEnabled === true || _isEnabled === false)){
			this.autoWiringEnabled = this.getBooleanValue(_isEnabled);
		}else{
			this.autoWiringEnabled = builderConfig.pageAutoWiringDefault;
		}
		
		if (this.autoWiringEnabled == true || this.autoWiringEnabled == "true") {
			this.autoWiringEnableRadio.click();
		}
		else {
			this.autoWiringDisableRadio.click();
		}
		
		//Add ellipsis to the tab label texts if they are too long
        dojo.query(".tabLabel").forEach(function(tabNode, index){
            var str = tabNode.innerHTML;
            var widthlimit = 100;
            if (!builderConfig.isBidi) {
				widthlimit = index === 0 ? 100 : 120;
			}
            var shortStr = com.ibm.mm.builder.utils.htmlUtil.getStrWithLimit(str, tabNode, widthlimit);
            tabNode.innerHTML = shortStr;          
        });
    },
	
	_displayCurrentOwner: function(){
		var owner = com.ibm.mm.builder.utils.acModelUtil.getPageOwner(this.pageId);
		if (owner) {
			this.pagePropertyCurrentOwner.innerHTML = owner.getDisplayName();
			this.pageOwnerLabel.style.display = "inline";
			this.noPageOwnerLabel.style.display = "none";
		}else{
			this.pageOwnerLabel.style.display = "none";
			this.noPageOwnerLabel.style.display = "inline";
		}
	},
	
	canChangeOwner: function(pageId) {
		if (!pageId) {
			return false;
		}
		var pageLayoutNode = null;
		if (dojo.isString(pageId)) {
			pageLayoutNode = com.ibm.mm.builder.utils.pageUtil.getPageLayoutNode(pageId);
		}
		if (pageLayoutNode) {
			var spaceId = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(pageId);
			var ac = null;
			if (spaceId) {
				var spaceNode = com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId);
				ac = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(spaceNode,pageLayoutNode);
			}else{
				ac = com.ibm.mashups.enabler.ac.AccessControlModelFactory.getAccessControlModel(pageLayoutNode);
			}
			return ac.confirmSetOwner(pageLayoutNode);
		}
		return false;
	},
	
	_hideChangeOwner: function(){

		var space = com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(this.pageId);
		if(!space || !this.canChangeOwner(this.pageId)){
			this.pagePropertyShowChangeOwner.style.display = "none";
		}else{
			this.pagePropertyShowChangeOwner.style.display = "inline";
		}
	},
    
    /**
     * hide the page property dialog
     */
    hide: function(){
		this._hideMessage();
        this.eventService.broadcastEvent("com.ibm.mashups.builder.closeMashupDialog", this.iContext.widgetId);
    },
    
    /**
     * init the theme selection
     */
    initThemeSelection: function(){
        this.themeSelection.innerHTML = "";
        var curThemeId = com.ibm.mm.builder.utils.themeUtil.getThemeId(this.pageId);
        var themeModel = com.ibm.mm.builder.utils.themeUtil.getThemeModel();
        var index = 0;
        var selectedIndex = 0;
		var iterator = themeModel.iterator();        
        while (iterator.hasNext()) {
			var theme = iterator.next();
			var themeId = theme.getID();
			var themeTitle = com.ibm.mm.builder.utils.themeUtil.getThemeTitle(theme, builderConfig.locale);
			
			this.themeSelection.options.add(new Option(themeTitle, themeId));
			this.themeSelection.options[this.themeSelection.options.length - 1].title = themeTitle;
			
			if (themeId == curThemeId) {
				selectedIndex = iterator.getCursorPosition() - 1;
				this.pageTheme = theme.getID();
			}
		}
        this.themeSelection.options[selectedIndex].selected = true;
    },
    
    /**
     * save page property action method
     */
    save: function(){
		if (!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
			messageType: 'error'}, this._messageBoxNode);
            this.messageControl.hide();
        }
		if (this.displayTab == "pageProperty") {
			var newPageName = dojo.trim(this.pageTitleInput.value);
			var newPageDesc = dojo.trim(this.pagePropertyDescription.value);
			var newTheme = this.themeSelection.value;
			
			if (this._savePageProperty(newPageName, newPageDesc, newTheme)) {
				var constants = com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants;
				dojo.publish(constants.Topic.Space.refresh,[constants.Action.EDIT_PAGE, {pageId: this.pageId}]);
				// need to refresh the layout since the nav is commited
				com.ibm.mashups.iwidget.services.ServiceManager.getService("eventService")
					.broadcastEvent("com.ibm.mashups.builder.layoutRefresh");
				this.hide();
			}
		}else if (this.displayTab == "accountSettings"){
			this._saveAccountSettings();
			this.hide();
		}
	},
    
	_saveAccountSettings:function(){
		if(com.ibm.mm.builder.utils.userUtil.isLookasideEnabled()) {
			var user = this.userModel.findCurrentUser().start();
			var changed = false;
			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
				if (this.displaySuccessNotification.toString() != user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS")) {
					user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_ENABLED_NOTIFICATIONS", this.displaySuccessNotification.toString());
					changed = true;
				}
			}
			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
				if (this.displayDisabledNotification.toString() != user.getAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS")) {
					user.setAttribute("com.ibm.mashups.user.AUTO_WIRE_DISABLED_NOTIFICATIONS", this.displayDisabledNotification.toString());
					changed = true;
				}
			}
			if (com.ibm.mm.builder.utils.userUtil.isLookasideEnabled("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
				if (this.onLoginValue && this.onLoginValue != user.getAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN")) {
					user.setAttribute("com.ibm.mashups.user.WHERE_TO_GO_WHEN_LOGIN", this.onLoginValue);
					changed = true;
				}
			}
			if (changed) {
				try {
					this.userModel.commit().start();
				} 
				catch (e) {
					this.LOGGER.severe("_saveAccountSettings",
						dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_ACCOUNT_SETTING_SAVE_FAIL,[e.message])
					);
				}
			}
		}
	},
	_verifyDescription: function(description) {
	    var exceed = com.ibm.mm.builder.utils.pageUtil.isPageDescriptionLengthExceed(description);
	    var errorMessage = null;
	    if (exceed > 0) {
	        errorMessage = this.resourceMessage.E_PAGE_UTIL_INVALID_DESCRIPTION_LENGTH_1;
	        if (typeof(errorMessage) === 'undefined') {
		        dojo.requireLocalization("com.ibm.mm.builder", "coreWidgetsMessages", "en");
	            var enWidgetsMessages = dojo.i18n.getLocalization("com.ibm.mm.builder", "coreWidgetsMessages", "en");
	            errorMessage = enWidgetsMessages.E_PAGE_UTIL_INVALID_DESCRIPTION_LENGTH_1;
	        }
	        if (typeof(errorMessage) === 'undefined') {
	            errorMessage = "BMWMB0120E:The page description is limited to ${0} characters. Shorten your description and save again."
	        }
	        errorMessage = dojo.string.substitute(errorMessage, [exceed]);
	        this.messageControl.attr("message", errorMessage);
	        this.messageControl.show();
	        return false;
	    } else {
	        return true;
	    }
	},
	
    _savePageProperty: function(newPageName, newPageDesc, newTheme){
        if (!com.ibm.mm.builder.utils.pageUtil.validatePageName(newPageName)) {
			return false;
		}
		        
        if (!this._verifyDescription(newPageDesc)) {
            return false;
        }
		
		//auto-wiring setting changed,write back the page metadata
		if (this.autoWiringEnabled != this.autoWiringEnableRadio.checked) {
			this.autoWiringEnabled = this.autoWiringEnableRadio.checked;
            if (this.isEditCurrentPage) {
				this.currentPageModel.setAutoWiringEnablement(this.autoWiringEnabled);
			}
			this.enablerUtil.setPageMetaData(com.ibm.mm.builder.constant.autoWiringEnabled, this.autoWiringEnabled.toString(), this.pageId);
		}
	   
        var pageNameChanged = (newPageName != this.pageTitle);
		var pageDescChanged = (newPageDesc != this.pageDesc);
        if (!pageNameChanged && !pageDescChanged && newTheme == this.pageTheme) {
            return true;
        }
        
        var navigationModel = com.ibm.mm.builder.utils.navigationUtil.getNavigationModel();
        var page = navigationModel.find(this.pageId).start();
		page.setTitle(newPageName, dojo.locale);
		// #18580
		var defaultLocale = ibmConfig["default.locale"];
		if (dojo.locale != defaultLocale && !page.getTitle(defaultLocale)) {
			page.setTitle(newPageName, defaultLocale);
		}
		page.setDescription(newPageDesc, dojo.locale);
        this.pageTitle = newPageName;
        if (this.pageTheme != newTheme) {
            themeChanged = true;
            page.setTheme(newTheme);
            this.pageTheme = newTheme;
            
            this.eventService.broadcastEvent("com.ibm.mashups.builder.savePage");
            var layoutModel =  navigationModel.getLayoutModel(this.pageId);
			if (!layoutModel) {
				this.LOGGER.severe("_savePageProperty", com.ibm.mm.builder.coreWidgetsMessages.E_EDITPAGE_SAVE_ERROR_0);
				return false;
			}
            var lmRoot = layoutModel.getRoot().start();
            var metadataNames = lmRoot.getMetaDataNames();
            this.enablerUtil.removePageMetaData(metadataNames, this.pageId);
			if (this.editPageInSpaceManager) {
				this.eventService.broadcastEvent("com.ibm.mashups.builder.spacemanager.pageThemeChanged", {
					pageId: this.pageId,
					pageTitle: this.pageTitle,
					pageDesc: newPageDesc
				});
			} else {
				setTimeout(function(){window.location.reload();}, 1000);
			}
        } else {
            if (pageDescChanged || pageNameChanged) {
				if(this.isEditCurrentPage && pageNameChanged){
					this.eventService.broadcastEvent("com.ibm.mashups.builder.updatePageTitle", this.pageTitle);
				}
                if(pageNameChanged){
					this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
				}
				
				var nCommit = navigationModel.commit();
				nCommit.setFinishedCallback(dojo.hitch(this,function(x, status){
						if(status == 200 || status == 201) {
							this.eventService.broadcastEvent("com.ibm.mashups.builder.refreshNavigation");
						} else {
							this.LOGGER.severe("_savePageProperty","Cannot save the navigation model", arguments);
						}
					}));
				nCommit.start();
            }
        }
        return true;
    },
	
	_showMessage : function(message, type) {
		if(!this.messageControl) {
			dojo.registerModulePath("com.ibm.lotus.oneui.v100.messages", this.iContext.io.rewriteURI("../dijit-library/oneUI.versionized/messages"));
	    	dojo.require("com.ibm.lotus.oneui.v100.messages.Message");
			var wid = "_"+ this.iContext.widgetId + "_";
			var node = dojo.byId(wid+"messageBox");
		   	this.messageControl = new com.ibm.lotus.oneui.v100.messages.Message({
				messageType: 'error'}, node);
		}
		this.messageControl.attr(
			{
			"message" : message,
			"messageType" : type || "error"
			}
		);
		this.messageControl.show();
	},
	
	_hideMessage : function() {
		if (this.messageControl) {
			this.messageControl.hide();
		}
	},
   	
    onClickAdvance:function(){
    	var sectionBody = this.pagePropertyAdvanceSection;
        if (dojo.style(sectionBody, "display") === "none") {
            dojo.attr(this.pagePropertyAdvanceIcon, "src", builderConfig.builderPath + "/images/nextdown.gif");
            dojo.fx.wipeIn({
				node: sectionBody,
				duration: 500,
				onEnd: function(){
					if (dojo.isIE) {
						dojo.removeClass("pageProperty_section_advance", sectionBody);
						dojo.addClass("pageProperty_section_advance", sectionBody); //hack code to solve the dojo wipe out issue}
					}
				}
			}).play();
        } else {
			if (builderConfig.isBidi){
				dojo.attr(this.pagePropertyAdvanceIcon, "src", builderConfig.builderPath + "/images/nextRtl.gif");	
			} else {
				dojo.attr(this.pagePropertyAdvanceIcon, "src", builderConfig.builderPath + "/images/next.gif");
			}
            dojo.fx.wipeOut({
                node: sectionBody,
                duration: 500,
				onEnd: dojo.hitch(this, function(){

				})
            }).play();
        }
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesWord(this.pagePropertyAdvanceSection);
    },
    
    onDisplayNotiClicked:function(event){
    	this.displaySuccessNotification = event.target.checked;
    },
    
    onNotifyMeClicked:function(event){
    	this.displayDisabledNotification = event.target.checked;
    },
	
    onLogin:function(event){
    	this.onLoginValue = event.target.value;
    },
	
	showChangeOwner:function(){
		var payload = {
	    	widgetTypeId: "changeOwner",
	        eventName:  "com.ibm.mashups.builder.changeOwner",
	        eventPayload:  this.pageId,
	        dialogParam:  {
				title: this.cws.I_CHANGE_PAGE_OWNER,
				nodeWidth: "400px",
				hasRightBottomResizer: false }
		};
		this.eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog",payload);
	} 
 
});
