/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.services.ConfigConstants");

/**
 * This constants class contains well defined constants available to the config service.
 * They are defined in the ConfigService.properties
 * @ibm-spi
 * @ibm-module Base2
 */
dojo.declare("com.ibm.mashups.enabler.services.ConfigConstants", null, {
    /**
     * URL pointing to the proxy
     * @type String
     */
    PROXY_URL: "com.ibm.mashups.proxy.url",
    
    /**
     * URL pointing to the hub
     * @type String
     */
    HUB_URL: "com.ibm.mashups.hub.url",
    
    /**
     * URL pointing to login
     * @type String
     */
    LOGIN_URL: "com.ibm.mashups.url.login",
    
    /**
     * URL pointing to logout
     * @type String
     */
    LOGOUT_URL: "com.ibm.mashups.url.logout",
    
    /**
     * context root of the server
     * @type String
     */
    CONTEXT_ROOT: "com.ibm.mashups.contextroot",
    
    /**
     * context root of the enabler component
     * @type String
     */
    CONTEXT_ROOT_ENABLER: "com.ibm.mashups.contextroot.enabler",
    
    /**
     * context root of the builder component
     * @type String
     */
    CONTEXT_ROOT_BUILDER: "com.ibm.mashups.contextroot.builder",
    
    /**
     * public name of the content handler servlet
     * @type String
     */
    CONTENTHANDLER_PUBLIC: "com.ibm.mashups.contenthandler.public",
    /**
     * private name of the content handler servlet
     * @type String
     */
    CONTENTHANDLER_PRIVATE: "com.ibm.mashups.contenthandler.private",
    
    /**
     * public name of the embedding handler servlet
     * @type String
     */
    EMBEDDING_PUBLIC: "com.ibm.mashups.embedding.public",
    /**
     * private name of the content handler servlet
     * @type String
     */
    EMBEDDING_PRIVATE: "com.ibm.mashups.embedding.private",
    
    /**
     * TBD
     * @type String
     */
    THEMES_FEEDS_EXPIRATION: "themes.feed.expiration",
    
    /**
     * comma separated list of all available locales in the system
     * @type String
     */
    AVAILABLE_LOCALES: "availableLocales",
    /**
     * the default locale of the mashups system
     * @type String
     */
    DEFAULT_LOCALE: "default.locale",
    /**
     * the default locale that's based on user preference for UI components to display date,currency etc.
     * @type String
     */
    DISPLAY_LOCALE: "displayLocale",
    /**
     * defines whether PUT/DELETE tunneling over POST should be used
     * @type String
     */
    TUNNEL_MODE: "tunnel.mode",
    
    /**
     * turns on debugging
     * @type String
     */
    CLIENT_IS_DEBUG: "isDebug",
    
    /**
     * BiDi setting
     * @type String
     */
    CLIENT_IS_BIDI: "isBidi",
    
    /**
     * Definition Url list of the widgets which is sandbox disabled: /dataEditor/dataEditor.xml,id1,id2
     * @type String
     */
    WIDGETDEFID_SANDBOX_DISABLED: "com.ibm.mashups.sandbox.force.disable",
    
    /**
     * Trace configuration for the client runtime
     * @type String
     */
    TRACE_CONFIG: "traceConfig",
    /**
     * tbd
     * @type String
     */
    CLIENT_POPUP_CONSOLE: "popupConsole",
    /**
     * tbd
     * @type String
     */
    CLIENT_ALLOW_PUBLISH_LOGGING: "allowPublishLogging",
    /**
     * tbd
     * @type String
     */
    CLIENT_ALLOW_PUBLISH_TRACING: "allowPublishTracing",
    /**
     * tbd
     * @type String
     */
    CLIENT_ADDITIONAL_SERVICES: "additionalServices",
    
    /**
     * Theme id used in case no theme is set.
     * @type String
     */
    CLIENT_DEFAULT_THEME_ID: "com.ibm.mashups.theme.defaultThemeId",
    /**
     * tbd
     * @type String
     */
    CLIENT_PAGE_SOURCE_READ_ONLY: "pageSourceReadOnly",
    /**
     * Group name used for auto accepting pages
     * @type String
     */
    CLIENT_AUTO_ACCEPT_SHARED_GROUPNAME: "autoAcceptSharedGroupName",
    /**
     * Default value for page level auto wiring enablement
     * @type String
     */
    AUTO_WIRING_DEFAULT_ENABLED: "autoWiringDefaultEnabled",
    /**
     * tbd
     * @type String
     */
    CLIENT_USER_ID_KEY: "userIdKey",
    /**
     * tbd
     * @type String
     */
    CLIENT_GROUP_CN_KEY: "groupCNKey",
    /**
     * Url used to fetch the service document
     * @type String
     */
    SERVICE_DOCUMENT_URL: "serviceDocumentUrl",
    /**
     * turns on multipart support
     * @type String
     */
    MULTIPART_ENABLED: "com.ibm.mashups.multipart.enabled",
    /**
     * if multipart support is enabled, determines if requests are correlated
     * by hostname
     * @type String
     */
    MULTIPART_CORRELATE_HOSTS: "com.ibm.mashups.multipart.correlatehosts",
    /**
     * if multipart support is enabled, should URLs with query strings be
     * considered cacheable
     * @type String
     */
    MULTIPART_CACHE_QUERIES: "com.ibm.mashups.multipart.cachequeries",
    /**
     * Returns the semicolon separated list of Endpoint IDs
     * @type String
     */
    ENDPOINTS: "endpointIDs",
    /**
     * Returns the name of the Endpoints Config Provider
     * @type String
     */
    ENDPOINT_CONFIG_PROVIDER: "Endpoints",
    /**
     * Returns the name of the Anonymous User Config setting
     * @type {String}
     */
    ANONYMOUS_USER: "anonymousUser",
    /**
     * MetaData name used to recognize whether a page is hidden or not
     * @type String
     */
    NAVIGATION_HIDDEN: "com.ibm.mashups.navigation.hidden",
    /**
     * MetaData name used to recognize whether a space is hidden or not
     * @type String
     */
    SPACE_HIDDEN: "com.ibm.mashups.space.hidden",
    /**
     * Returns the name of the current User Config setting
     * @type String
     */
    USER: "user",
    /**
     * Returns the name of subdomains Config setting, subdomains are used to create sandboxed iwidgets
     * @type String
     */
    SUBDOMAINS: "subdomains",
    /**
     * Returns the name of server domain Config setting
     * @type String
     */
    SERVERDOMAIN: "serverdomain",
    /**
     * Returns the name of sandboxenabled Config setting, sandboxed feature is disabled if this configuration is set to false
     * @type String
     */
    SANDBOXENABLED: "sandboxenabled",
    /**
     * Returns the name of config setting that decides if subdomain should be reused when an existing sandboxed iwidget is removed from the page.
     * @type String
     */
    SUBDOMAINREUSE: "subdomainreuse",
    /**
     * MetaData name used to indicate attributes that need to added to url
     * @type String
     */
    NAVSTATE_PERSISTENCE_URL: "navstate.persistence.url",
    /**
     * MetaData name used to indicate attributes that need to added to persistence store
     * @type String
     */
    NAVSTATE_PERSISTENCE_PSTORE: "navstate.persistence.pstore",
    /**
     * MetaData name used to indicate number of widgets whose navigation state will be added to url
     * @type String
     */
    NAVSTATE_PERSISTENCE_URL_LIMIT: "navstate.persistence.url.limit",
    /**
     * MetaData name used to indicate number of sharedparametersets whose navigation state will be added to url
     * @type String
     */
    NAVSTATE_PERSISTENCE_URL_SPLIMIT: "navstate.persistence.url.splimit",
    /**
     * MetaData name used to indicate if navigation state is huffmann encoded or not
     * @type String
     */
    NAVSTATE_HUFFMANNENCODE_ENABLED: "navstate.huffmannencode.enabled",
    /**
     * MetaData name used to indicate the html fragment that's displayed when a widget is under loading
     * @type String
     */
    LOADING_HTML: "loadingHTML",
    
    /**
     * Specified whether pageloading should be optimized (Multipart)
     * @type String
     */
    PAGE_LOAD_OPTIMIZATION: "pageLoadOptimization",
    
    /**
     * Specified whether pageloading should be optimized for themes (Multipart)
     * @type String
     */
    PAGE_LOAD_OPTIMIZATION_THEME: "pageLoadOptimizationTheme",
    
    /**
     * Specifies whether application widgets should be optimized (Multipart)
     * @type String
     */
    PAGE_LOAD_OPTIMIZATION_APP_WIDGETS: "pageLoadOptimizationAppWidgets",
    
    /**
     * Allows to create New Spaces and Pages for anonymous users
     * @type String
     */
    ANONYMOUS_ALLOW_CREATE: "com.ibm.mashups.anonymous.allow.create",
    
    /**
     * If displayName is not sent from server use this property for User Display Name
     * @type String
     */
    DEFAULT_USER_DISPLAY_PROP: "com.ibm.mashups.default.user.display.prop",
    
    /**
     * The product name which will show up in the browser title, other product can replace it.
     * @type String
     */
    PRODUCT_NAME: "com.ibm.mashups.productname",
    
    /**
     * If displayName is not sent from server use this property for Group Display Name
     * @type String
     */
    DEFAULT_GROUP_DISPLAY_PROP: "com.ibm.mashups.default.group.display.prop",
    
    /**
     * The unique name of the welcome space
     * @type String
     */
    WELCOME_SPACE_ID: "com.ibm.mashups.welcome.space.name",
    
    /**
     * The filter as regexp for characters used on page and space title.
     * @type String
     */
    BUILDER_TITLE_FILTER_REGEXP: "com.ibm.mashups.builder.filter.title.regexp",
    
    /**
     * ID of the Anonymous Virtual User
     * @type String
     */
    ANON_VIRTUAL_USER_ID: "com.ibm.mashups.anonUserId",
    
    /**
     * ID of the All Authenticated Users Virtual Group
     * @type String
     */
    ALL_AUTH_VIRTUAL_GROUP_ID: "com.ibm.mashups.allAuthGroupId",
    
    /**
     * The server type this enabler is connected to. It can be either SERVER_TYPE_MASHUPS or SERVER_TYPE_PORTAL
     * @type String
     */
    SERVER_TYPE: "com.ibm.mashups.server",
    
    /**
     * The server type value for Lotus Mashups
     * @type String
     */
    SERVER_TYPE_MASHUPS: "Lotus_Mashups",
    
    /**
     * The server type value for WebSphere Portal
     * @type String
     */
    SERVER_TYPE_PORTAL: "WebSphere_Portal",
    
    /**
     * The server type value for Business Space
     */
    SERVER_TYPE_BSPACE: "Business_Space",
    
    /**
     * Anonymous mode enabled default is false
     * @type String
     */
    ANON_MODE_ENABLED: "com.ibm.mashups.anonymous.mode",
    
    /**
     * Setting to true will prevent search clients for automatically adding wildcards
     * to user and group searches.  Default is false.
     * @type String
     */
    AUTO_WILDCARD_DISABLED: "com.ibm.mashups.autoWildcardSearchDisabled",
    
    /**
     * Sets the name of the property in the ContextMenu_Provider to use for the
     * context menu
     * @type String
     */
    CONTEXT_MENU_NAME: "com.ibm.mashups.contextmenu.name",
    
    WIDGET_BUILDER_ENABLED: "com.ibm.mashups.widgetBuilder.enabled",
    
    CREATE_SPACE_TEMPLATE_MODE: "createSpaceOnTemplateMode",
    
    FAVORITE_SPACES_MAXIMUM_NUMBER: "favorite.spaces.maximum.number",
    
    RECENT_SPACES_MAXIMUM_NUMBER: "recent.spaces.maximum.number",
    /**
     * Register resources that's preloaded with enabler so enabler won't load it anymore
     * For example:
     * [{
     *    globalid: "lconn.coreUtilities",
     *    version: "2.5"
     * }, {
     *    globalid: "lconn.coreCSS",
     *    version: "2.5"
     * }]
     * @type String
     */
    REGISTER_LOADEDRESOURCES: "register.loadedresources",
    
    /**
     * Defines the persistence mode that should be used by the iContext. Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE: "com.ibm.mashups.enabler.icontext.persistence.mode",
    
    /**
     * Defines the read-only persistence mode for the event provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_EVENTS: "com.ibm.mashups.enabler.icontext.persistence.mode.events",
    /**
     * Defines the modifiable persistence mode for the event provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_EVENTS_MODIFIABLE: "com.ibm.mashups.enabler.icontext.persistence.mode.events.modifiable",
    
    /**
     * Defines the read-only persistence mode for the wire provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_WIRES: "com.ibm.mashups.enabler.icontext.persistence.mode.wires",
    /**
     * Defines the modifiable persistence mode for the wire provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_WIRES_MODIFIABLE: "com.ibm.mashups.enabler.icontext.persistence.mode.wires.modifiable",
    
    /**
     * Defines the read-only persistence mode for the attributes provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_ATTRIBUTES: "com.ibm.mashups.enabler.icontext.persistence.mode.attributes",
    /**
     * Defines the modifiable persistence mode for the attributes provider that is used by the iContext. It overwrites any mode defined as part of <tt>PERSISTENCE_MODE</tt>.Default is <tt>DOM</tt>.
     */
    PERSISTENCE_MODE_ATTRIBUTES_MODIFIABLE: "com.ibm.mashups.enabler.icontext.persistence.mode.attributes.modifiable",
    
    /**
     * Defines whether the json attributes implementation will be injecting the attributes defined in the widget xml
     * as well into the attributes map. This will only apply if the json attributes have been enabled through the PERSISTENCE_MODE_ATTRIBUTES setting.
     */
    PERSISTENCE_MODE_ATTRIBUTES_JSON_INJECTXML: "com.ibm.mashups.enabler.icontext.attributes.json.injectxml",
    
    /**
     * Defines whether autocommit is enabled on the iContext. If set to <tt>true</tt> the iContext will automatically commit data to the
     * backend if commit is called on e.g. the iWidgetAttributes.
     */
    ICONTEXT_AUTO_COMMIT: "com.ibm.mashups.enabler.icontext.autocommit",
    
    ID_PREFIX: "com.ibm.mashups.iWidget.idPrefix",
    /**
     * Defines how violations of enabler usage is prompted to the user; see
     * <ul>
     * <li><code>API_ENFORCEMENT_MODE_WARN</code></li>
     * <li><code>API_ENFORCEMENT_MODE_ERROR</code></li>
     * </ul>
     * Defaults to <code>API_ENFORCEMENT_MODE_WARN</code>.
     * @type String
     * @private
     */
    API_ENFORCEMENT_MODE: "com.ibm.mashups.enabler.enforcement",
    
    /**
     * Warnings will be prompted in the console denoting usage errors of the enabler api.
     * @type String
     * @private
     */
    API_ENFORCEMENT_MODE_WARN: "warning",
    
    /**
     * Errors will be thrown denoting usage errors of the enabler api, note that
     * this potentially breaks the driver if the api is used incorrectly.
     * @type String
     * @private
     */
    API_ENFORCEMENT_MODE_ERROR: "error",
    
    /**
     * With this option the location (a URL) of the widget which will be displayed for non previewable content can be defined.
     * If empty (thats the default) the widget delivered with the enabler will be used.
     *
     * @since 3.0
     * @type String
     */
    NON_PREVIEWABLE_WIDGET_LOCATION: "com.ibm.mashups.enabler.layout.widget.NonPreviewableContentWidget.location",
    
    /**
     * Size limit of page descriptions, implied from persistence
     * @since 3.0
     * @type String
     */
    LIMIT_PAGE_DESCRIPTION: "com.ibm.mashups.persistence.page.description.limit",
    
    /**
     * Defines whether personalize is allowed or not for users. Defaults to true.
     * @since 3.0
     * @type Boolean
     */
    WIDGET_PERSONALIZE_ENABLED: "com.ibm.mashups.widget.attributes.personalize.enabled",
    
    /**
     * Defines maximum page number when creating page base on page from hub. Defaults to 50.
     * @since 3.0
     * @type String
     */
    SPACEMANAGER_PAGE_QUERYCOUNT: "com.ibm.mashups.spacemanager.page.queryCount",
    /**
     * Defines the search keyword when pages in hub are queried. Keep it empty will return all pages.
     * @since 3.0
     * @type String
     */
    SPACEMANAGER_PAGE_QUERYKEYWORD: "com.ibm.mashups.spacemanager.page.queryKeyword",
    /**
     * Defines maximum space number when creating space base on space from hub. Defaults to 50.
     * @since 3.0
     * @type String
     */
    SPACEMANAGER_SPACE_QUERYCOUNT: "com.ibm.mashups.spacemanager.spacetemplate.queryCount",
    /**
     * Defines the search keyword when spaces in hub are queried. Keep it empty will return all spaces.
     * @since 3.0
     * @type String
     */
    SPACEMANAGER_SPACE_QUERYKEYWORD: "com.ibm.mashups.spacemanager.spacetemplate.queryKeyword",
    
    /**
     * Defines the search keyword when spaces in hub are queried. Keep it empty will return all spaces.
     * @since 2.4
     * @type String
     */
    LOCALAPPS_REGEX: "com.ibm.mashups.multipart.localapps.regex",
    
    /**
     * Defines the format (as a regular expression) of the server side object IDs.
     * @since 3.0
     * @type String
     */
    SERVER_OBJECT_ID_FORMAT: "com.ibm.mashups.server.oid.format",
    
    /**
     * Defines the format (as a regular expression) of the logout verification.
     * @since 3.0.0.2
     * @type String
     */
    LOGOUT_VERIFICATION_REGEXP: "com.ibm.mashups.logout.verification.regexp",
    
    /**
     * if multipart support is enabled, this setting, when <code>true</code> defines whether public and private cacheable
     * resources should be sent in different requests for cacheability
     * @since 3.0.0.1-CF1
     * @type String
     */
    MULTIPART_SPLIT_PUBLIC: "com.ibm.mashups.multipart.splitPublic",
    
    /**
     * if multipart support is enabled, this setting, when <code>true</code> defines whether transactions should be splitted
     * when the generated huffman URL is > maxUrlLength rather then falling back to multipart POST in order to increase
     * cachability
     * @since 3.0.0.1-CF1
     * @type String
     */
    MULTIPART_SPLIT_TRANSACTIONS: "com.ibm.mashups.multipart.splitTransactions",
    
    /**
     * Defines whether to use queued widget rendering. Default to true.
     * @since 3.0.0.1
     * @type Boolean
     */
    QUEUE_RENDERING: "com.ibm.mashups.queueRendering",
    
    /**
     * If multipart support is enabled, this setting, when <code>true</code> defines whether the backend supports modifying requests (POST, PUT, DELETE) to the resource handler (res://)<br>
     * Default: false
     * @since 3.0.0.1_CF2
     * @type Boolean
     */
    MULTIPART_USE_SINK: "com.ibm.mashups.multipart.useSinkForModRequests",
    
    /**
     * Determines whether the 'handlesink=noop' parameter is set with HTTP POST 
     * requests to create navigation nodes.
     * Default: false
     * @since 3.0.0.1_CF2
     * @type Boolean
     */
    NAVIGATION_CREATION_NOOP: "com.ibm.mashups.navigation.creation.noop"
});

com.ibm.mashups.enabler.services.ConfigConstants = new com.ibm.mashups.enabler.services.ConfigConstants();
